2020-01-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.22.
	* configure (VERSION): Update to 0.22.
	(main): Likewise.
	* build-aux/GNUmakefile.in: Likewise.
	* configure.sh (VERSION): Likewise.
	* guix/git/mes.scm (mes, mes.git): Likewise.

	build: Update release process.
	* build-aux/GNUmakefile.in: Update documentation.
	(sign-dist):  Rename from `sign'.
	* configure: Remove version check for Guix; support GUIX=guix ./configure.

	doc: Release update.
	* BOOTSTRAP: Release update.
	* HACKING: Likewise.
	* INSTALL: Likewise.
	* NEWS: Likewise.
	* PORTING: Likewise.
	* README: Likewise.
	* ROADMAP: Likewise.
	* doc/mes.texi: Likewise.
	* doc/announce/ANNOUNCE-0.22: New file.

2020-01-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Fix execlp, execvp for file names with slash.
	Reported by mid-kid.

	* lib/posix/execlp.c (execlp): Do not use search_path when file name
	contains a slash (WAS: when file name starts with slash).
	* lib/posix/execvp.c (execvp): Likewise.

2020-01-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Support bootstrapping using build.sh.
	* build-aux/build.sh.in: Oops, use $compiler = bootstrap concept does
	not exist yet.  Gash cp does not support -p; drop it.
	* configure.sh: Oops, set bootstrap to `true' instead of yes.

	mescc: Mes C Library: lseek: Be careful clearing read buffer.
	* lib/linux/lseek.c (_lseek): New function.
	* lib/linux/lseek.c (lseek): Use it to check if we should reset read
	buffer.
	* lib/mes/__buffered_read.c (__read_buffer_max): New variable.
	(__buffered_read_init): Add environment override: MES_READ_BUFFER.
	(__buffered_read): Use it.

	build: Have configure respect GUILE_LOAD_PATH for mes to find Nyacc.
	* configure: Substitute GUILE_LOAD_PATH from %load-path.
	* configure.sh: Likewise.
	* build-aux/config.make.in: Add GUILE_LOAD_PATH as subtitution variable.
	* build-aux/config.sh.in: Likewise.
	* mes/module/mes/guile.mes (%load-path): New variable.

2020-01-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Have configure prefer $CC over gcc; tcc over gcc, gcc over cc.
	Reported by Vagrant Cascadian.

	* configure (string->version): Prefer for most-dotted string.  Fixes
	makeinfo version.
	(check-program-version): Prefer displaying of command, if single word.
	(main): Check for $CC --version, $CC -v.  Prefer $CC over gcc; tcc over
	gcc, gcc over cc.

2020-01-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Opt for reproducible builds with Guile and Mes.
	* module/mescc/compile.scm (mes-or-reproducible?): New variable.
	(ast->comment): Use it.
	* module/mescc/preprocess.scm (mes-or-reproducible?): New variable.
	(c99-input->full-ast): Use it.

2020-01-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Resurrect compiling with TinyCC.
	   ./configure CC=tcc --host=i686-unknown-linux-gnu --with-courage

	* configure: Cater for tcc.

2019-12-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Cater for FreeBSD.
	* build-aux/bootstrap.sh.in: Add test ! -e -o to satisfy FreeBSD test.
	Fixes skipping over all compilations.
	* build-aux/cc.sh (compile): Likewise.

	freebsd: Initial x86 scaffold.
	* lib/freebsd/x86-mes-gcc/crt1.c: New file.
	* lib/freebsd/x86-mes-gcc/exit-42.S: New file.
	* lib/freebsd/x86-mes-gcc/hello-mes.S: New file.
	* lib/freebsd/x86-mes-gcc/mini.c: New file.
	* lib/freebsd/x86-mes-mescc/crt1.c: New file.
	* lib/freebsd/x86-mes-mescc/mini.c: New file.
	* lib/freebsd/x86-mes/elf32-0exit-42.hex2: New file.
	* lib/freebsd/x86-mes/elf32-0header.hex2: New file.
	* lib/freebsd/x86-mes/elf32-0hello-mes.hex2: New file.
	* lib/freebsd/x86-mes/elf32-body-exit-42.hex2: New file.
	* lib/freebsd/x86-mes/elf32-body-hello-mes.hex2: New file.
	* lib/freebsd/x86-mes/elf32-footer-single-main.hex2: New file.
	* lib/freebsd/x86-mes/elf32-header.hex2: New file.

	freebsd: Initial configure support.
	* configure: Initial FreeBSD configure support.
	* configure.sh: Likewise.  Run without bash.

	build: Prepare for kernel variants.
	* configure: Fix detection of Arch, FreeBSD.
	* lib/linux/x86-mes-gcc/exit-42.S: Move from ...
	* lib/x86-mes-gcc/exit-42.S: ... here.
	* lib/linux/x86-mes-gcc/hello-mes.S: Move from ...
	* lib/x86-mes-gcc/hello-mes.S: ... here.
	* lib/linux/x86-mes-mescc/exit-42.S: Move from ...
	* lib/x86-mes-mescc/exit-42.S: ... here.
	* lib/linux/x86-mes-mescc/hello-mes.S: Move from ...
	* lib/x86-mes-mescc/hello-mes.S: ... here.
	* lib/linux/x86-mes/elf32-0exit-42.hex2: Move from ...
	* lib/x86-mes/elf32-0exit-42.hex2: ... here.
	* lib/linux/x86-mes/elf32-0header.hex2: Move from ...
	* lib/x86-mes/elf32-0header.hex2: ... here.
	* lib/linux/x86-mes/elf32-0hello-mes.hex2: Move from ...
	* lib/x86-mes/elf32-0hello-mes.hex2: ... here.
	* lib/linux/x86-mes/elf32-body-exit-42.hex2: Move from ...
	* lib/x86-mes/elf32-body-exit-42.hex2: ... here.
	* lib/linux/x86-mes/elf32-body-hello-mes.hex2: Move from ...
	* lib/x86-mes/elf32-body-hello-mes.hex2: ... here.
	* lib/linux/x86-mes/elf32-footer-single-main.hex2: Move from ...
	* lib/x86-mes/elf32-footer-single-main.hex2: ... here.
	* lib/linux/x86-mes/elf32-header.hex2: Move from ...
	* lib/x86-mes/elf32-header.hex2: ... here.
	* lib/linux/x86_64-mes-gcc/exit-42.S: Move from ...
	* lib/x86_64-mes-gcc/exit-42.S: ... here.
	* lib/linux/x86_64-mes-gcc/hello-mes.S: Move from ...
	* lib/x86_64-mes-gcc/hello-mes.S: ... here.
	* lib/linux/x86_64-mes-mescc/exit-42.S: Move from ...
	* lib/x86_64-mes-mescc/exit-42.S: ... here.
	* lib/linux/x86_64-mes-mescc/hello-mes.S: Move from ...
	* lib/x86_64-mes-mescc/hello-mes.S: ... here.
	* lib/linux/x86_64-mes/elf64-0exit-42.hex2: Move from ...
	* lib/x86_64-mes/elf64-0exit-42.hex2: ... here.
	* lib/linux/x86_64-mes/elf64-0header.hex2: Move from ...
	* lib/x86_64-mes/elf64-0header.hex2: ... here.
	* lib/linux/x86_64-mes/elf64-0hello-mes.hex2: Move from ...
	* lib/x86_64-mes/elf64-0hello-mes.hex2: ... here.
	* lib/linux/x86_64-mes/elf64-body-exit-42.hex2: Move from ...
	* lib/x86_64-mes/elf64-body-exit-42.hex2: ... here.
	* lib/linux/x86_64-mes/elf64-body-hello-mes.hex2: Move from ...
	* lib/x86_64-mes/elf64-body-hello-mes.hex2: ... here.
	* lib/linux/x86_64-mes/elf64-footer-single-main.hex2: Move from ...
	* lib/x86_64-mes/elf64-footer-single-main.hex2: ... here.
	* lib/linux/x86_64-mes/elf64-header.hex2: Move from ...
	* lib/x86_64-mes/elf64-header.hex2: ... here.
	* module/mescc.scm (parse-opts): Support --kernel.
	* module/mescc/mescc.scm (kernel-find): New function.
	* module/mescc/mescc.scm (hex2->elf): Use it to find kernel-specific ELF
	snippets.
	* build-aux/install.sh.in: Install it.

2019-12-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Add ioctl3 stub.

	mescc: Mes C Library: Fix access stub.
	* lib/stub/access.c (access): Use _open3 to give more meaningful
	behaviour.  Fixes hanging of mes.

	hurd: Fixes for upgrade to debian-hurd-20190220.img.
	* include/mach/mach-init.h (__mach_host_self, __mach_task_self):
	Remove macro magic.
	(mach_host_self, mach_task_self): Remove macro magic; declare as function.
	* lib/mach/mach-init.c (mach_host_self, mach_task_self): New function.
	(mach_init): Use them.
	* lib/gnu/hurd-start.c (_hurd_start): Use mach_task_self ().
	* lib/gnu/_exit.c (_exit): Likewise.

	hurd: Add malloc.
	* include/gnu/syscall.h (__vm_allocate): New value.
	(__vm_allocate): Declare.
	* lib/gnu/malloc.c: New file.
	* lib/stdlib/malloc.c[__GNU__]: Disable.  See FIXME.
	* lib/gnu/vm-allocate.c: New file.
	* build-aux/configure-lib.sh (libc_SOURCES): Add it.

	hurd: Add open.
	* include/fcntl.h (O_RDONLY, O_WRONLY, O_RDWR, O_CREAT, O_APPEND,
	O_TRUNC)[__GNU__]: Specialize for GNU.
	* lib/gnu/dir-lookup.c: New file.
	* lib/stdio/fopen.c (fopen): Use O_RDONLY.
	* lib/tests/posix/50-open-read.c (main): Likewise.
	* lib/tests/stdio/90-fseek.c (main): Likewise.
	* include/gnu/syscall.h (SYS__dir_lookup): New value.
	* lib/gnu/_open3.c: New file.
	* build-aux/configure-lib.sh (libc_SOURCES): Build them.

	hurd: Add argv and environ.
	* include/gnu/hurd.h (struct hurd_startup_data): Add argp, envp.
	* lib/gnu/hurd-start.c (__argv, __env): Define them.
	* lib/gnu/exec-startup-get-data.c (mach_startup_info2hurd_startup_data):
	Set them.
	* lib/gnu/x86-mes-gcc/crt1.c (_start): Use them.
	* build-aux/configure-lib.sh (libc_mini_SOURCES): Add argz-extract.c.
	* include/argz.h: Build fix.
	* lib/string/argz-count.c: Likewise.
	* lib/string/argz-extract.c: Likewise.

	hurd: Add stubs for missing libc+tcc functions.
	* lib/stub/close.c: New file.
	* lib/stub/rmdir.c: New file.
	* lib/stub/stat.c: New file.
	* build-aux/configure-lib.sh (libc_tcc_SOURCES)[gnu]: Add them.

	hurd: Add stubs for missing libc functions.
	* lib/stub/_getcwd.c: New file.
	* lib/stub/_getcwd.c: New file.
	* lib/stub/_open3.c: New file.
	* lib/stub/access.c: New file.
	* lib/stub/brk.c: New file.
	* lib/stub/chmod.c: New file.
	* lib/stub/clock_gettime.c: New file.
	* lib/stub/dup.c: New file.
	* lib/stub/dup2.c: New file.
	* lib/stub/execve.c: New file.
	* lib/stub/fork.c: New file.
	* lib/stub/gettimeofday.c: New file.
	* lib/stub/ioctl.c: New file.
	* lib/stub/time.c: New file.
	* lib/stub/unlink.c: New file.
	* lib/stub/waitpid.c: New file.
	* build-aux/configure-lib.sh (libc_SOURCES)[gnu]: Add them.

	hurd: Add stubs for missing libmes functions.
	* lib/stub/lseek.c: New file.
	* build-aux/configure-lib.sh (libmes_SOURCES)[gnu]: Add it.

	hurd: Add _read.
	* include/gnu/hurd.h (fd_read): Declare.
	* include/gnu/syscall.h (SYS__io_read): New value.
	* lib/gnu/_read.c: New file.
	* lib/gnu/fd-read.c: New file.
	* lib/gnu/io-read.c: New file.
	* build-aux/configure-lib.sh (libc_SOURCES): Add _read sources.

	hurd: Add _write.
	* include/gnu/syscall.h (SYS__io_write): Add enum field.
	(_hurd_dtable, _hurd_dtable_size): Declare variable.
	(fd_get, fd_write, __io_write, __syscall_put): Declare.
	* lib/gnu/hurd-start.c (_hurd_dtable, _hurd_dtable_size): Define
	variable.
	* lib/gnu/_write.c: New file.
	* lib/gnu/fd-get.c (fd_get): New file.
	* lib/gnu/fd-write.c (fd_write): New file.
	* lib/gnu/io-write.c: New file.
	* lib/gnu/syscall.c (__syscall_put): New function.
	* build-aux/cofnigure-lib.sh (libc_mini_SOURCES): Add write sources.
	* lib/tests/mes/30-oputs.c (main): Update.
	* lib/tests/mes/30-oputs.stdout: New file.
	* lib/tests/mes/30-eputs.c: New test.
	* lib/tests/mes/30-eputs.stderr: New file.
	* build-aux/check-mescc.sh (TESTS): Add it.

2019-12-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	hurd: Initial support.
	This adds minimal Hurd support by implementing the _exit function.

	* AUTHORS: Update.
	* .gitignore: Ignore a.out, core, .config.
	* include/sys/wait.h (W_EXITCODE): New define.
	* lib/gnu/x86-mes-gcc/crt1.c: New file.
	* lib/gnu/x86-mes-gcc/mini.c: New file.
	* lib/gnu/hurd-start.c: New file.
	* lib/gnu/_exit.c: New file.
	* include/gnu/syscall.h: New file.
	* include/gnu/hurd.h: New file.
	* lib/gnu/_exit.c: New file.
	* lib/gnu/exec-startup-get-data.c: New file.
	* lib/gnu/hurd-start.c: New file.
	* lib/gnu/proc-mark-exit.c: New file.
	* lib/gnu/syscall.c: New file.
	* lib/gnu/task-get-special-port.c: New file.
	* lib/gnu/task-terminate.c: New file.
	* lib/gnu/vm-statistics.c: New file.
	* build-aux/configure-lib.sh (libc_mini_SOURCES): Add Hurd sources.
	* build-aux/build.sh.in (CPPFLAGS): Add lib to includes, to find linux
	crt1.c.
	* build-aux/test-c.sh: Always use at least -l c+mini for GNU.
	* lib/tests/scaffold/30-exit-42.exit: New file.
	* lib/tests/scaffold/30-exit-42.c: New test.
	* build-aux/check-mescc.sh (TESTS): Add it.
	* lib/tests/scaffold/30-exit-0.c (main): Move from 00-exit-0.c; Rewrite,
	use _exit.
	* include/gnu/hurd-types.h: Import from GNU C Library.
	* include/mach/mach-init.h: Likewise.
	* lib/mach/mach-init.c: Likewise.
	* lib/mach/mach_host_self.S: Likewise.
	* lib/mach/mach_msg_trap.S: Likewise.
	* lib/mach/mach_reply_port.S: Likewise.
	* lib/mach/mach_task_self.S: Likewise.
	* lib/mach/mach_thread_self.S: Likewise.
	* lib/mach/msg.c: Likewise.

2019-12-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Generate ChangeLog reproducibly.  Thanks, Timothy!
	* build-aux/gitlog-to-changelog (git_dir_option): Avoid non-reproducible
	localtime.

	build: Make guild optional for bootstrap builds.
	* configure: Use `true' for guild when it is not available.

	build: Clean-out .gitignore.
	.gitignore: Remove obsolete cross build patterns.

	build: Cater for bootstrap build.
	* build-aux/build.sh.in: Build bin/mes.  Update scripts and users.
	* build-aux/bootstrap.sh.in: Update.
	* build-aux/install.sh.in: Install all built bin/mes-* flavours.
	* configure: Drop SEED, support --bootstrap.
	* configure.sh: Likewise.

2019-12-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Oops, have configure honor --host.
	This allows

	    ./configure --host=i686-unknown-linux-gnu

	instead of

	    CC=i686-unknown-linux-gnu-gcc ./configure

	* configure (main): Honor --host.

2019-12-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	bootstrap: Default to mesar for mescc build.
	* configure.sh: Default to mesar for mescc build.

	bootstrap: Fix configure.sh's host detection.
	* configure.sh: Avoid setting host="" and not running $CC.

	mescc: Add mes 0.19 compatibility.
	* mes/module/mes/boot-0.scm (%datadir): Cater for %datadir not being
	set.

2019-12-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	bootstrap: Build files only once.
	* build-aux/bootstrap.sh.in: Build files only once.

	build: Support mescc-tools 0.5.2.
	* configure: Remove version check for mescc-tools.
	Check for stage0 architecture flag type.
	* configure.sh: Likewise.
	* build-aux/build-scaffold.sh: Add stage0 flag type indirection.
	* module/mescc/mescc.scm (arch-get-architecture): Likewise.

2019-12-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Fix for compiling handwritten .S assembly.
	* module/mescc/mescc.scm (mescc:compile): Handle .S.
	(mescc:link): Likewise.

	build: Add mescc scaffold for regular build.
	* lib/x86-mes-mescc/exit-42.S: New file.
	* lib/x86-mes-mescc/hello-mes.S: New file.
	* lib/x86_64-mes-mescc/exit-42.S: New file.
	* lib/x86_64-mes-mescc/hello-mes.S: New file.

2019-12-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Add --with-bootstrap option.
	* configure (main): Add --with-bootstrap option.
	* build-aux/build.sh.in [--with-bootstrap]: After building mes with CC,
	build mes with MesCC.

2019-12-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Support toplevel lib and mes builds.
	* build-aux/build.sh.in: Add missing libdir for gcc build.
	* build-aux/config.sh.in: ...here.
	* build-aux/build-mes.sh: Do not overwrite srcdest, V.

	bootstrap: Support srcdir builds.
	* build-aux/bootstrap.sh.in (srcdest): Initialize.
	* build-aux/build-lib.sh: Source config.sh.
	* configure.sh: Support srcdir builds.
	* build-aux/build.sh.in: Move setting of cflags to ...
	* build-aux/cflags.sh: ... New file.

	configure: Honor CFLAGS, LDFLAGS.
	* configure (cflags-list, ldflags-list): New function.
	check-preprocess-header-c, check-compile-string-c,
	check-link-string-c): Use them.  Be verbose when %verbose?.
	(CFLAGS, LDFLAGS): Initialize to "-static -g".

2019-12-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	build! Fixup clean without git: Clean cleaner.
	* build-aux/GNUmakefile.in (clean): Clean cleaner.

2019-12-07  Vagrant Cascadian  <vagrant@debian.org>

	Fix build without git on "wip" branch.
	--=-=-=
	Content-Type: text/plain

	In the "wip" branch, the attempt to build without git was a bit overly
	aggressive in the purging of GIT.

	live well,
	  vagrant

	From 73bb68e86318a6bc0fe191db663be97f94556956 Mon Sep 17 00:00:00 2001
	From: Vagrant Cascadian <vagrant@debian.org>
	Date: Sat, 7 Dec 2019 19:59:00 +0100
	Subject: [PATCH] Fix build without git

	Commit "1863c0d843a5fe4e94e8cb923cc0896f30fceeeb" removed the
	substitution of @GIT@ when, resulting in the GIT variable being set to
	"@GIT@" rather than "" when git is not installed.

2019-12-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Fix configure host detection for Arch.  Thanks, Jelle!
	* configure (main): Grok `CPU-pc-linux-gnu'.

	build: Successfully check for Nyacc 0.99.0.
	* configure (gulp-pipe): New function.
	(check-program-version): Use it to correctly detect Nyacc.
	(gulp-pipe*): Rewrite to use it.

	build: Remove git dependency.
	* configure: Remove git dependency.
	* build-aux/GNUmakefile.in (clean,distclean, maintainer-clean):
	Implement without git.
	* INSTALL: Update dependencies.

2019-12-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Remove MES_PKGDATADIR.
	* configure: Do not add MES_PKGDATADIR to config.h.
	* configure.sh: Likewise.
	* simple.sh: Likewise.
	* src/mes.c (open_boot): Do not use MES_PKGDATADIR; rely on
	MES_PREFIX or cwd.

2019-12-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Ignore -fno-stack-protector.
	* module/mescc.scm (parse-opts): Ignore it.

	build: Use debug build (-g) by default.
	* build-aux/build.sh.in (debug): Enable.

	build: Honor user's CFLAGS, CPPFLAGS, LDFLAGS.
	* build-aux/build.sh.in (AM_CFLAGS, AM_CPPFLAGS, AM_LDFLAGS): Rename
	from CFLAGS, CPPFLAGS, LDFLAGS.  Export them.
	* configure: Substitute them.
	* configure.sh: Likewise.
	* build-aux/cc.sh (compile, link): Use them.
	* build-aux/config.make.in (CFLAGS, CPPFLAGS, LDFLAGS): Add
	substitutable variables.
	* build-aux/config.sh.in: Likewise.
	* build-aux/export.make: Export them.

	test: 90-abtod: Remove printf dependency.  Fixes gcc.
	* lib/tests/mes/90-abtod.stdout: Remove.
	* lib/tests/mes/90-abtod.c (main): Remove printf.

2019-12-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: 90-readdir: Remove qsort dependency.  Fixes tmpfs failures.
	* lib/tests/dirent/90-readdir.c (check_seen): New function.
	(main): Use it instead of qsort.
	(qsort_strcmp): Remove.

2019-11-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Throw instead of segfault on non-existing input file.
	Reported by theruran.

	* src/posix.c (open_input_file): Call error instead of failing silently.

2019-06-11  Vagrant Cascadian  <vagrant@debian.org>

	boot-0: Fix spelling of "evaluate"

2019-11-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Honor --includedir, --libdir.
	* guix/git/mes.scm (mes):
	* module/mescc.scm (%includedir, %libdir): New variable.
	(mescc:main): Add them to options.
	* module/mescc/mescc.scm (mescc:preprocess, c->info): Add %includedir.
	(arch-find): Use %libdir instead of
	prefix-file.
	(prefix-file): Remove.
	* scripts/mescc.scm.in (%includedir, %libdir): Initialize from and set
	in environment.

	xx

	* module/mescc/mescc.scm :

2019-11-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Post-release update.
	* NEWS: Typo.
	* doc/announce/ANNOUNCE-0.21: Add checksums.

2019-11-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.21.
	* configure (VERSION): Update to 0.21.
	(main): Likewise.
	* build-aux/GNUmakefile.in: Likewise.
	* configure.sh (VERSION): Likewise.
	* guix/git/mes.scm (mes, mes.git): Likewise.

2019-11-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release update.
	* BLURB: Release update.
	* HACKING: Remove roadmap.
	* INSTALL: Release update.
	* NEWS: Add 0.21 section.
	* README: Release update.
	* ROADMAP: New file.
	* configure.sh: Release update.
	* doc/announce/ANNOUNCE-0.21: New file.
	* doc/mes.texi: Release update.

2019-11-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: vfprintf: Support --with-system-libc.
	* include/stdarg.h (va_arg8)[SYSTEM_LIBC]: Define.

	mescc: Mes C Library: Support gcc-4.6.4: Fix ctime stub.
	* lib/stub/ctime.c (ctime): Fix stub to avoid segfault upon use.

	mescc: Mes C Library: Fix isatty for x86_64.
	* lib/linux/ioctl.c (ioctl3): New function.
	* include/sys/ioctl.h: Declare it.
	* lib/posix/isatty.c (__tcgetattr): Use it.

2019-11-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Prefer /bin/bash if available. Thanks, Vagrant!
	Ensure the configure script uses /bin/bash, otherwise on systems with
	/bin -> /usr/bin it results in /bin/bash being embedded in various
	scripts.

	Inspired by

	    https://salsa.debian.org/debian/mes/blob/debian/master/debian/patches/force-use-of-bin-bash

	* configure: Prefer /bin/bash, /bin/sh if available.  Helps
	reproducibility on Debian.

2019-11-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Update script help and usage.
	* doc/mes.texi (Invoking mesar): New section.
	* mes/module/mes/boot-0.scm: Add one line help description.
	* module/mescc.scm (parse-opts): Likewise.
	* scripts/diff.scm (main): Add -h,--help, -v,--version.
	* scripts/mesar.in: Likewise.

	build: Use unversioned doc directory. Thanks, Vagrant!
	* configure (docdir): Drop version.  Fixes Debian lint error.
	* configure.sh (docdir): Likewise.

	build: Add sensible NAME section for man pages. Thanks, Vagrant!
	* build-aux/GNUmakefile.in (mes.1, mescc.1, mesar.1): Add sensible
	--name section.  Fixes Debian lint error.  Reported by Vagrant
	Cascadian.

2019-11-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "build: Mark lib/tests/dirent/90-readdir.c as XFAIL on x86_64-gcc."
	This reverts commit dc0b41f83efa973b7a92c0c7a0ad1eb21a7c4c7a.

2019-10-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Mark lib/tests/dirent/90-readdir.c as XFAIL on x86_64-gcc.
	* build-aux/check-mescc.sh (XFAIL_TESTS)[x86_64-gcc]: Add
	lib/tests/dirent/90-readdir.c.

2019-11-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "build: Mark lib/tests/dirent/90-readdir.c as XFAIL on x86_64-mescc."
	This reverts commit 17986224095ed72649fb2383f72c21f525977310.

2019-10-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Mark lib/tests/dirent/90-readdir.c as XFAIL on x86_64-mescc.
	* build-aux/check-mescc.sh (XFAIL_TESTS)[x86_64-mescc]: Add
	lib/tests/dirent/90-readdir.c.

2019-10-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Better and friendlier tarball.
	* build-aux/GNUmakefile.in (dist): Be friendly to Debian; avoid using
	EPOCH.  Cater for file permission differences.

2019-10-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: bootstrap fixes.
	* build-aux/config.sh.in (bootstrap): Set up for substitution.
	* configure.sh (bootstrap): Substitute.
	* build-aux/install.sh.in (_v): Robustify check for V.
	(__exclude_go, __exclude_scm): Initialize.

2019-10-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Fix -c, --command.
	* mes/module/mes/boot-0.scm: Prepend 'begin to expr list.

2019-10-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	check: Remove duplicate test.
	* build-aux/check-boot.sh (TESTS): Remove duplicate test.

2019-09-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support gcc-4.6.4: vfprintf, vsnprintf: pad with space.
	* lib/stdio/vfprintf.c (vfprintf): pad with space.
	* lib/stdio/vsnprintf.c (vsnprintf): pad with space.

2019-09-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support gcc-4.6.4: Add math stubs.
	* lib/math/ceil.c: New file.
	* lib/math/floor.c: New file.
	* lib/stub/atan2.c: New file.
	* lib/stub/cos.c: New file.
	* lib/stub/exp.c: New file.
	* lib/stub/log.c: New file.
	* lib/stub/modf.c: New file.
	* lib/stub/pow.c: New file.
	* lib/stub/sin.c: New file.
	* lib/stub/sqrt.c: New file.
	* lib/libc+gnu.c: Include them.
	* include/math.h (atan2, ceil, cos, exp, fabs, floor, log, modf, pow,
	sin, sqrt): Declare.
	* lib/math/fabs.c: Update.
	* lib/stub/ldexp.c: Update.

2019-09-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support gcc-4.6.4: Add fscanf, vfscanf.
	* lib/stdio/vfscanf.c: New file.
	* lib/stdio/fscanf.c: New file.
	* build-aux/configure-lib.sh (libc_gnu_SOURCES): Add them.
	* include/stdio.h (fscanf): Declare.
	* include/stdarg.h (vfscanf): Declare.
	* lib/stub/fscanf.c: Remove.

2019-09-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Libray: Fix off_t.
	* include/sys/types.h (off_t): Drop unsigned.

2019-09-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Environment setup.
	* scripts/mescc.in (MES_ARENA, MES_MAX_ARENA, MES_STACK): Reduce defaults.
	* build-aux/check.sh.in (MES_ARENA): Likewise.  Export them.
	* build-aux/bootstrap.sh.in (MES_STACK): Likewise.
	(MES_PREFIX): Set default.

2019-08-26  Danny Milosavljevic  <dannym@scratchpost.org>

	Add missing #include.
	* lib/stdlib/mbstowcs.c: Add missing #include.

	Fix dtoab.
	* lib/mes/dtoab.c (dtoab): Fix it.
	* lib/tests/mes/90-dtoab.c (main): Fix test.
	* build-aux/check-mescc.sh (XFAIL_TESTS: Remove it.

2019-08-27  Danny Milosavljevic  <dannym@scratchpost.org>

	va_align: Fix compiler warning.
	Follow-up to 49b0cd7d2e6952044d7436260d6ba950e40ee05f.

	* include/stdarg.h: Fix compiler warning.

2019-08-27  Danny Milosavljevic  <dannym@scratchpost.org>

	Add missing #include.
	* lib/tests/mes/90-abtod.c (main): Add missing #include.

	Fix variable argument list traversal for doubles.
	* include/stdarg.h (va_align): New macro.
	(va_arg8): New macro.
	* lib/stdio/vfprintf.c (vfprintf): Use it.
	* lib/stdio/vsnprintf.c (vsnprintf): Use it.

2019-08-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Improve --with-system-libc support.
	* build-aux/build-lib.sh: Avoid building libc for --with-system-libc.
	Make libmes richer.
	build-aux/check-mescc.sh: Enable 50-malloc test.
	* include/dirstream.h: Use HAVE_DIRSTREAM_H to cater for non-existing
	dirstream.h.
	* include/grp.h[SYSTEM_LIBC]: Typo.
	* include/mes/lib.h (__brk, __call_at_exit)[SYSTEM_LIBC]: Declare.
	* include/stdlib.h (comparison_fn_t)[SYSTEM_LIBC]: Declare.
	* include/time.h (mktime): Return time_t.
	* lib/posix/isatty.c [SYSTEM_LIBC]: Do not (re)declare termios.
	* lib/stub/mktime.c (mktime): Return time_t.
	* lib/tests/scaffold/41-ternary.c (main): Remove assumption that
	locals are initialized.
	* lib/tests/scaffold/70-stdarg.c: Cater for SYSTEM_LIBC.
	* lib/tests/setjmp/80-setjmp.c: Declare jmp buf.
	* lib/*/*.c: Add missing mes/lib.h, errno.h includes.

2019-09-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: vfprintf, vsnprintf: Pad floats with space.
	* lib/stdio/vfprintf.c (vfprintf): Pad floats with space.
	* lib/stdio/vsnprintf.c (vsnprintf): Pad floats with space.
	* lib/tests/stdio/90-sprintf.c: Test it.

2019-08-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: vsscanf: Increase count for scanned float.
	* lib/stdio/vsscanf.c (vsscanf): Increase count for scanned float.

2019-07-31  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Tar: Fix getpwnam, getpwuid stubs.
	* lib/stub/getpwnam.c (getpwnam): Return pointer to static struct
	passwd.
	* lib/stub/getpwuid.c (getpwuid): Likewise.

2019-07-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Tar: Add getgrgid, getgrnam, setgrent stub.
	* include/grp.h: New file.
	* lib/stub/getgrgid.c: New file.
	* lib/stub/getgrnam.c: New file.
	* lib/stub/setgrent.c: New file.
	* lib/libc+gnu.c: Include them.

2019-07-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Awk: Add wchar_t.
	* include/sys/types.h (wchar_t): New typedef.

2019-07-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Awk: Add getpgid, getpgrp stubs.
	* include/unistd.h (getpgid, getpgrp): Declare.
	* lib/stub/getpgid.c: New file.
	* lib/stub/getpgrp.c: New file.
	* lib/libc+gnu.c: Include them.

2019-07-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Tar: Add mktime stub, fix localtime stub.
	* include/time.h (mktime): Declare.
	* lib/stub/mktime.c: New stub.
	* lib/libc+gnu.c: Include it.
	* lib/stub/localtime.c (localtime): Return pointer to static struct
	tm.  Avoids segfaults.

2019-07-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Tar: Add creat, mknod.
	* include/linux/x86_64/syscall.h (SYS_mknod): New macro.
	* include/linux/x86/syscall.h (SYS_mknod): New macro.
	* lib/linux/mknod.c: New file.
	* build-aux/configure-lib.sh (libc_gnu_SOURCES): Add it.
	* include/sys/stat.h (mknod): Declare it.
	* include/fcntl.h (creat): New macro.

2019-07-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Tar: Add missing defines.
	* include/errno.h (ENXIO): New macro.
	* include/sys/stat.h (S_IFIFO, S_ISFIFO): New macro.

2019-07-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Bash: Add struct winsize.
	* include/termio.h (struct winsize): New type.

2019-07-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Awk: Implement atof.
	* lib/stdlib/atoi.c: Update.
	* lib/stdlib/atof.c: Rename from stub/atof.c; Implement.
	* lib/libc+gnu.c: Update include.
	* lib/libg.c: Update include.

2020-01-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Awk: Add dtoab, %f in vfprintf, vsnprintf.
	* include/libmes.h (dtoab): Declare.
	* lib/mes/ntoab.c (ntoab): Update.
	* lib/mes/dtoab.c: New file.
	* build-aux/configure-lib.sh (libmes_SOURCES, libc_tcc_SOURCES): Add
	it.
	* lib/tests/mes/90-dtoab.c: Test it.
	* lib/tests/stdio/90-sprintf.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it, against...
	* lib/tests/mes/90-dtoab.stdout: ...baseline.
	* lib/stdio/vfprintf.c (vfprintf): Support %f, even more naive support
	for %e, %E, %g, %G.
	* lib/stdio/vsnprintf.c (vsnprintf): Likewise.

2019-06-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Awk: Add abtod, implementing strtod.
	* include/libmes.h (abtod): Declare.
	* lib/mes/abtod.c: New file.
	* build-aux/configure-lib.sh (libmes_SOURCES, libc_tcc_SOURCES): Add
	it.
	* lib/mes/abtol.c: Update.
	* lib/stdlib/strtod.c: Use it to implement; move from stub/strtod.
	* lib/tests/mes/90-abtod.c: Test it.
	* lib/tests/mes/90-abtod.stdout: Baseline.
	* build-aux/check-mescc.sh (tests): Run it.

2019-06-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Awk: vsscanf: Support %f.
	* lib/stdio/vsscanf.c (vsscanf): Support %f.

2019-06-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Awk: Do not flush std files.
	* lib/stdio/fflush.c (fflush): Do not flush std files.

2019-06-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Awk: Add isgraph.
	* lib/ctype/isgraph.c: New file.
	* lib/libc+gnu.c: Include it.
	* include/ctype.h: Add missing prototypes.

2019-06-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Tar: Add readlink, symlink.
	* lib/linux/gnu.c (readlink, symlink): New function.
	* include/unistd.h (readlink, symlink): Declare.
	* include/linux/x86/syscall.h (SYS_readlink, SYS_symlink): New macro.
	* include/linux/x86_64/syscall.h (SYS_symlink, SYS_readlink): New
	macro.

2019-06-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support GNU Tar: Add execlp.
	* lib/posix/execl.c (vexec): New function.
	(execl): Use it.
	* lib/posix/execlp.c: New file.
	* build-aux/configure-lib.sh (libc_tcc_SOURCES): Add it.
	* lib/libc+gnu.c: Include it.
	* include/unistd.h (execlp): Declare.
	* lib/tests/posix/90-execlp.c: New file.
	* lib/tests/posix/90-execlp.stdout: New file.
	* build-aux/check-mescc.sh: Test it.

2019-06-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Fix compile warnings.
	* include/stdlib.h (abort): Add prototype.

2019-11-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Add missing stubs.
	* build-aux/configure-lib.sh (libc_gnu_SOURCES): Add fscanf, rewind stubs.
	* lib/stdio/freeopen.c: Remove.

2019-09-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Avoid tar --exclude=.
	* build-aux/install.sh.in: Only use `tar --exclude=' if we also have .go
	files compiled by Guile.

2019-09-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: mesar: Remove bashisms.
	* scripts/mesar.in: Remove bashisms.

2019-10-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	configure.sh: Cleanup argument parsing. Thanks, Timothy!
	* configure.sh: Cleanup argument parsing.

2019-09-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	configure.sh: Remove bashisms.
	* configure.sh: Remove bashisms.  Fixes running with Gash 0.1.

2019-09-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "nyacc: 0.86.0 compatibility stub. WIP"
	This reverts commit 0183cc1c42437fda27196e27b490285a61d47f59.

	While it works to run Nyacc 0.86.0, it breaks running Nyacc 0.93 and
	up.  This would need more thought and work, adding a nyacc-compat
	directory or so.  Seems not worth the effort right now.

2019-09-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	nyacc: 0.86.0 compatibility stub. WIP
	* mes/module/nyacc/lang/c99/util.scm: 0.86.0 compatibility stub.

2019-09-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Split-out build-source-lib.sh from build-lib.sh.
	* build-aux/build-lib.sh: Remove building of source lib.
	* build-aux/build-source-lib.sh: New file.
	* build-aux/build.sh.in: Invoke it.
	* build-aux/bootstrap.sh.in: Likewise.

2019-11-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Honor configure's --includedir. Thanks, Vagrant!
	Suggested by Vagrant Cascadian

	    https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=902174#84

	* build-aux/install.sh.in: Install headers in $includedir.
	* configure (includedir): Typo.
	* configure.sh (includedir): Likewise.

2019-11-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Create ascii signature.
	* build-aux/GNUmakefile.in (sign): Create ascii signature.

2019-09-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Post-release update.
	* doc/announce/ANNOUNCE-0.20: Update.
	* guix/git/mes.scm (mes): Update.

	Release 0.20.
	* configure (VERSION): Update to 0.20.
	(main): Likewise.
	* configure.sh (VERSION): Likewise.
	* guix/git/mes.scm (mes, mes.git): Likewise.

	doc: Release update.
	* BLURB: New file.
	* AUTHORS: Update.
	* HACKING: Update.
	* INSTALL: Update.
	* NEWS: Update.
	* README: Update.
	* doc/images/gcc-mesboot-graph.dot: Update.
	* doc/mes.texi: Update.
	* simple.sh: Update.
	* doc/announce/ANNOUNCE-0.20: New file.

	guix: Update mescc-tools to 0.6.1.
	* guix/git/mes.scm (mescc-tools): Update to 0.6.1.
	* configure: Check for mescc-tools versions 0.6 or higher.

	build: Create ascii signature.
	* build-aux/GNUmakefile.in (sign): Create ascii signature.

	guix: Update Nyacc to 0.99.
	* guix/git/mes.scm (nyacc): Update to 0.99.

	doc: Add PORTING.
	* PORTING: New file.

	doc: Typos. Thanks, dddddd.
	* doc/announce/ANNOUNCE-0.11: Typo.
	* doc/announce/ANNOUNCE-0.12: Typo.
	* doc/announce/ANNOUNCE-0.13: Typo.
	* doc/announce/ANNOUNCE-0.14: Typo.

	mescc: Remove dead code. Thanks Mark Weaver.
	* module/mescc/compile.scm (field-size): Remove dead function.

	guix: Update packaging.
	* build-aux/manifest.scm (string-append):
	* guix/git/mes.scm (nyacc, git-file?): Remove.
	(mescc-tools): Bump to 0.6.0.
	(%source-dir): New variable.
	(mes.git): Ues it.
	* guix.scm: Rename from .guix.scm.

	build: Do not generate ChangeLog from tarball.
	* configure (main): Set .git-for-build.
	* build-aux/install.sh.in (DESTDIR): Use it as canary to skip
	ChangeLog rebuild.

	build: Use mesar instead of ar.
	* scripts/mesar.in: Rename from ar.in.  Update users.
	* build-aux/build.sh.in (LIBS): Update.
	* build-aux/check.sh.in (recheck): Likwise.
	* build-aux/install.sh.in (DESTDIR): Likwise.
	* configure (main): Likwise.
	* configure.sh (mes_system): Likwise.
	* .gitignore: Update.

	getopt: Remove old FSF address, thanks Vagrant.
	* lib/posix/getopt.c: Remove old FSF address.

2019-09-09  Danny Milosavljevic  <dannym@scratchpost.org>

	Add missing #include.
	* lib/tests/scaffold/55-char-array.c: Add missing #include.

	Add missing #include.
	* lib/tests/io/90-stat.c: Add missing #include.

	Add missing #include.
	* lib/posix/getcwd.c: Add missing #include.

2019-09-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	signal: Use SA_RESTORER on x86-64.
	* lib/linux/signal.c (signal)[x86_64]: Avoid segfault by setting
	SA_RESTORER flag.

2019-09-09  Danny Milosavljevic  <dannym@scratchpost.org>

	signal: Add comment on why we don't use the restorer.
	* lib/linux/signal.c: Add comment on why we don't use the restorer.

	signal: Remove SA_SIGINFO.
	* lib/linux/signal.c (signal): Remove SA_SIGINFO.

	signal: Don't use custom restorer.
	* lib/linux/signal.c (signal): Don't use custom restorer.

	signal: Use SA_SIGINFO (like glibc).
	* lib/linux/signal.c (_restorer): Rename to...
	(_restorer_for_siginfo): ...this.
	(signal): Use it.  Use SA_SIGINFO.

	signal: Make sure that the signal mask is actually unsigned long.
	* lib/linux/signal.c (signal): Make sure that the signal mask is actually
	unsigned long.

2019-09-09  Danny Milosavljevic  <dannym@scratchpost.org>

	Delete "__sigmask".
	Follow-up to 6d95b89759d3c598fc84194429ae8c57249daa1a

	* lib/linux/signal.c (__sigmask): Delete definition.

2019-09-09  Danny Milosavljevic  <dannym@scratchpost.org>

	Fix "struct sigaction" structure for rt_sigaction.
	* include/signal.h (sigset_t): Increase size.
	* lib/linux/signal.c (signal): Use new sigset_t.

	Inherit CFLAGS for mes.
	* build-aux/check.sh.in: Inherit CFLAGS for mes.

	Fix typo.
	* build-aux/build.sh.in: Fix typo in "CFLAGS".

	tests: Fail early on nonexistent file.
	* lib/tests/io/90-stat.c (main): Fail early on nonexistent file.

	open: Check flags, and use _open2 if applicable.
	* lib/linux/open.c (open): Check flags; use _open2.

	ldiv: Make rem < 0 if a < 0.
	* lib/mes/div.c (ldiv): Make rem < 0 if a < 0.

	ldiv: Handle a == LONG_MIN.
	* lib/mes/div.c (ldiv): Handle a == LONG_MIN.

2019-09-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	ntoab: Use __mesabi_uldiv only for arm.
	* lib/mes/ntoab.c (ntoab)[__MESC__ && __arm__]: Use __mesabi_uldiv.
	* build-aux/check-mescc.sh (XFAIL_TESTS): 70-printf-simple.c and
	70-printf.c now pass for x86_64 mescc.

2019-07-01  Danny Milosavljevic  <dannym@scratchpost.org>

	Fix ntoab.
	Follow-up to b5b19304b59fefbed923b146ec8c8d495556fa76.

	* lib/mes/ntoab.c (ntoab): Fix non-MESC case.

2019-06-18  Danny Milosavljevic  <dannym@scratchpost.org>

	signal: Define "_restorer" everywhere except on i386.
	* lib/linux/signal.c: Define "_restorer" everywhere except on i386.

	Clarify our data type choices in "struct stat".
	* include/sys/stat.h: Clarify our data type choices in "struct stat".

2019-09-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Bump timeout.
	* build-aux/test-c.sh: Bump timeout to 10s, __mesabi_uldiv can be slow.

2019-06-14  Danny Milosavljevic  <dannym@scratchpost.org>

	ntoab: Use __mesabi_uldiv only on __MESC__.
	* lib/mes/ntoab.c (ntoab): Use __mesabi_uldiv only on __MESC__.

2019-06-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Include mes/div.c for mescc builds.
	* build-aux/configure-lib.sh (libmes_SOURCES): Add mes/div.c.
	* simple.sh: Likewise.

2019-06-13  Danny Milosavljevic  <dannym@scratchpost.org>

	ntoab: Include "assert.h".
	* lib/mes/ntoab.c: #include "assert.h".

	mescc: Mes C Library: Use __mesabi_uldiv.
	* lib/mes/ntoab.c (ntoab): Use __mesabi_uldiv.

	mescc: Mes C Library: Add integer division algorithm.
	* lib/mes/div.c: New file.

2019-07-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Have write behave well with buffered reads.
	* lib/mes/write.c: New file.
	* build-aux/configure-lib.sh (libc_mini_SOURCES): Add it.
	(libc_mini_shared_SOURCES): New variable.
	(libc_mini_SOURCES, libmes_SOURCES): Use it.
	(libmes_SOURCES): Add lib/linux/lseek.c, lib/posix/write.c.
	(libc_tcc_SOURCES): Remove lib/linux/lseek.c.
	* lib/posix/write.c (write): Correct for read buffer.
	* lib/stdio/fwrite.c (fwrite): Remove read buffer correction.
	* simple.sh: Update.

2019-07-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Add buffered read.
	* lib/mes/__buffered_read.c: New file.
	* build-aux/configure-lib.sh (libc_SOURCES): Add it.  Also add memmove.c.
	(libc_tcc_SOURCES): Remove memmove.c
	* lib/linux/close.c (close): Clear read buffer.
	* lib/linux/_open3.c (_open3): Likewise.
	* lib/linux/lseek.c (lseek): Correct for read buffer.
	* lib/stdio/fwrite.c (fwrite): Likewise.
	* lib/posix/read.c (read): Call __buffered_read.
	* lib/posix/write.c (write): Add FIXME note about buffered reads.
	* simple.sh: Update.

2019-06-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	tests: Disable 70-extern.c for x86_64-gcc.
	* build-aux/check-mescc.sh (XFAIL_TESTS)[x86_64-gcc]: Add
	70-extern.c.

2019-05-30  Danny Milosavljevic  <dannym@scratchpost.org>

	mescc: Put char's ASCII code into register, not char.
	* module/mescc/compile.scm (expr-register): Put char's ASCII code into
	register, not char.

2019-06-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Update to Nyacc 0.93.
	* mes/module/nyacc/lang/c99/util.mes: New file.
	* mes/module/nyacc/lang/c99/parser.mes: Use it.
	* module/mescc/compile.scm (ast->info): Update for Nyacc 0.93.0.
	* module/mescc/preprocess.scm (need-progress):  Likewise.
	(ast-strip-comment): Likewise.

2019-08-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: string->number: Support #x-prefixed hex numbers.
	* mes/module/mes/scm.mes (string->number): Support "#x"-prefix.
	* tests/math.test ("string->number #hex"): Test it.

2019-07-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Do not dump variables with extern storage.
	* lib/tests/scaffold/70-extern.stdout: New file.
	* lib/tests/scaffold/70-extern.c: New file.
	* build-aux/check-mescc.sh (TESTS): Add it..
	* module/mescc/M1.scm (global-string?, global-extern?): New function.
	(info->M1): Dump strings first.  Skip extern symbols.
	* module/mescc/info.scm (<global>): Add storage field.
	(make-global): Add storage parameter.  Pass it.
	* module/mescc/compile.scm (make-global-entry): Likewise.
	(global->info): Likewise.
	(init-declr->info): Likewise.
	(decl->info): Pass storage.

	build: ./pre-inst-env MES_PREFIX fixup.
	* build-aux/pre-inst-env.in: Set MES_PREFIX to abs_top_srcdir.
	* src/mes.c (open_boot): Cater for MES_PREFIX/mes and ${srcdest}.

	mescc: Be silent.
	* module/mescc/M1.scm (infos->M1, info->M1): Add verbose?.  Move
	debugging into verbose? > 1.
	* module/mescc/compile.scm (c99-input->info, c99-ast->info): Likewise.
	(mescc:trace-verbose): Rename from mescc:trace.
	(mescc:trace): New function.
	* module/mescc.scm (mescc:main): Likewise.
	* module/mescc/mescc.scm (mescc:preprocess, c->ast mescc:compile,
	c->info, E->info): Likewise.
	* module/mescc/preprocess.scm (c99-input->full-ast, c99-input->ast):
	Likewise.

2019-07-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Add <include>/<kernel>/<arch> to include path.
	* module/mescc/preprocess.scm (c99-input->full-ast): Add
	<include>/<kernel>/<arch> to include path.
	* module/mescc/compile.scm (c99-input->info): Pass arch.
	* module/mescc/mescc.scm (mescc:preprocess): Likewise.
	(c->info): Likewise.
	(c->ast): Likewise.

	mescc: Add 70-function-destruct-declare.c test.
	* module/mescc/compile.scm (init-declr->info): Do not attempt to
	re-calculate function type.
	(ftn-declr:get-type): Remove.
	* lib/tests/scaffold/70-function-destruct-declare.c: New file.
	* build-aux/check-mescc.sh (TESTS): Add it.

	mescc: Resurrect --write.
	* module/mescc/mescc.scm (mescc:preprocess): Pass pretty-print/write
	to c->ast.

	build: Distribute crt*.c, libc+gnu.c for tcc, gcc bootstrap build.
	* build-aux/build-lib.sh (libc_gnu_SOURCES): Build libc+gnu.c.  Copy
	crt*.c, libc+gnu.c for distribution.

	build: Uniquify config macros.
	* configure (main): Rename VERSION to MES_VERSION, pkgdatadir to
	MES_PKGDATADIR.  Update users.
	* configure.sh (mes_system): Likewise.
	* src/mes.c (mes_symbols): Update.
	(open_boot): Update.
	* scaffold/cons-mes.c (main): Update.
	* simple.sh: Update.

2019-07-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Resurrect --with-cheating.
	* build-aux/config.sh.in (SCHEME): New substitute.
	* build-aux/config.make.in: Likewise.
	* configure: Substitute them.

2019-07-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support tcc: libtcc1 build fixes.
	* lib/libtcc1.c: Support building without long long, float support.

2019-06-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Avoid type/size_t conflicts.
	* include/alloca.h: Remove typedefs, include sys/types.h.
	* include/stdint.h: Likewise.
	* include/string.h: Likewise.

2019-07-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support tcc: Add intptr_t, uintptr_t.
	* include/sys/types.h (intptr_t, uintptr_t): Add typedef.

2019-07-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Add 70-struct-post.c test with fix.
	* lib/tests/scaffold/70-struct-post.c: New file.
	* build-aux/check-mescc.sh (TESTS): Add it.
	* module/mescc/compile.scm (expr->register): Use type size for rank
	0 (WAS: 1).

	mescc: Add 70-struct-short-enum-init.c test with fix.
	* module/mescc/compile.scm (init->data): Respect type of size.
	* lib/tests/scaffold/70-struct-short-enum-init.c: New file.
	* lib/tests/scaffold/70-struct-short-enum-init.stdout: New file.
	* build-aux/check-mescc.sh (TESTS): Add test.

2019-07-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Add 70-array-in-struct-init.c test with fix.
	* lib/tests/scaffold/70-array-in-struct-init.c: New file.
	* lib/tests/scaffold/70-array-in-struct-init.stdout: New file.
	* build-aux/check-mescc.sh (TESTS): Add test.
	* module/mescc/compile.scm (array-init-element->data): Recurse for
	elements instead of using init->data.  Support array fields.

2019-07-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Remove broken copy of simple-format.
	* mes/module/mes/simple-format.mes: New file.
	* mes/module/mes/guile.mes: Use it.
	(with-output-to-string, simple-format): Remove broken copies.
	* mes/module/mes/display.mes (with-output-to-string, simple-format,
	format): Remove.

2019-07-05  Danny Milosavljevic  <dannym@scratchpost.org>

	Fix remainder handling.
	* mes/module/mes/scm.mes (number->string): Fix remainder handling.
	* build-aux/check-mescc.sh (XFAIL_TESTS): Remove
	lib/tests/scaffold/60-math.c.

2019-07-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "test: Disable 60-math.c test."
	This reverts commit bbe6576a66a520d429bb3ec84120ffcce88480bf.

	test: Disable 60-math.c test.
	* build-aux/check-mescc.sh (TESTS): Remove
	lib/tests/scaffold/60-math.c.
	(BROKEN_TESTS): Add it.

2019-07-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Resurrect bootstrap.sh.
	* build-aux/connfigure-lib.sh: Split from build-lib.sh
	* build-aux/build-lib.sh: Include it.
	* build-aux/bootstrap.sh.in: New file.
	* configure.sh: Substitute it.

2019-07-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Use basename of input as default output name.
	* module/mescc/mescc.scm (mescc:preprocess, mescc:compile,
	mescc:assemble, M1->hex2): Use basename of input as default output name.

2019-07-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Handle gcc with --pie-by-default.
	This fixes upgrading to debian-hurd-20190220.img.

	* build-aux/build.sh.in (CFLAGS): Add -static.  Fixes using gcc
	compiled with --pie-by-default
	* build-aux/check.sh.in (CFLAGS): Likewise.
	* module/mescc.scm (parse-opts): Ignore -no-pie, -static.

2019-07-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Split-off broken 72-typedef-struct-def-local.
	* lib/tests/scaffold/72-typedef-struct-def-local.c: New file.
	* lib/tests/scaffold/72-typedef-struct-def.c: Remove local bit.
	* build-aux/check-mescc.sh (TESTS): Add it.
	(XFAIL_TESTS)[mescc]: Add lib/tests/scaffold/72-typedef-struct-def.c.

2019-06-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Fix open-read test.
	* build-aux/pre-inst-env.in (srcdir): Remove.
	(abs_top_srcdir, abs_top_builddir): Export.
	* lib/tests/posix/50-open-read.c (main): Use abs_top_srcdir.

2019-06-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Add open-read test.
	* build-aux/test-c.sh: Support running by hand.
	* lib/tests/posix/50-open-read.c: New test.
	* lib/tests/posix/data/open-read: New file.
	* build-aux/check-mescc.sh (TESTS): Add it.

	test: Enable argv test, run tests with arguments.
	* build-aux/check-mescc.sh (TESTS): Enable 54-argv.c
	(XFAIL_TESTS): Remove it.
	* build-aux/test-c.sh: Invoke test with options.
	* lib/tests/scaffold/54-argc.c: Update.

2019-06-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C library: Move common getcwd, open bits to posix.
	* lib/linux/_getcwd.c: Rename from getcwd.c.
	* lib/linux/_open3.c: Rename from open.c.
	* lib/posix/getcwd.c: New file with bits from ../linux/getcwd.c.
	* lib/posix/open.c: New file with bits ../linux/getcwd.c.
	* build-aux/build-lib.sh (libc_SOURCES): Update.

2019-06-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Move posix bits to read.
	* lib/linux/_read.c: Rename from read.
	* lib/posix/read.c: New file.
	* build-aux/build-lib.sh (libc_SOURCES): Update.
	* include/mes/lib.h (_read): Declare.

2019-06-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	porting: Avoid failing in scaffold build.
	* build-aux/build-scaffold.sh: Do not fail when using courage.

	build: Use bash if available to avoid dash problems.
	* configure: Set SHELL to bash.
	* configure.sh: Likewise.
	* build-aux/test-suite.sh (TEST_LOGS):
	* build-aux/export.make: Export SHELL.
	* build-aux/config.sh.in (SHELL): New substitute, export.
	* build-aux/config.make.in (SHELL): New substitute.
	* build-aux/GNUmakefile.in (build, check, install, uninstall): Use
	$SHELL to avoid dash problems.
	* build-aux/check-mescc.sh: Likewise.
	* build-aux/build.sh.in: Likewise.
	* build-aux/check-mes.sh: Likewise.
	* build-aux/check.sh.in: Likewise.

	test: Oops, uncomment some commented-out tests.
	* lib/tests/scaffold/55-char-array.c: Uncomment.
	* lib/tests/scaffold/72-typedef-struct-def.c: Likewise.

	build: Improve --with-system-libc support.
	* build-aux/build-lib.sh: Avoid building libc for --with-system-libc.
	Make libmes richer.
	build-aux/check-mescc.sh: Enable 50-malloc test.
	* include/dirstream.h: Use HAVE_DIRSTREAM_H to cater for non-existing
	dirstream.h.
	* include/grp.h[SYSTEM_LIBC]: Typo.
	* include/mes/lib.h (__brk, __call_at_exit)[SYSTEM_LIBC]: Declare.
	* include/stdlib.h (comparison_fn_t)[SYSTEM_LIBC]: Declare.
	* include/time.h (mktime): Return time_t.
	* lib/posix/isatty.c [SYSTEM_LIBC]: Do not (re)declare termios.
	* lib/stub/mktime.c (mktime): Return time_t.
	* lib/tests/scaffold/41-ternary.c (main): Remove assumption that
	locals are initialized.
	* lib/tests/scaffold/70-stdarg.c: Cater for SYSTEM_LIBC.
	* lib/tests/setjmp/80-setjmp.c: Declare jmp buf.
	* lib/*/*.c: Add missing mes/lib.h, errno.h includes.

2019-06-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	porting: Add x86_64 scaffold: exit and write in assembly.
	* lib/x86_64-mes-gcc/exit-42.S: New file.
	* lib/x86_64-mes-gcc/hello-mes.S: New file.
	* lib/x86_64-mes/elf64-0exit-42.hex2: New file.
	* lib/x86_64-mes/elf64-0hello-mes.hex2: New file.
	* lib/x86_64-mes/elf64-body-exit-42.hex2: Rewrite..
	* lib/x86_64-mes/elf64-body-hello-mes.hex2:
	* lib/x86_64-mes/elf64-0header.hex2: Fix copyright header.
	* lib/x86_64-mes/elf64-header.hex2: Likewise.
	* lib/x86_64-mes/elf-0footer.hex2: Remove.

2019-06-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	porting: Add x86 scaffold: exit and write in assembly.
	* lib/x86-mes-gcc/exit-42.S: New file.
	* lib/x86-mes-gcc/hello-mes.S: New file.
	* lib/x86-mes/elf32-0exit-42.hex2: New file.
	* lib/x86-mes/elf32-0hello-mes.hex2: New file.
	* lib/x86-mes/elf32-body-hello-mes.hex2: New file.
	* lib/x86-mes/elf32-body-exit-42.hex2: Rewrite.
	* lib/x86-mes/elf32-header.hex2: Fix copyright header.
	* lib/x86-mes/elf32-0header.hex2: Likewise.
	* lib/x86-mes/elf-0footer.hex2: Remove.
	* build-aux/build-scaffold.sh: Build them.
	* .dir-locals.el (asm-mode): Allow TABs.
	* .gitignore: Reserve .S assembly sources, i.e. manual written
	assembly.  Update build system.
	* module/mescc/mescc.scm: Update.
	* build-aux/build-lib.sh: Update.
	* scripts/ar.in: Update.

2019-06-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	make check: Do not re-check unless recheck=true.
	* build-aux/check-mescc.sh (recheck): New variable.
	* build-aux/check.sh.in (recheck): New variable.
	* build-aux/test-suite.sh (TEST_LOGS): Use it.

2019-05-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Cater for ARM.
	* configure: Cater for ARM.
	* configure.sh: Likewise
	* build-aux/GNUmakefile.in: Likewise.
	* build-aux/bootstrap.sh.in: Likewise.
	* module/mescc.scm (parse-opts): Likewise.
	* src/mes.c (mes_environment): Likewise.
	* build-aux/build.sh.in: Likewise.
	* build-aux/config.sh Likewise.
	* build-aux/install.sh.in: Likewise.
	* module/mes/guile.scm: Likewise.
	* scripts/mescc.scm.in: Likewise.
	* module/mescc/mescc.scm (arch-get): New function.
	(arch-get-info): New function.
	(arch-get-define): New function.
	(arch-get-m1-options): New function.
	(arch-get-Architecture): New function.
	(mescc:preprocess c->info, E->info, M1->hex2, hex2->elf,
	M1->blood-elf, arch-find): Use them.

2019-06-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Drop $@-workaround.
	* scripts/mescc.in: Drop $@-workaround.

2019-06-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Simplify.
	    core: Make mes src/ c files separate compilation units.

	* include/mes/constants.h: New file.
	* include/mes/macros.h: New file.
	* include/mes/mes.h: New file.
	* src/gc.c: Update.
	* src/hash.c: Update.
	* src/lib.c: Update.
	* src/math.c: Update.
	* src/mes.c: Update.
	* src/module.c: Update.
	* src/posix.c: Update.
	* src/reader.c: Update.
	* src/string.c: Update.
	* src/struct.c: Update.
	* src/vector.c: Update.

	    mes: Update datadir.

	* src/mes.c (g_datadir): New global.
	(open_boot): Rename from read_boot.
	(read_boot): New function.
	* mes/module/mes/boot-0.scm: Move from boot-0.scm.in
	* configure: Update.
	* configure.sh: Update.

	    mescc: Create libraries from separate files.

	* .gitignore: Update.
	* build-aux/bootstrap-mes.sh: Remove.
	* build-aux/bootstrap.sh.in: Remove.
	* build-aux/build-guile.sh: Update.
	* build-aux/build-mes.sh: Update.
	* build-aux/build-scaffold.sh: New file.
	* build-aux/build.sh.in: Update.
	* build-aux/cc.sh: Update.
	* build-aux/check-tcc.sh: Remove.
	* build-aux/config.sh.in: New file.
	* build-aux/config.sh: Remove.
	* build-aux/install.sh.in: Update.
	* build-aux/test-boot.sh: New file.
	* build-aux/test-c.sh: New file.
	* build-aux/test-driver: New file.
	* build-aux/test-suite.sh: New file.
	* build-aux/trace.sh: Update.
	* build-aux/uninstall.sh.in: Update.
	* configure: Update.
	* configure.sh: Update.
	* lib/linux/x86-mes-mescc/crt1.c: Move from lib/linux/x86-mes.
	* lib/linux/x86-mes-mescc/mini.c: Likewise.
	* lib/linux/x86_64-mes-mescc/crt1.c: Move from lib/linux/x86_64-mes.
	* lib/linux/x86_64-mes-mescc/mini.c: Likewise.
	* lib/linux/x86-mes-gcc/syscall.c: Rename from mes.c.
	* lib/linux/x86-mes-mescc/syscall.c: Likewise.
	* lib/linux/x86_64-mes-gcc/syscall.c: Likewise.
	* lib/linux/x86_64-mes-mescc/syscall.c: Likewise.
	* lib/mes/mes_open.c: Include config.h.
	* lib/tests/stdio/70-printf-hello.c: Likewise.
	* lib/tests/stdio/70-printf-simple.c: Likewise.
	* scaffold/gc-test.sh: New file.
	* simple.sh: Update.

2019-06-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Move scaffold/tests into lib.
	* lib/tests/scaffold: Move from scaffold/tests.
	* scaffold/tests: Remove.
	* build-aux/check-mescc.sh: Update.

2019-05-10  Danny Milosavljevic  <dannym@scratchpost.org>

	build: Make "GUILEC" compilation status output more verbose (print full path).
	* build-aux/build-guile.sh: Make "GUILEC" compilation status output more
	verbose (print full path).

2019-05-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Fix --disable-silent-rules. Thanks ng0!
	* configure (main): Substitute V as string value.
	* build-aux/trace.sh: Typo.  Fixes using V=0.
	* build-aux/config.status.in (V): New substitute.
	* build-aux/config.make.in (V): New substiute.

	mescc: Use a.out as default executable name.
	* module/mescc/mescc.scm (hex2->elf): Use a.out as default executable
	name.

	mescc: Robustify against empty `V' in environment.
	* module/mescc.scm: Robustify against empty V in environment.

2019-05-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Fix -dumpmachine to respect -m bits selection.
	* module/mescc.scm (parse-opts): Fix -dumpmachine to respect -m bits
	selection.  Also display kernel.

2019-05-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support single-dash options on Mes too.
	* scripts/mescc.in[MES]: Add -- as separator, fixes using single-dash
	options on Mes too.

	mescc: Ignore -fnobuiltin, -nostdinc for GCC compatibility.
	* module/mescc.scm (parse-opts): Add -fnobuiltin, -nostdinc.
	(mescc:main): Ignore them.

2019-05-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Resurrect running boot tests on Guile.
	* module/mes/guile.scm (keyword->string): New function.
	* scaffold/boot/43-or.scm (foo): Add quoting.
	* scaffold/boot/45-pass-if.scm (pass-if): Likewise.
	* scaffold/boot/46-report.scm (pass-if): Likewise.
	* scaffold/boot/47-pass-if-eq.scm (pass-if): Likewise.
	* scaffold/boot/48-let.scm (map): Rename from map1.
	* scaffold/boot/60-let-syntax-expanded.scm: Some work.

2019-05-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Fix compile warnings.
	* lib/stdio/fputc.c (fputc): Oops, stream is a long.
	* lib/stdlib/malloc.c (malloc): Cast to char *. FIXME
	* lib/string/memchr.c (memchr): Cast to void *.
	* lib/string/memcmp.c (memcmp): Add const cast.

	mescc: Mes C Library: Fixes for x86_64 crt1.c
	* lib/linux/x86_64-mes/crt1.c (_start): Write only 4 bytes to int
	variables __stdin, __stdout, __stderr.

2019-05-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Move srfi-1 for-each and map tests to tests/srfi-1.test.
	This fixes: `make check MES=guile'.

	* tests/srfi-1.test ("map 1,2", "map 2,1", "for-each 1,2",
	for-each 2,1"): Move from scm.test.
	* tests/scm.test ("map 1,2", "map 2,1", "for-each 1,2",
	for-each 2,1"): Remove.

2019-05-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Use SYSTEM_LIBC [WAS: WITH_GLIBC].
	Run: sed -i 's,WITH_GLIBC,SYSTEM_LIBC,g' $(git grep -l WITH_GLIBC)

	* build-aux/config.sh: Update.
	* include/alloca.h: Likewise.
	* include/ar.h: Likewise.
	* include/argz.h: Likewise.
	* include/assert.h: Likewise.
	* include/ctype.h: Likewise.
	* include/dirent.h: Likewise.
	* include/dirstream.h: Likewise.
	* include/dlfcn.h: Likewise.
	* include/endian.h: Likewise.
	* include/errno.h: Likewise.
	* include/fcntl.h: Likewise.
	* include/features.h: Likewise.
	* include/float.h: Likewise.
	* include/getopt.h: Likewise.
	* include/inttypes.h: Likewise.
	* include/libgen.h: Likewise.
	* include/limits.h: Likewise.
	* include/linux/x86_64/syscall.h: Likewise.
	* include/locale.h: Likewise.
	* include/math.h: Likewise.
	* include/memory.h: Likewise.
	* include/mes/lib-mini.h: Likewise.
	* include/pwd.h: Likewise.
	* include/setjmp.h: Likewise.
	* include/signal.h: Likewise.
	* include/stdarg.h: Likewise.
	* include/stdbool.h: Likewise.
	* include/stddef.h: Likewise.
	* include/stdint.h: Likewise.
	* include/stdio.h: Likewise.
	* include/stdlib.h: Likewise.
	* include/stdnoreturn.h: Likewise.
	* include/string.h: Likewise.
	* include/strings.h: Likewise.
	* include/sys/cdefs.h: Likewise.
	* include/sys/dir.h: Likewise.
	* include/sys/file.h: Likewise.
	* include/sys/ioctl.h: Likewise.
	* include/sys/mman.h: Likewise.
	* include/sys/param.h: Likewise.
	* include/sys/resource.h: Likewise.
	* include/sys/select.h: Likewise.
	* include/sys/stat.h: Likewise.
	* include/sys/time.h: Likewise.
	* include/sys/timeb.h: Likewise.
	* include/sys/times.h: Likewise.
	* include/sys/types.h: Likewise.
	* include/sys/ucontext.h: Likewise.
	* include/sys/user.h: Likewise.
	* include/sys/wait.h: Likewise.
	* include/termio.h: Likewise.
	* include/time.h: Likewise.
	* include/unistd.h: Likewise.
	* lib/libmes.c: Likewise.
	* lib/tests/stdio/70-printf-hello.c: Likewise.
	* lib/tests/stdio/70-printf-simple.c: Likewise.
	* lib/tests/stdio/80-sscanf.c: Likewise.
	* lib/tests/stdlib/50-malloc.c: Likewise.
	* module/mescc/preprocess.scm: Likewise.
	* scaffold/cons-mes.c: Likewise.
	* scaffold/lib/stdlib/malloc.c: Likewise.
	* scaffold/micro-mes.c: Likewise.
	* scaffold/tests/61-array.c: Likewise.
	* scaffold/tiny-mes.c: Likewise.
	* simple.sh: Likewise.
	* src/mes.c: Likewise.

2019-05-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Bugfix for search-path. Fixes running MesCC on Guile.
	* module/mescc/mescc.scm (arch-find): Also look in cwd.
	* mes/module/mes/posix.mes (search-path): Do not look in cwd.

2019-05-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Use named --architecture switch for upcoming mescc-tools 0.6.
	* module/mescc/mescc.scm (M1->hex2): Use named --architecture switch for
	upcoming mescc-tools 0.6.
	(hex2->elf): Likewise.
	* build-aux/bootstrap-mes.sh: Likewise.
	* build-aux/bootstrap.sh.in: Likewise.
	* build-aux/config.sh: Likewise.

2019-05-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Identify 64-bit bug when compiled with MesCC.
	* src/math.c (divide): Add divide-by-zero error.
	(modulo): Likewise.
	* module/mes/guile.scm (%compiler): New variable.
	* module/mescc/M1.scm (mesc?): New variable.
	(hex2:immediate8): Use it to avoid divide-by-zero error.
	* HACKING (Bugs): Add it.

	mes: Make debug levels 4 and 5 usable.
	* HACKING: Update debug policy.
	* lib/linux/read.c (read): Print read in level 5.
	* src/mes.c (eval_apply): Print module in level 6.
	(main): Likewise.  Remove redundant module printing.
	* src/gc.c (gc): Print symbols in level 6.

2019-05-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Run build-aux/indent.sh.
	* src/mes.c: Re-indent.
	* src: Likewise.
	* include: Likewise.
	* lib: Likewise.
	* scaffold: Likewise.

2019-05-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Grand indent: prepare.
	* build-aux/indent.sh: New file.
	* include/mes/builtins.h: Move from src/builtins.h.
	* include/fcntl.h: Use // *INDENT-OFF* to prevent indent breakage.
	* include/locale.h: Likewise.
	* include/signal.h: Likewise.
	* include/sys/stat.h: Likewise.
	* include/sys/user.h: Likewise.
	* lib/linux/x86-mes-gcc/crt0.c: Likewise.
	* lib/linux/x86-mes-gcc/crt1.c: Likewise.
	* lib/linux/x86-mes-gcc/mes.c: Likewise.
	* lib/linux/x86-mes-gcc/mini.c: Likewise.
	* lib/linux/x86_64-mes-gcc/crt0.c: Likewise.
	* lib/linux/x86_64-mes-gcc/crt1.c: Likewise.
	* lib/linux/x86_64-mes-gcc/mes.c: Likewise.
	* lib/linux/x86_64-mes-gcc/mini.c: Likewise.
	* lib/x86_64-mes-gcc/setjmp.c: Likewise.
	* src/mes.c: Likewise.
	* src/reader.c: Likewise.

2019-05-15  Jan (janneke) Nieuwenhuizen  <janneke@gnu.org>

	mes: Support -c EXPR.
	* mes/module/mes/boot-0.scm.in: Support -c EXPR.

	mes: Support optional port on read.
	* mes/module/mes/scm.mes (read): Support optional port on read.

	build: Fix mescc installation on Debian.
	* build-aux/pre-inst-env.in: Set bindir.
	* scripts/mescc.in: Fix configure/prefix issues.
	* mes/module/mes/boot-01.scm (integer->char): Remove.
	(newline): Use "\n".
	(%moduledir): Use string-append.
	* mes/module/mes/boot-02.scm: Likewise.
	* mes/module/mes/boot-0.scm: Likewise.

	build: Debian make check and install fixes.
	* configure (main): Oops, typo: mandir uses --infodir.
	* build-aux/check.sh.in: Run check-mescc.sh with bash.
	* build-aux/config.sh (CFLAGS, CPPFLAGS, HEX2FLAGS, LDFLAGS, M1FLAGS):
	unset.
	* build-aux/install.sh.in: Use BASHOPTS to check for bash; on Debian
	dash is used and has $SHELL=/bin/bash.  Use ${DESTDIR}@...

2019-05-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Rename strings.c.
	* src/string.c: Rename from src/strings.c.
	* src/mes.c
	* build-aux/snarf.sh: Update.

2019-05-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Use mes_open to avoid open trickery.
	* include/mes/lib.h (mes_open): Declare.
	* lib/libmes.c[WITH_GLIBC]: Remove open undefine.
	(mes_open)[!WITH_GLIBC]: New function.
	* src/mes.c (open_boot): Use mes_open.
	* src/posix.c (open_input_file): Likewise.
	(open_output_file): Likewise.

	mescc: Mes C Library: Remove dead code.
	* lib/glibc.c: Remove.
	* lib/abtol.c: Remove.

	mescc: Mes C Library: Explode linux/tcc.c.
	* lib/linux/close.c: New file.
	* lib/linux/lseek.c: New file.
	* lib/linux/rmdir.c: New file.
	* lib/linux/stat.c: New file.
	* lib/linux/tcc.c: Include them.
	(close, lseek, rmdir, stat): Remove.

	mescc: Mes C Library: Explode linux/libc.c.
	* lib/linux/access.c: New file.
	* lib/linux/brk.c: New file.
	* lib/linux/chmod.c: New file.
	* lib/linux/dup.c: New file.
	* lib/linux/dup2.c: New file.
	* lib/linux/execve.c: New file.
	* lib/linux/fork.c: New file.
	* lib/linux/fsync.c: New file.
	* lib/linux/getcwd.c: New file.
	* lib/linux/ioctl.c: New file.
	* lib/linux/libc.c: New file.
	* lib/linux/open.c: New file.
	* lib/linux/read.c: New file.
	* lib/linux/unlink.c: New file.
	* lib/linux/waitpid.c: New file.
	* lib/linux/libc.c: Include them.
	(access, brk, chmod, dup, dup2, execve, fork, fsync, getcwd, ioctl,
	libc, open, read, unlink, waitpid): Remove.

2019-05-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Explode linux/gnu.c.
	* lib/linux/chdir.c: New file.
	* lib/linux/fcntl.c: New file.
	* lib/linux/fstat.c: New file.
	* lib/linux/getdents.c: New file.
	* lib/linux/getegid.c: New file.
	* lib/linux/geteuid.c: New file.
	* lib/linux/getgid.c: New file.
	* lib/linux/getpid.c: New file.
	* lib/linux/getppid.c: New file.
	* lib/linux/getrusage.c: New file.
	* lib/linux/getuid.c: New file.
	* lib/linux/kill.c: New file.
	* lib/linux/link.c: New file.
	* lib/linux/lstat.c: New file.
	* lib/linux/mkdir.c: New file.
	* lib/linux/nanosleep.c: New file.
	* lib/linux/pipe.c: New file.
	* lib/linux/rename.c: New file.
	* lib/linux/setgid.c: New file.
	* lib/linux/settimer.c: New file.
	* lib/linux/setuid.c: New file.
	* lib/linux/signal.c: New file.
	* lib/linux/sigprogmask.c: New file.
	* lib/linux/gnu.c: Include them.
	(chdir, fcntl, fstat, getdents, getegid, geteuid, getgid, getpid,
	getppid, getrusage, getuid, kill, link, lstat, mkdir, munmap,
	nanosleep, pipe, rename, setgid, settimer, setuid, signal,
	sigprogmask): Remove.

2019-05-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Explode libc-mini.c.
	* lib/posix/write.c: New file.
	* lib/linux/libc-mini.c: Include it.
	(write): Remove.
	* lib/tests/mes/30-oputs.c: Remove dead code.

2019-05-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Cleanup includes.
	* include/mes/lib-mini.h: Move from include/libmes-mini.h.  Update users.
	* include/mes/lib.h: Move from include/libmes.h.  Update users.

2019-05-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support -nodefaultlibs, -nostartfiles, -nostdlib.
	* module/mescc.scm (parse-opts): Parse -nodefaultlibs, -nostartfiles, -nostdlib.
	* module/mescc/mescc.scm (mescc:link): Handle -nodefaultlibs, -nostdlib.
	(hex2->elf): Handle -nostartfiles, -nostdlib.

2019-05-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Do not install test binaries.
	* build-aux/install.sh.in: Do not install test binaries.

2019-05-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: m2: Move force-output to Scheme.
	* mes/module/mes/posix.mes (force-output): New function.
	* src/posix.c (force_output): Remove.
	* src/mes.c (mes_builtins): Remove adding of force-output.

2019-03-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: M2-Planet first-aid, simplest build script possible.
	* simple.sh: New file.

2019-03-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	.dir-locals.el: Assert default GNU settings.
	* .dir-locals.el: Assert default GNU settings.

	Fix typo in stage0 copyright headers.
	* lib/x86-mes/elf-0footer.hex2: Fix typo.
	* lib/x86-mes/elf32-0header.hex2: Fix typo.
	* lib/x86-mes/elf32-body-exit-42.hex2: Fix typo.
	* lib/x86-mes/elf32-footer-single-main.hex2: Fix typo.
	* lib/x86-mes/elf32-header.hex2: Fix typo.
	* lib/x86_64-mes/elf-0footer.hex2: Fix typo.
	* lib/x86_64-mes/elf64-0header.hex2: Fix typo.
	* lib/x86_64-mes/elf64-body-exit-42.hex2: Fix typo.
	* lib/x86_64-mes/elf64-footer-single-main.hex2: Fix typo.
	* lib/x86_64-mes/elf64-header.hex2: Fix typo.

2019-03-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Fix ungetc.
	* include/sys/resource.h (OPEN_MAX, RLIMIT_NOFILE): New macro.
	* lib/libc.c: Add memset.c include.
	* lib/libc+tcc.c: Remove memset.c include.
	* lib/linux/tcc.c (close):
	* lib/mes/fdgetc.c (__ungetc_buf): New global.
	(_ungetc_pos, _ungetc_fd, _ungetc_buf): Remove.  Update users.
	* scaffold/tests/65-read.c: Update.

2019-03-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Replace POSIX, posix_p by WITH_GLIBC, wip_glibc_p.
	* build-aux/build-mes.sh: Replace POSIX, posix_p by WITH_GLIBC, wip_glibc_p.
	* build-aux/build.sh.in: Likewise.
	* build-aux/cc.sh (link): Likewise.
	* build-aux/config.make.in (with_glibc_p): Likewise.
	* build-aux/config.sh (libc): Likewise.
	(CPPFLAGS): Likewise.
	* build-aux/config.status.in (with_glibc_p): Likewise.
	* build-aux/test.sh: Likewise.
	* configure (main): Likewise.
	* configure.sh (subst): Likewise.
	(mes_arch): Likewise.
	* include/libmes.h: Likewise.
	* include/linux/x86_64/syscall.h: Likewise.
	* lib/libmes.c: Likewise.
	* lib/tests/stdio/70-printf-hello.c (main): Likewise.
	* lib/tests/stdio/70-printf-simple.c (main): Likewise.
	* lib/tests/stdio/80-sscanf.c (main): Likewise.
	* lib/tests/stdlib/50-malloc.c: Likewise.
	* module/mescc/preprocess.scm (c99-input->full-ast): Likewise.
	* scaffold/cons-mes.c: Likewise.
	* scaffold/lib/stdlib/malloc.c: Likewise.
	* scaffold/micro-mes.c: Likewise.
	* scaffold/tests/61-array.c (getenv): Likewise.
	* scaffold/tiny-mes.c: Likewise.
	* src/mes.c: Likewise.

2019-03-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Fix compile warnings.
	* include/libmes.h (dtoab, itoa, ltoa, ntoab, ultoa, utoa): Return
	char* (WAS: char const*).
	* lib/*/*c: Update, add missing includes.

2019-03-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Fix isatty.
	* lib/posix/isatty.c (isatty): Test ioctl == 0.
	* mes/module/mes/boot-0.scm.in: Update: no tty?: read from stdin.

	test: 50-getenv: Test PATH, allow to fail.
	* lib/tests/posix/50-getenv.c (main): Test PATH.
	* build-aux/check-mescc.sh (broken): Add 50-getenv.

	mes: Support map and for-each with lists of unequal length.
	* mes/module/mes/base.mes (map): Support lists of unequal length.
	* mes/module/mes/scm.mes (for-each): Likewise.
	* module/mescc/compile.scm (expr->register): Fix compile warning.
	* tests/scm.test ("map 1,2", "map 2,1", "for-each 1,2", "for-each
	2,1": Test it.

	mescc: Mes C Library: Use __ as global internal prefix.
	* include/libmes-mini.h (g_stdin, g_stdout, g_stderr): Rename to
	__stdin, __stdout, __stderr.  Update users.

2019-02-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: ctype.h: Add missing prototypes.
	* include/ctype.h: Add missing prototypes.

	mescc: Mes C Library: Bugfix for tcc-compiled exit assembly.
	* lib/linux/x86-mes-gcc/mini.c (_exit): Add clobbered registers %eax,
	%ebx.  Fixes always exit 1.

2019-02-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Remove special characters from files.
	* scaffold/tests/06-call-not-1.c: Rename from 06-call-!1.c.
	* scaffold/tests/06-not-call-1.c: Rename from 06-!call-1.c.
	* scaffold/tests/12-if-eq.c: Rename from 12-if-==.c.
	* scaffold/tests/13-if-neq.c: Rename from 13-if-!=.c.
	* scaffold/tests/15-if-not-f.c: Rename from 15-if-!f.c.
	* scaffold/tests/21-char-array-simple.c: Rename from 21-char[]-simple.c.
	* scaffold/tests/21-char-array.c: Rename from 21-char[].c.
	* scaffold/tests/22-while-char-array.c: Rename from 22-while-char[].c.
	* scaffold/tests/41-ternary.c: Rename from 41-?.c.
	* scaffold/tests/7u-call-ternary.c: Rename from 7u-call-?.c.
	* scaffold/tests/7u-ternary-expression.c: Rename from 7u-?-expression.c.
	* build-aux/check-mescc.sh (tests): Update.

	build: Support building with Gash.
	* build-aux/check-mes.sh: Replace unspported $((..)) by $(expr ...).
	* build-aux/check-mescc.sh: Likewise.
	* build-aux/check-tcc.sh: Likewise.

2019-02-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Configure: remove temp files.
	* configure (gulp-pipe*): Remove .error.
	(check-header-c): Remove .config.c.
	(check-compile-c): Likewise.
	(check-link-c): Likewise.

	build: Remove mini-mes.
	* scaffold/mini-mes.c: Remove.
	* build-aux/build-mes.sh: Remove commented build instructions.
	* .gitignore: Remove pattern.

2019-02-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Initialize streams in crt1.
	* lib/linux/x86-mes-gcc/crt1.c: Initialize streams.
	* lib/linux/x86-mes/crt1.c: Likewise.
	* lib/linux/x86_64-mes-gcc/crt1.c: Likewise.
	* lib/linux/x86_64-mes/crt1.c: Likewise.
	* src/mes.c (main): Remove initialization of streams.

	mescc: Mes C Library: Populate with function tests from scaffold.
	* .gitignore: Update.
	* build-aux/bootstrap.sh.in: Update.
	* build-aux/build-mes.sh: Update.
	* build-aux/check-mescc.sh: Update.
	* lib/tests/assert/50-assert.c: Move from scaffold/tests/50-assert.c.
	* lib/tests/dirent/90-readdir.c: Move from scaffold/tests/99-readdir.c.
	* lib/tests/dirent/readdir.dir: Move from scaffold/tests/readdir.dir.
	* lib/tests/io/90-stat.c: Move from scaffold/tests/92-stat.c.
	* lib/tests/mes/30-oputs.c: Move from scaffold/tests/31-oputs.c.
	* lib/tests/mes/50-itoa.c: Move from scaffold/tests/51-itoa.c.
	* lib/tests/posix/90-unsetenv.c: Move from scaffold/tests/94-unsetenv.c.
	* lib/tests/setjmp/80-setjmp.c: Move from scaffold/tests/80-setjmp.c.
	* lib/tests/signal/90-signal.c: Move from scaffold/tests/95-signal.c.
	* lib/tests/stdio/70-printf-hello.c: Move from scaffold/tests/70-printf-hello.c.
	* lib/tests/stdio/70-printf-simple.c: Move from scaffold/tests/70-printf-simple.c.
	* lib/tests/stdio/70-printf.c: Move from scaffold/tests/70-printf.c.
	* lib/tests/stdio/80-sscanf.c: Move from scaffold/tests/87-sscanf.c.
	* lib/tests/stdio/90-fopen-append.c: Move from scaffold/tests/98-fopen.c.
	* lib/tests/stdio/90-fopen.c: Move from scaffold/tests/97-fopen.c.
	* lib/tests/stdio/90-fread-fwrite.c: Move from scaffold/tests/93-fread-fwrite.c.
	* lib/tests/stdio/90-fseek.c: Move from scaffold/tests/91-fseek.c.
	* lib/tests/stdlib/50-getenv.c: Move from lib/tests/stdlib/getenv.c.
	* lib/tests/stdlib/50-malloc.c: Move from lib/tests/stdlib/malloc.c.
	* lib/tests/stdlib/70-strtoull.c: Move from scaffold/tests/7j-strtoull.c.
	* lib/tests/stdlib/80-qsort-dupes.c: Move from scaffold/tests/81-qsort-dupes.c.
	* lib/tests/stdlib/80-qsort.c: Move from scaffold/tests/81-qsort.c.
	* lib/tests/stdlib/90-strtol.c: Move from scaffold/tests/96-strto.c.
	* lib/tests/string/30-strlen.c: Move from scaffold/tests/30-strlen.c.
	* lib/tests/string/50-strcmp.c: Move from scaffold/tests/51-strcmp.c.
	* lib/tests/string/50-strcpy.c: Move from scaffold/tests/53-strcpy.c.
	* lib/tests/string/50-strncmp.c: Move from scaffold/tests/51-strncmp.c.
	* lib/tests/string/70-strchr.c: Move from scaffold/tests/70-strchr.c.
	* lib/tests/string/80-strncpy.c: Move from scaffold/tests/86-strncpy.c.
	* lib/tests/string/80-strrchr.c: Move from scaffold/tests/88-strrchr.c.
	* lib/tests/string/90-snprintf.c: Move from scaffold/tests/9a-snprintf.c.
	* lib/tests/string/90-strpbrk.c: Move from scaffold/tests/90-strpbrk.c.
	* lib/tests/string/90-strspn.c: Move from scaffold/tests/90-strspn.c.

2019-02-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Start test suite.
	TODO: move strict libc tests from scaffold/test/* here.

	* lib/tests/stdlib/getenv.c: New file.
	* lib/tests/stdlib/malloc.c: Move from scaffold.
	* build-aux/bootstrap.sh.in: Built them.
	* build-aux/build-mes.sh: Likewise.

2019-02-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Remove stray debugging newline output.
	* mes/module/mes/guile.mes (open-input-file): Move debugging newline
	into debug clause.

	mescc: Mes C Library: Fix brk return type compare.
	* lib/stdlib/malloc.c (malloc): Fix brk return type compare.

	core: Rename load_env to read_boot.
	* src/mes.c (read_boot): Rename from load_env; Update users.
	(open_boot): Rename from load_boot; Update users.

2019-02-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Initialize g_buf dynamically, add MES_STRING_MAX override.
	* src/mes.c (g_buf, MAX_STRING): Move from strings.c.
	(gc_init_cells): Initialize g_buf dynamically.
	(main): Add environment override MES_MAX_STRING for MAX_STRING.
	* doc/mes.texi (Environment Variables): Document it.

2019-02-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes-snarf: rewrite for development-time snarfing
	* build-aux/mes-snarf.scm (%gcc?): Remove.
	(symbol->header): Produce code for src/builtins.h.
	(symbol->source, symbol->names, function->environment): Remove.
	(snarf-symbols): Rewrite, snarf from init_symbol (...).
	(function->source): Produce code to be manually put into
	(main): Remove --mes option.

2019-02-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Resurrect POSIX build. Thanks, gio!
	* lib/libmes.c[POSIX]: Define and initialize g_stdin, g_stdout and
	g_stderr that were moved to crt1 for non-POSIX builds.
	* src/mes.c[POSIX]: Remove struct-initialisation exceptions.

2019-01-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Remove struct definitions for builtins, drop snarfing.
	After making a change to the list of builtin functions, run

	    cat src/*.i

	and move the into

	    src/mes.c:mes_builtins ()

	and, or also after changing the list of fixed symbols in src/mes.c:mes_symbols (), do

	    cat src/*.h > src/builtins.h

	* build-aux/build.sh.in: Remove snarfing.
	* build-aux/bootstrap.sh.in: Likewise.
	* mes/module/mes/display.mes (display):
	* mes/module/mes/type-0.mes (cell:type-alist): Remove <cell:function>.
	(function?, builtin?): Remove.
	* src/builtins.h: New file.
	* src/mes.c (TFUNCTION): Remove.
	(struct function): Remove.
	(apply_builtin): Rewrite from call.
	(mes_builtins): Rewrite.
	(init_builtin, make_builtin_type, make_builtin, builtin_name,
	builtin_arity, builtin, builtin_p, builtin_printer): New function.

2019-01-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Remove struct definitions for cells, drop snarfing for symbols.
	* src/mes.c (init_symbol): New function.
	(mes_symbols): Use it.
	(scm_nil, ... scm_test): Remove.

2018-12-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Add take-while.
	* mes/module/srfi/srfi-1.mes (take-while): New function.

2018-12-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Enhance POSIX command-line support, e.g. -DFOO=1.
	* module/mescc.scm (unclump-single): New function.
	(main): Use it to support -DFOO=bar, and equivalent.

2018-12-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Support running out-of-tree.
	* build-aux/pre-inst-env.in (MES_PREFIX): Use absolute name.

	core: Remove string debugging.
	* src/strings.c (make_bytes, make_string, string_equal_p,
	symbol_to_string, symbol_to_keyword, make_symbol): Remove string
	debugging.

	core: Remove --dump, --load.
	* mes/module/mes/boot-0.scm.in (tty?): Remove --dump, --load.
	* src/mes.c (bload_env): Remove.
	* src/reader.c (dump): Remove.

2018-12-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Post-release update.
	* doc/announce/ANNOUNCE-0.19: Update.

	Release 0.19.
	* configure (VERSION): Update to 0.19.
	(main): Likewise.
	* configure.sh (VERSION): Likewise.
	* guix/git/mes.scm (mes, mes.git): Likewise.

2018-10-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release update.
	* AUTHORS: Update.
	* HACKING: Update.
	* NEWS: Update.
	* doc/mes.guix: Update.
	* scripts/mescc.in: Update.
	* mes/module/mes/boot-0.scm.in: Update.
	* doc/announce/ANNOUNCE-0.19: New file.

2018-12-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: assq-ref, assoc-ref: Support alist == #f.
	* mes/module/mes/scm.mes (assq-ref): Support alist == #f.
	(assoc-ref): Likewise.

	core: Bump MAX_STRING to 524288
	* src/strings.c (MAX_STRING): Bump to 524288.
	(assert_max_string): New function.
	(list_to_cstring, string_append, read_string): Use it.
	* src/reader.c (reader_read_string): Use it.

2018-12-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support Bash: Add getppid.
	* lib/linux/gnu.c (getppid): New function.
	* include/linux/x86/syscall.h (SYS_getppid): New macro.
	* include/linux/x86_64/syscall.h (SYS_getppid): New macro.

	mescc: Support bash: Add sigdelset stub.
	* lib/stub/sigdelset.c (sigdelset): New stub.
	* lib/libc+gnu.c: Include it.

2018-12-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: getcwd: Support getcwd (0, 0) GNU extension.
	* lib/linux/libc.c (_getcwd): Rename from getcwd.
	(_getcwd): New function.  Support getcwd (0, 0) GNU extension.

2018-12-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Replace \r in comments.
	* module/mescc/compile.scm (ast->comment): Replace \r in comments.

2018-11-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Support building with Gash.
	* build-aux/install.sh: Replace variables with substitution.
	* build-aux/bootstrap.sh: New file.
	* configure: Substitute it.
	* configure.sh: Likewise.  Be friendly to Gash.
	* .gitignore: Ignore it.

2018-11-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Run without shell.
	* mes/module/mescc.mes: New file.
	* module/mescc.scm: Include it.
	* scripts/mescc.scm.in: New file.
	* scripts/mescc.in: Use it; Make pure shell.
	* configure: Substitute it.
	* configure.sh: Substitute it.
	* build-aux/install.sh.in: Install it.

2018-11-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Add string-ref.
	* src/strings.c (string_ref): New function.
	* mes/module/mes/scm.mes (string-ref): Remove.

	core: Add string-length.
	* src/strings.c (string_length): New function.
	* mes/module/mes/scm.mes (string-length): Remove.

	core: Add string-append.
	* src/strings.c (string_append): New function.
	* mes/module/mes/boot-0.scm.in (string-append): Remove.
	* mes/module/mes/boot-03.scm (string-append): Remove.
	* scaffold/boot/50-make-string.scm (string-append): Remove.
	* scaffold/boot/50-string-append.scm (string-append): Remove.
	* scaffold/boot/50-string-join.scm (string-append): Remove.
	* scaffold/boot/51-module.scm (string-append): Remove.
	* scaffold/boot/52-define-module.scm (string-append): Remove.
	* tests/macro.test (string-append): Remove.
	* scaffold/boot/17-string-append.scm: Move from 50-string-append.scm.

2018-11-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: String as array of bytes.
	* src/strings.c: New file.
	* src/mes.c: Use it.  Update users.

2018-11-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Move mecmp to libc.
	* lib/libc.c: Include mecmp.c.
	* lib/libc+tcc.c: Remove mecmp.c include.

2018-11-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Move memchr to libc.
	* lib/libc.c: Include memchr.c.

	test: Use write instead of display.
	* module/mes/test.scm (seq?, sequal?, seq2?, sless?, sequal2?): Use
	write for expected, actual.

2018-11-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: struct_set_: Oops typo.
	* src/struct.c (struct_set_x_): Oops, remove indirection.

	mes: Remove copy of make-string.
	* mes/module/mes/guile.mes (make-string): Remove copy.

	mescc: Compile fixes.
	* include/libmes-mini.h[WITH_GLIBC]: Do not declare strlen, write, types.

2018-11-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Oops, %moduledir debug info.
	* mes/module/mes/boot-0.scm.in: Oops, %moduledir debug info.

	build: configure: Support Mes.
	* configure: Support Mes.

	mes; Add read-line.
	* mes/module/mes/guile.mes (read-line): New function.

	mes: dirname: Fix for absolute file names.
	* mes/module/mes/guile.mes (dirname): Fix absolute files.

	mes: Add file-exists?.
	* mes/module/mes/guile.mes (file-exists?): New function.

	mes: Add with-error-to-file.
	* mes/module/mes/guile.mes (with-error-to-file): New function.

	mes: Add string-downcase, string-upcase, string-tokenize.
	* mes/module/srfi/srfi-13.mes (string-downcase, string-upcase,
	string-tokenize): New function.

	mes: Add char-downcase, char-upcase.
	* mes/module/srfi/srfi-14.mes (char-downcase, char-upcase): New
	function.

	mes: Add char-set:digit, char-set:lower-case, char-set:upper-case.
	* mes/module/srfi/srfi-14.mes (char-set:digit, char-set:lower-case,
	char-set:upper-case): New variable.

	mes: Add char-set-adjoin, char-set-complement.
	* mes/module/srfi/srfi-14.mes (char-set-adjoin, char-set-complement):
	New function.

	mes: system*: Support redirection.
	* mes/module/mes/posix.mes (system*): Support redirection.

	core: read_string: Allow for gc.
	* src/posix.c (read_char): Add optional port parameter.
	(read_string): Allow for gc.

	core: Add delete_file.
	* src/posix.c (delete_file): New function.

	core: Add dup, dup2.
	* src/posix.c (dup_, dup2_): New function.

	core: Add getcwd.
	* src/posix.c (getcwd_): New function.

	core: Support redirection of stderr.
	* include/libmes-mini.h (g_stderr): New global.
	* lib/mes/eputc.c (eputc): Use it.
	* lib/mes/eputs.c (eputs): Likewise.
	* lib/mes/oputc.c (oputc): Likewise.
	* lib/mes/oputs.c (oputs): Likewise.
	* src/lib.c (display_error_, write_error_): Likewise.
	* src/posix.c (write_byte): Likewise.
	* src/mes.c (mes_builtins): Likewise.
	(main): Iniitalize g_stderr.
	* src/posix.c (current_error_port, set_current_error_port): New
	function.
	* mes/module/mes/boot-0.scm.in (current-output-port,
	current-error-port): Remove.

	core: Assert g_free in alloc.
	* src/mes.c (alloc): Assert g_free.

	mescc: unlink: Move to libc.
	* lib/linux/libc.c (unlink): New function.
	* lib/linux/tcc.c (unlink): Remove.

	mescc: dup, dup2: Move to libc.
	* lib/linux/libc.c (dup, dup2): New function.
	* lib/linux/gnu.c (dup, dup2): Remove.

	mescc: getcwd: Move to libc.
	* lib/linux/libc.c (getcwd): New function.
	* lib/linux/tcc.c (getcwd): Remove.

2018-11-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support GNU make with POSIX.
	* include/linux/x86/syscall.h (SYS_sigprocmask): New macro.
	* include/linux/x86_64/syscall.h (SYS_rt_sigprocmask): New macro.
	* include/signal.h (SIG_BLOCK, SIG_UNBLOCK, SIG_SETMASK): New macro.
	(sigprocmask): Declare.
	* lib/linux/gnu.c (sigprocmask): New function.

2018-11-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support GNU Bash.
	* include/errno.h (EACCES, ENOSPC, ESPIPE): New macro.
	* include/linux/x86/syscall.h (SYS_setuid, SYS_geteuid, SYS_getegid,
	SYS_setgid): New macro.
	* include/linux/x86_64/syscall.h: Likewise.
	* include/stdint.h (LLONG_MIN, LLONG_MAX, SIZE_MAX): New macro.
	* include/sys/stat.h (S_ISUID, S_ISGID, S_IXGRP, S_IXOTH, S_IRGRP,
	S_IROTH, S_IWGRP, S_IWOTH, S_IRWXG, S_IRWXO): New macro.
	* include/termio.h: New file.
	* include/unistd.h (_POSIX_VERSION): New macro.
	* lib/linux/gnu.c (geteuid, getegid, setuid, setgid): New function.
	* lib/string/memchr.c: New file.
	* lib/stub/getpwuid.c: New file.
	* lib/stub/rand.c: New file.
	* lib/stub/ttyname.c: New file.
	* include/string.h (memchr): Declare.
	* include/unistd.h (geteuid, getegid, setuid, setgid): Declare.

2018-11-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Simplify: cater for one compiler at a time.
	* build-aux/build-cc.sh: Remove.
	* build-aux/build-cc32.sh: Remove.
	* build-aux/build-cc64.sh: Remove.
	* build-aux/build-x86_64-mes.sh: Remove.
	* build-aux/cc-mes.sh: Remove.
	* build-aux/cc-x86_64-mes.sh: Remove.
	* build-aux/cc32-mes.sh: Remove.
	* build-aux/cc64-mes.sh: Remove.
	* build-aux/test64.sh: Remove.
	* build-aux/bootstrap-mes.sh: New file.
	* build-aux/config.make.in: New file.
	* build-aux/config.status.in: New file.
	* build-aux/test-cc.sh: New file.
	* .gitignore: Update.
	* build-aux/GNUmakefile.in: Update.
	* build-aux/build-guile.sh: Update.
	* build-aux/build-mes.sh: Update.
	* build-aux/build.sh.in: Update.
	* build-aux/cc.sh: Update.
	* build-aux/check-boot.sh: Update.
	* build-aux/check-mes.sh: Update.
	* build-aux/check-mescc.sh: Update.
	* build-aux/check-tcc.sh: Update.
	* build-aux/check.sh.in: Update.
	* build-aux/config.sh: Update.
	* build-aux/export.make: Update.
	* build-aux/install.sh.in: Update.
	* build-aux/pre-inst-env.in: Update.
	* build-aux/test.sh: Update.
	* build-aux/uninstall.sh.in: Update.
	* configure: Update.
	* configure.sh: Update.
	* module/mescc/i386/as.scm: Update.
	* module/mescc/preprocess.scm: Update.
	* module/mescc/x86_64/as.scm: Update.
	* scripts/mescc.in: Update.
	* tests/psyntax.test: Update.

2018-11-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Add missing define.
	* lib/x86-mes/x86.M1: Add missing define.

2018-11-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Exit if library cannot be found.
	* module/mescc/mescc.scm (arch-find): Exit upon failure.

	mescc: Accept -O, --std, -x.
	* scripts/mescc.in (parse-opts): Accept -O, --std, -x.

	mescc: Support -dumpmachine.
	* scripts/mescc.in (parse-opts): Support -dumpmachine.

2018-10-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: vsnprintf: Compliant implementation.
	* lib/stdio/vsnprintf.c (vsnprintf): New, complient implementation,
	replacing vsnprint.
	* lib/stdio/vsprintf.c (vsnprint): Forward to vsnprint.
	* lib/stdio/snprintf.c (snprintf): Likewise.
	* scaffold/tests/9a-snprintf.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

2018-10-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Add performance test.
	* module/mes/test.scm (pass-if-timeout): New macro.
	* tests/perform.test: New test.
	* build-aux/check-mes.sh (tests): Run it.

	mes: Add ceil, floor, round, inexact->exact.
	* mes/module/mes/scm.mes (ceil, floor, round, inexact->exact,
	exact->inexact): New function.

	mes: read-string: Take optional port argument.
	* src/posix.c (read_string): Take optional port argument.
	* mes/module/mes/guile.mes (read-string): Remove.

	core: eval_apply: Order gotos according to frequency.
	* src/mes.c (eval_apply): Order gotos according to frequency.

	Revert "core: eval_apply profile."
	This reverts commit d61e6be0b18459a8e3c262eab448b428dc81937a.

	core: eval_apply profile.
	* src/mes.c: Poor man's eval_apply profile.

2018-10-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Fix displaying of closure.
	* src/lib.c (display_helper): Fix displaying of closure.

	mes: Print backtrace upon exception.
	* mes/module/mes/catch.mes (display-backtrace,
	frame-function): New function.
	(%eh): Use them.

	core: Set procedure in stack frame.
	* src/mes.c (eval_apply): Set procedure in stack frame.

	core: Implement stack and frame.
	* src/lib.c (frame_printer make_frame_type, make_frame,
	make_stack_type, make_stack, stack_length, stack_ref): New function.

	core: Support time functions.
	* lib/linux/clock_gettime.c: New file, move from gnu.c.
	* lib/linux/gettimeofday.c: New file, move from tcc.c.
	* lib/linux/time.c: New file, move from tcc.c.
	* lib/linux/libc.c: Include them.
	* lib/linux/gnu.c (clock_gettime): Remove.
	* lib/linux/tcc.c (time, gettimeofday): Remove.
	* include/time.h (CLOCK_PROCESS_CPUTIME_ID): New define.
	* src/posix.c (init_time, current_time, gettimeofday_,
	seconds_and_nanoseconds_to_long, get_internal_run_time): New function.
	* src/mes.c (scm_symbol_internal_time_units_per_second): New symbol.
	(main): Call init_time.

2018-10-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Use hash table for symbols.
	* src/mes.c (mes_symbols): Use hash table for symbols.  Update users.

2018-10-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Use assert before failure exit.
	* src/mes.c (error): Use assert before failure exit.  Helps debugging.

2018-10-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Add hashq_get_handle, hash, hash_ref, hash_set_x.
	* src/mes.c (scm_symbol_hashq_table, scm_symbol_record_type,
	scm_symbol_module, scm_symbol_buckets, scm_symbol_size): New symbols.
	Update users.
	* src/hash.c (hash_list_of_char): Rename from hashq_.  Respect size,
	update callers.
	(hashq_, hash_ hash, hashq_get_handle, hash_ref, hash_set_x_,
	hash_set_x): New function.
	(hashq_ref): Do not return handle.  Update callers.

	mes: Move pair? to core.
	* src/lib.c (pair_p): New function.  Gains 8% performance on MesCC.

2018-10-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Move assoc to core.
	* mes/mes.c (assoc_string, assoc): New function.
	* mes/module/mes/scm.mes (assoc): Remove.  Gains 12% performance for
	MesCC.

2018-10-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "core: Add gc-debug for stack array."
	This reverts commit f35084d1dbea889d107824e7596da1701c6b90ad.

2018-10-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Add gc-debug for stack array.
	* src/gc.c (gc_debug): New function.

	scaffold: Resurrect mini-mes.
	* src/mini-mes.c: Resurrect.

2017-12-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Use array-based stack.
	* src/mes.c (STACK_SIZE)[MES_ARRAY_STACK]: New variable.
	(g_stack_array): New variable.
	(g_stack): Change type to SCM*.
	(gc_push_frame)[MES_ARRAY_STACK]: Use g_stack_array, g_stack.
	(gc_peek_frame): Likewise.
	(gc_pop_frame): Likewise.
	* src/gc.c (gc_check): Likewise.
	(gc): Likewise.

2018-10-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Resurrect Guile-1.8 support.
	* module/mes/mes-0.scm: Resurrect Guile-1.8 support.

2018-10-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: expand_variable: Remove weird exceptions: begin, if.
	* src/mes.c (expand_variable_): Remove weird exceptions: begin, if.

2018-10-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Switch to srfi-9 based on structs.
	* mes/module/srfi/srfi-9.mes: Swap symlink to srfi-9-struct.mes.
	* mes/module/srfi/srfi-9/gnu.mes: Swap symlink to gnu-struct.mes.
	* src/module.c (make_module_type): Update to match srfi-9-struct
	records.  Update users.
	* src/hash.c (make_hashq_type): Likewise.

	mes: srfi-9: Add implementation based on struct.
	* mes/module/srfi/srfi-9-struct.mes: New file.
	* mes/module/srfi/srfi-9-vector.mes: Rename from srfi-9.mes
	* mes/module/srfi/srfi-9.mes: Symlink to srfi-9-vector.mes.
	* mes/module/srfi/srfi-9/gnu-struct.mes: Add srfi-9-struct
	implementation.
	* mes/module/srfi/srfi-9/gnu-vector.mes: Rename from gnu.mes.
	* mes/module/srfi/srfi-9/gnu.mes: Symlink to gnu-vector.mes.

	core: hashq-table: Refactor to be a record-like struct.
	* src/hash.c (hash_table_printer): New function.
	(make_hashq_type): New function.
	* src/module.c (module_printer): Use it.
	(make_module_type): New function.
	(make_initial_module): Use them.

	mescc: Mes C Library: oputs: New function.
	* lib/mes/oputc.c: New file.
	* lib/libmes.c: Include it.
	* include/libmes.h: Declare it.

	core: Use hashq-table for macros.
	* src/mes.c (lookup_macro_): Remove.
	(macro_ref, get_macro, macro_set_x): New function.  Update callers.

	core: Add hashq-table type.
	src/hash.c: New file.
	src/module.c (char_hash, module_hash): Remove.
	* src/module.c (make_initial_module): Use hash primitives.
	(module_define_x): Likewise.
	(module_variable): Likewise.
	* build-aux/snarf.sh: Snarf it.
	* src/mes.c: Include it.

	core: Add boot-module.
	* src/mes.c (scm_symbol_boot_module): New symbol.
	(eval_apply): Handle it.
	(mes_symbols): Initialize it.

2018-10-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Add module-define!
	* src/module.c (module_define_x, module_printer): New function.
	(make_initial_module): Use them.
	* tests/srfi-0.test: Test it.
	* src/mes.c (display_m0): Remove.  Update callers.
	* mes/module/mes/fluids.mes (make-fluid): Rewrite.
	* tests/macro.test: Test it.
	* mes/module/mes/boot-0.scm.in (module-define!): Remove.
	* mes/module/mes/boot-02.scm: Likewise.
	* module/mes/misc.scm (pk, warn): New function.
	* build-aux/check-mes.sh (tests): Run tests.

	core: Add module indirection for variable lookup.
	* src/module.c (module_ref, module_variable): New function.
	* src/mes.c: Thoughout: Use them.
	(assq_ref_env): Remove.
	* mes/module/mes/boot-0.scm.in (defined?): Use module-variable.
	* mes/module/mes/boot-00.scm (defined?): Likewise.
	* mes/module/mes/boot-01.scm (defined?): Likewise.
	* mes/module/mes/boot-02.scm (defined?): Likewise.
	* scaffold/boot/53-closure-display.scm: Likewise.

	core: Add module type.
	* src/module.c: New file.
	* build-aux/snarf.sh: Snarf it.
	* src/mes.c: Include it.

	core: Add cstring_to_symbol.
	* src/mes.c (make_symbol): Rename from lookup_symbol_.  Update
	callers.
	(cstring_to_symbol): New function.
	* src/reader.c (reader_read_identifier_or_number): Use it.

2018-10-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Add struct type.
	* src/struct.c: New file.
	* build-aux/snarf.sh: Snarf it.
	* src/mes.c: Include it.

2018-10-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: factor-out snarfing.
	* build-aux/snarf.sh: New file.
	* build-aux/build-cc.sh: Use it.
	* build-aux/build-cc32.sh: Likewise.
	* build-aux/build-cc64.sh: Likewise.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/build-x86_64-mes.sh: Likewise.
	* build-aux/snarf.sh: Likewise.

	core: core:cdr: Support port type.
	* src/mes.c (cdr_): Support port type.
	* mes/module/mes/display.mes (display): Add space between fields.

	mes: with-fluids: Fix reset.
	* mes/module/mes/fluids.mes (with-fluids): Fix reset.
	* tests/fluids.test (report): Remove Mes failure expectation.

2018-10-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Recognize U integer suffix.
	* module/mescc/compile.scm (cstring->int): Recognize U integer
	suffix.  Thanks, Peter de Wachter!

2018-10-16  Peter De Wachter  <pdewacht@gmail.com>

	mescc: Add INTn_MIN/MAX defines to stdint.h.
	* include/stdint.h: Add INTn_MIN/MAX defines.  Move integere size
	defines from limits.h
	* include/limits.h: Include it.

2018-10-16  Peter De Wachter  <pdewacht@gmail.com>

	mescc: Allow superfluous parentheses in function declarations.
	E.g.:  int (f)();
	This is obscure but valid C.  It occurs in the csmith headers (thanks
	to macro shenanigans).

	* module/mescc/compile.scm (fctn-defn:get-name,
	fctn-defn:get-statement): Allow superfluous parentheses in function declarations.

2018-10-16  Peter De Wachter  <pdewacht@gmail.com>

	mescc: Implement unary plus operator.
	* module/mescc/compile.scm (ast->type, expr->register,
	try-expr->number):): Implement unary plus operator.

	mescc: Add missing assembly defines.
	* lib/x86-mes/x86.M1: Add missing assembly defines.
	* lib/x86_64-mes/x86_64.M1: Likewise.

	mescc: Delete duplicate assembly defines.
	* lib/x86-mes/x86.M1: Delete duplicate assembly defines.
	* lib/x86_64-mes/x86_64.M1: Likewise.

2018-10-16  Peter De Wachter  <pdewacht@gmail.com>

	mescc: Exit with non-zero exit code when subprocess fails.
	system* returns the result of waitpid. So, suppose that a subprocess
	fails with exit code 1. Then the waitpid return value will be 256.
	And exit(256) is equivalent to exit(0).

	Modified-by: Jan Nieuwenhuizen <janneke@gnu.org>

	* mes/module/mes/posix.mes (status:exit-val): New function.
	* module/mescc/mescc.scm (assert-system*): Use it.

2018-10-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Oops typo.
	* module/mescc/M1.scm (hex2:immediate8): Typo.

2018-12-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Support \xNN in reader.  Fixes tcc-boot running on Mes.
	* src/reader.c (reader_read_string): Support \xNN.  Fixes Guix
	bootstrap chain; i.e., compilation of gcc-2.95.3 using tcc-boot.
	* tests/base.test ("reader: \\x08"): Test it.
	* scaffold/tests/17-compare-char.c: Likewise, for mescc.
	* build-aux/check-mescc.sh (tests): Run it.

2018-11-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: configure: Make dot optional.
	* configure: Make dot optional.

2018-10-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Oops, remove stray lib/linux/x86_64-mes/crt1.
	* lib/linux/x86_64-mes/crt1: Remove.

2018-10-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: x86_64 bootstrap build fixes and workaround.
	* configure: Substitute @arch@ (WAS: ARCH).  Update users.
	* configure.sh: Substitute @arch@.
	* build-aux/build-mes.sh: Use $GUILE for x86_64 build.
	* build-aux/install.sh.in: Install mes.S, mes.x86_64-mes-S too.
	Prune *.E, *.out.

2018-10-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release update.

	mescc: Oops, delete wrong line of assembly.
	* lib/x86-mes/x86.M1 (movzbl_%bx,%ebx): Delete wrong line.  Thanks, pdewacht!

2018-10-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	admin: Release update.
	* doc/announce/ANNOUNCE-0.18: New file.
	* guix/git/mes.scm (mes): Update hash.

2018-10-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.18.
	* configure (VERSION): Update to 0.18.
	(main): Likewise.
	* configure.sh (VERSION): Likewise.
	* guix/git/mes.scm (mes, mes.git): Likewise.
	* guix/mescc-tools-boot.patch: New file.

2018-09-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release update.
	* BOOTSTRAP: Update.
	* HACKING: Update.
	* NEWS: Update.
	* README: Update.
	* doc/mes.texi (Submitting Patches): Fix misquoting, misattribution.

2018-10-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Another attempt at divide.
	* module/mescc/i386/as.scm (i386:r0/r1): Never be signed.  Use div for unsigned.
	(i386:r0%r1): Likewise.
	* module/mescc/x86_64/as.scm (x86_64:r0/r1): Likewise.
	(x86_64:r0%r1): Likewise.
	* lib/x86-mes/x86.M1: Add div.
	* lib/x86_64-mes/x86_64.M1: Likewise.

	tests: Expect srfi-13 failure, MesCC more resembles Gcc.
	* tests/srfi-13.test (report): Expect INT-MIN failure for x86.

2018-10-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: reader: Support 64 bit.
	* src/reader.c (reader_read_identifier_or_number): Support 64 bit.
	(reader_read_binary): Likewise.
	(reader_read_octal): Likewise.
	(reader_read_hex): Likewise.

	mescc: Mes C Library: Fix execve on x86_64.
	* include/linux/x86_64/syscall.h (SYS_execve): Typo.  Fixes execve on
	x86_64.

	build: Support make seed for x86_64.
	* build-aux/GNUmakefile.in (seed): Support make seed for x86_64.
	* build-aux/build-mes.sh[SEED]: Also build src/mes.S.
	* build-aux/build-x86_64-mes.sh[SEED]: Also build src/mes.x86_64-mes.S.

	mes: Support fold-right 3.
	* mes/module/srfi/srfi-1.mes (fold-right): Support fold-right 3.
	* tests/srfi-1.test ("fold-right-3"): Test it.

	mescc: Nyacc comment escapes.
	* module/mescc/compile.scm (ast->comment): Nyacc comment escapes.

	mescc: Fix clobbering of struct by value assign.
	* module/mescc/x86_64/as.scm (long-r0->r1-mem): New instruction.
	* module/mescc/i386/as.scm: Likewise.
	* lib/x86_64-mes/x86_64.M1: Support it.
	* module/mescc/compile.scm (r0->r1-mem*n-): Fix clobbering.

	core: Add vector test.
	* scaffold/boot/11-vector.scm: New test.
	* build-aux/check-boot.sh: Run it.

	mescc: Fix obnoxious assignment ERROR message.
	* module/mescc/compile.scm (expression->register): Fix assignment
	ERROR message.

	core: Avoid 64bit zero divide.
	* src/math.c (divide): Avoid (64bit) 0 divide.
	(modulo): Likewise.

	mescc: Support negative divide.
	* module/mescc/i386/as.scm (i386:r0/r1, i386:r0%r1): Support
	negative divide.
	* module/mescc/x86_64/as.scm (x86_64:r0/r1, x86_64:r0%r1): Likewise.
	* lib/x86-mes/x86.M1: Likewise.
	* lib/x86_64-mes/x86_64.M1: Likewise.
	* scaffold/tests/a0-math-divide-signed-negative.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

	mescc: Support --align, off by default.
	* scripts/mescc.in (parse-opts): Add --align.
	* module/mescc/mescc.scm (mescc:compile): Support --align, off by
	default.
	* module/mescc/M1.scm (infos->M1): Add #:align parameter.
	(M1:merge-infos): Likewise.  Keep types.
	(info->M1): Likewise.  Make alignment switchable.
	* module/mescc/compile.scm (r->ident):  Do not clobber.
	(ident-add): Likewise.
	(clean-info): Keep types.
	* module/mescc/i386/as.scm (i386:r->byte-label): New instruction.
	* lib/x86-mes/x86.M1: Add instructions.
	* lib/x86_64-mes/x86_64.M1: Add instructions.
	* module/mescc/x86_64/as.scm (x86_64:r->byte-label,
	x86_64:r->word-label, x86_64:r->long-label): New instruction.

	Revert "mescc: Make globals at least reg-size."
	This reverts commit 30544316c35ed4a2472f2029beb27e007d913792.

	mescc: Make globals at least reg-size.
	* module/mescc/compile.scm (global->info): Make globals at least reg-size.

	mescc: Support 64-bit immediates.
	* module/mescc/M1.scm (hex2:address8, hex2:immediate8): New function.
	(info->M1): Support 64-bit.
	* module/mescc/compile.scm (convert-r0): FIXME!
	* module/mescc/x86_64/as.scm (x86_64:value->r, x86_64:r->local,
	x86_64:label->arg, x86_64:label->r, x86_64:r+value,
	x86_64:r-cmp-value, x86_64:r-long-mem-add, x86_64:r-and): Support
	64-bit immediates.
	* lib/x86_64-mes/x86_64.M1: Likewise.
	* scaffold/tests/17-compare-unsigned-char-le.c: Test it.
	* scaffold/tests/17-compare-unsigned-short-le.c: Test it.
	* build-aux/check-mescc.sh (tests): Run them.

	core: Use proper name for %compiler.
	* src/mes.c (mes_symbols, bload_env): : Use proper name for %compiler.

	core: Resurrect MES_MINI for non-POSIX.
	src/mes.c[MES_MINI,!POSIX]: Resurrect.

	mescc: Mes C Library: Add ultoa.
	* lib/mes/ultoa.c: New file.
	* lib/libmes.c: Include it.
	* include/libmes.h: Declare ultoa.

	mescc: Mes C Library: Add ltoa.
	* lib/mes/ltoa.c: New file.
	* lib/libmes.c: Include it.
	* include/libmes.h: Declare ltoa.

	mescc: Fix truncation of short.
	* module/mescc/compile.scm (convert-r0): Typo.  Fixes truncation of
	short.  Thanks, pdewacht!
	* scaffold/tests/a0-call-trunc-char.c: New file.
	* scaffold/tests/a0-call-trunc-short.c: New file.
	* build-aux/check-mescc.sh: Add them.

	build: Split-off x86_mes-gcc build.
	* build-aux/build-cc64.sh: New file.
	* build-aux/build.sh.in[CC64]: Invoke it.
	* build-aux/build-cc.sh: Remove x86_64-mes-gcc build.
	* build-aux/GNUmakefile.in (x86_64-mes-gcc): New target.
	* build-aux/build-x86_64-mes.sh: Build all scafffold files.

2018-10-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Oops, use MES_LIBS.
	* build-aux/build-x86_64-mes.sh: Use MES_LIBS instead of the unused
	MES64_LIBS.  Fixes build.  Thanks, pdewacht!

	build: remove bashism.
	* build-aux/trace.sh (trace): Remove bashism.  Thanks pdewacht!

2018-10-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Support x86_64.
	* src/lib.c: Support x86_64.
	* src/math.c: Likewise.
	* src/mes.c: Likewise.
	* src/reader.c: Likewise.
	* src/vector.c Likewise.

	build: Oops, set VERSION.
	* build-aux/install.sh.in (VERSION): New substituted variable.

2018-09-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Resurrect make seed.
	* build-aux/GNUmakefile.in (seed): Resurrect.
	* build-aux/build-x86_64-mes.sh: Build from seed.

2018-08-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: x86_64 support: Refactor to abstracted assembly, add x86_64.
	* module/mescc/as.scm: Support abstracted assembly.
	* module/mescc/i386/as.scm: Rewrite.
	* module/mescc/x86_64/as.scm: Implement.
	* module/mescc/compile.scm: Refactor to abstracted assembly.
	* module/mescc/M1.scm: Update for partial 64 bit support.
	* module/mescc/bytevectors.scm (bytevector-u64-native-set!): New
	procedure.
	* module/mescc/i386/info.scm (i386:type-alist): Use 4 byte type length
	also for faking double, long long, long double.
	* module/mescc/info.scm:modified:
	* module/mescc/x86_64/info.scm (x86_64:registers): New variable.
	* lib/x86-mes/x86.M1: Update for new register scheme.
	* lib/x86_64-mes/x86_64.M1: Implement.
	* lib/x86-mes/setjmp.c: Implement.
	* lib/x86_64-mes-gcc/setjmp.c: Implement.
	* build-aux/build-cc.sh: Update for x86_64.
	* build-aux/build-cc32.sh: Likewise.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/build-x86_64-mes.sh: Likewise.
	* build-aux/check-mescc.sh: Likewise.
	* build-aux/test64.sh: Likewise.
	* include/libmes.h: Likewise.
	* include/setjmp.h: Likewise.
	* include/signal.h: Likewise.
	* include/stdarg.h: Likewise.
	* include/sys/stat.h: Likewise.
	* include/sys/types.h: Likewise.
	* include/sys/wait.h: Likewise.
	* include/unistd.h: Likewise.
	* lib/libc+gnu.c: Likewise.
	* lib/libc+tcc.c: Likewise.
	* lib/linux/gnu.c: Likewise.
	* lib/linux/libc-mini.c: Likewise.
	* lib/linux/libc.c: Likewise.
	* lib/linux/tcc.c: Likewise.
	* lib/linux/x86_64-mes-gcc/mes.c: Likewise.
	* lib/linux/x86_64-mes/crt1.c: Likewise.
	* lib/mes/abtol.c: Likewise.
	* lib/posix/mktemp.c: Likewise.
	* lib/posix/wait.c: Likewise.
	* lib/stdio/fopen.c: Likewise.
	* lib/stdio/fputc.c: Likewise.
	* lib/stdio/fseek.c: Likewise.
	* lib/stdio/printf.c: Likewise.
	* lib/stdio/sprintf.c: Likewise.
	* lib/stdio/vfprintf.c: Likewise.
	* lib/stdio/vsprintf.c: Likewise.
	* lib/stdio/vsscanf.c: Likewise.
	* lib/stdlib/qsort.c: Likewise.
	* lib/x86-mes-gcc/setjmp.c: Likewise.
	* scaffold/tests/11-if-1.c: Likewise.
	* scaffold/tests/15-if-!f.c: Likewise.
	* scaffold/tests/16-if-t.c: Likewise.
	* scaffold/tests/21-char[].c: Likewise.
	* scaffold/tests/23-pointer.c: Likewise.
	* scaffold/tests/32-compare.c: Likewise.
	* scaffold/tests/33-and-or.c: Likewise.
	* scaffold/tests/34-pre-post.c: Likewise.
	* scaffold/tests/35-compare-char.c: Likewise.
	* scaffold/tests/36-compare-arithmetic.c: Likewise.
	* scaffold/tests/37-compare-assign.c: Likewise.
	* scaffold/tests/38-compare-call.c: Likewise.
	* scaffold/tests/40-if-else.c: Likewise.
	* scaffold/tests/41-?.c: Likewise.
	* scaffold/tests/42-goto-label.c: Likewise.
	* scaffold/tests/43-for-do-while.c: Likewise.
	* scaffold/tests/44-switch.c: Likewise.
	* scaffold/tests/45-void-call.c: Likewise.
	* scaffold/tests/46-function-static.c: Likewise.
	* scaffold/tests/51-strcmp.c: Likewise.
	* scaffold/tests/51-strncmp.c: Likewise.
	* scaffold/tests/53-strcpy.c: Likewise.
	* scaffold/tests/54-argv.c: Likewise.
	* scaffold/tests/60-math.c: Likewise.
	* scaffold/tests/61-array.c: Likewise.
	* scaffold/tests/63-struct-cell.c: Likewise.
	* scaffold/tests/64-make-cell.c: Likewise.
	* scaffold/tests/65-read.c: Likewise.
	* scaffold/tests/70-printf.c: Likewise.
	* scaffold/tests/71-struct-array.c: Likewise.
	* scaffold/tests/72-typedef-struct-def.c: Likewise.
	* scaffold/tests/74-multi-line-string.c: Likewise.
	* scaffold/tests/76-pointer-arithmetic.c: Likewise.
	* scaffold/tests/79-int-array.c: Likewise.
	* scaffold/tests/7a-struct-char-array.c: Likewise.
	* scaffold/tests/7b-struct-int-array.c: Likewise.
	* scaffold/tests/7i-struct-struct.c: Likewise.
	* scaffold/tests/7k-for-each-elem.c: Likewise.
	* scaffold/tests/7l-struct-any-size-array.c: Likewise.
	* scaffold/tests/7o-struct-pre-post.c: Likewise.
	* scaffold/tests/7q-bit-field.c: Likewise.
	* scaffold/tests/7s-struct-short.c: Likewise.
	* scaffold/tests/80-setjmp.c: Likewise.
	* scaffold/tests/81-qsort.c: Likewise.
	* scaffold/tests/85-sizeof.c: Likewise.
	* scaffold/tests/87-sscanf.c: Likewise.
	* scaffold/tests/90-strpbrk.c: Likewise.
	* scaffold/tests/91-fseek.c: Likewise.
	* scaffold/tests/95-signal.c: Likewise.
	* scaffold/tests/97-fopen.c: Likewise.
	* scaffold/tests/99-readdir.c: Likewise.
	* scaffold/tests/t.c: Likewise.
	* lib/linux/x86_64-mes/mes.c: New file.
	* lib/linux/x86_64-mes/mini.c: New file.
	* lib/x86_64-mes/setjmp.c: New file.
	* scaffold/tests/06-!call-1.c: New file.
	* scaffold/tests/06-call-2.c: New file.
	* scaffold/tests/06-call-variable.c: New file.
	* scaffold/tests/08-assign-global.c: New file.
	* scaffold/tests/08-assign-negative.c: New file.
	* scaffold/tests/17-compare-and-or.c: New file.
	* scaffold/tests/17-compare-and.c: New file.
	* scaffold/tests/17-compare-ge.c: New file.
	* scaffold/tests/17-compare-gt.c: New file.
	* scaffold/tests/17-compare-le.c: New file.
	* scaffold/tests/17-compare-lt.c: New file.
	* scaffold/tests/17-compare-or.c: New file.
	* scaffold/tests/17-compare-unsigned-ge.c: New file.
	* scaffold/tests/17-compare-unsigned-gt.c: New file.
	* scaffold/tests/17-compare-unsigned-le.c: New file.
	* scaffold/tests/17-compare-unsigned-lt.c: New file.
	* scaffold/tests/21-char[]-simple.c: New file.
	* scaffold/tests/23-global-pointer-init-null.c: New file.
	* scaffold/tests/23-global-pointer-init.c: New file.
	* scaffold/tests/23-global-pointer-pointer-ref.c: New file.
	* scaffold/tests/23-global-pointer-ref.c: New file.
	* scaffold/tests/23-pointer-sub.c: New file.
	* scaffold/tests/31-oputs.c: New file.
	* scaffold/tests/32-call-wrap.c: New file.
	* scaffold/tests/38-compare-call-2.c: New file.
	* scaffold/tests/38-compare-call-3.c: New file.
	* scaffold/tests/51-pointer-sub.c: New file.
	* scaffold/tests/54-argc.c: New file.
	* scaffold/tests/63-struct-array-assign.c: New file.
	* scaffold/tests/63-struct-array-compare.c: New file.
	* scaffold/tests/63-struct-array.c: New file.
	* scaffold/tests/63-struct-assign.c: New file.
	* scaffold/tests/63-struct-function.c: New file.
	* scaffold/tests/63-struct-local.c: New file.
	* scaffold/tests/63-struct-pointer.c: New file.
	* scaffold/tests/63-struct.c: New file.
	* scaffold/tests/70-printf-hello.c: New file.
	* scaffold/tests/70-printf-simple.c: New file.
	* scaffold/tests/70-stdarg.c: New file.
	* scaffold/tests/70-strchr.c: New file.
	* scaffold/tests/73-union-hello.c: New file.
	* scaffold/tests/76-pointer-arithmetic-pp.c: New file.
	* scaffold/tests/79-int-array-simple.c: New file.
	* scaffold/tests/7b-struct-int-array-hello.c: New file.
	* scaffold/tests/7b-struct-int-array-pointer.c: New file.
	* scaffold/tests/7i-struct-struct-simple.c: New file.
	* scaffold/tests/7k-for-each-elem-simple.c: New file.
	* scaffold/tests/7l-struct-any-size-array-simple.c: New file.
	* scaffold/tests/7o-struct-pre-post-simple.c: New file.
	* scaffold/tests/7q-bit-field-simple.c: New file.
	* scaffold/tests/90-strspn.c: New file.
	* scaffold/tests/06-call-string.c.: Rename from 31-eputs.c.
	* scaffold/tests/7t-function-destruct.c: Rename from 48-function-destruct.c.
	* scaffold/tests/48-global-static.c: Rename from 49-global-static.c.
	* scaffold/tests/55-char-array.c:renamed: Rename from 4a-char-array.c.
	* scaffold/tests/51-itoa.c:r Rename from 52-itoa.c.
	* include/signal.h:(struct sigaction):

	mescc: x86_64 support: Add tests.

2018-08-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Initial x86_64 support.
	    make all-go && MES=guile ./pre-inst-env scripts/mescc -m64 -c scaffold/main.c

	mescc: Prepare for x86_64 support.
	* module/mescc/info.scm (info): Add allocated, registers.
	* module/mescc/i386/info.scm: New file.
	* build-aux/build-guile.sh (SCM_FILES): Add it.
	* module/mescc/compile.scm (c99-input->info): Add info parameter.
	(c99-ast->info): Likewise.
	(i386:type-alist): Remove.
	(alloc-register, free-register): New function.
	(expr->register*): Rename from expr->accu*.  Update callers.
	(expr->accu): Rename from expr->accu.  Update callers.
	* module/mescc/mescc.scm(%info): New variable.
	* module/mescc/mescc.scm (c->ast): Use it.
	(mescc:compile): Likewise.
	(E->info): Likewise.

2018-09-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	emacs: Add disassembly helpers.
	* .dir-locals.el (as-32, as-64): Add disassembly helpers.

2018-09-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: nyacc-for-mes: Update to 0.86.0.
	* guix/git/mes.scm (nyacc-for-mes): Update to 0.86.0 plus fix binary
	literals.

	mescc: Support gcc-3.0: Locale header fix.
	* include/locale.h (LC_ALL, LC_NUMERIC): Numbers, not strings.
	(LC_COLLATE, LC_CTYPE): New macro.

2018-09-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Oops, fix ./check.sh for bootstrap build.
	* build-aux/config.sh (top_builddir): Set default to `.'.

2018-09-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: nyacc-for-mes: Update to 0.85.3.
	* guix/git/mes.scm (nyacc-for-mes): Update to 0.85.3.

	mes: Support Nyacc 0.85.3: Integrate progress.
	* mes/module/nyacc/lang/sx-util.mes: New file.
	* mes/module/nyacc/version.mes: New file.
	* mes/module/nyacc/lang/c99/cpp.mes (nyacc): Include them.
	* mes/module/nyacc/lang/c99/parser.mes (nyacc): Include them.
	* module/mescc/preprocess.scm (need-progress): New function.
	(progress): New function.
	(insert-progress-monitors): Use them to Integrate progress.

	mes: Support Nyacc 0.85.3: Add char-set-copy.
	* mes/module/srfi/srfi-14.mes (char-set-copy): New function>

2018-09-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Update bootstrap graph.
	* doc/images/gcc-mesboot-graph.dot: Regenerate.
	* build-aux/GNUmakefile.in (doc/mes.info): Oops change dependency to .png.
	* doc/mes.texi (The Mes Bootstrap Process): Update image and wording.

	guix: Update hash.
	* guix/git/mes.scm (mes): Update hash.

2018-09-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.17.1.
	* configure (VERSION): Update to 0.17.1.
	(main): Likewise.
	* configure.sh (VERSION): Likewise.
	* build-aux/GNUmakefile.in (gen-announce): Likewise.
	* guix/git/mes.scm (mes, mes.git): Likewise.

2018-08-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release update.
	* HACKING (prefix): Update.
	* INSTALL (http): Update.
	* NEWS: Update.
	* README (C-compiler): Update.
	* doc/announce/ANNOUNCE-0.17: Update.

2018-09-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: ALlow releasing from worktree.
	* build-aux/GNUmakefile.in (COMMIT): Check for .git file.

2018-09-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Do not redefine size_t.
	* include/stddef.h: Do not redefine size_t.

2018-08-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support make 3.80: Add setlocale, sigaddset.
	* include/limits.h (ULONG_MAX): New macro.
	* include/locale.h (LC_ALL, LC_NUMERIC): New macro.
	* lib/stub/setlocale.c: New file.
	* lib/stub/sigaddset.c: New file.
	* lib/libc+gnu.c: Include them.

	mescc: Mes C Library: Fix qsort to support duplicate entries.
	* lib/stdlib/qsort.c (qpart): Handle dupes.
	* scaffold/tests/81-qsort-dupes.c: New file.
	* build-aux/check-mescc.sh (tests): Run it.

2018-08-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support make: Implement clock_gettime, time.
	* include/linux/x86/syscall.h (SYS_time, SYS_clock_gettime,
	SYS_gettimeofday): New macro.
	* include/linux/x86_64/syscall.h (SYS_time, SYS_clock_gettime,
	SYS_gettimeofday): New macro.
	* lib/linux/tcc.c (gettimeofday, time): New function.
	* lib/linux/gnu.c (clock_gettime): New function.
	* include/time.h: Declare it.
	* lib/stub/gettimeofday.c: Remove.
	* lib/stub/time.c: Remove.

	mescc: Mes C Library: Support make: Support main with envp.
	* lib/linux/x86-mes-gcc/crt1.c (_start): Also push envp.
	* lib/linux/x86-mes/crt1.c (_start): Also push envp.
	* lib/linux/x86_64-mes-gcc/crt1.c (_start): Also mov environment,%rdx.

	mescc: Mes C Library: Support make: Add chdir, getlogin, setvbuf, sigblock.
	* lib/stub/getlogin.c: New file.
	* lib/stub/setvbuf.c: New file.
	* lib/stub/sigblock.c: New file.
	* lib/libc+gnu.c: Include them.
	* include/linux/x86/syscall.h (SYS_chdir): New macro.
	* include/linux/x86_64/syscall.h (SYS_chdir): New macro.
	* include/stdio.h (_IOFBF, _IOLBF, _IONBF): New macro.
	* include/errno.h (ENOEXEC, ECHILD): New macro.
	* include/sys/wait.h (WNOHANG): New macro.
	* lib/linux/gnu.c (chdir): New function.
	* include/ar.h: New file.

	mescc: Mes C Library: Support diffutils: Add execl.
	* include/limits.h (CHAR_MAX): New macro.
	* lib/posix/execl.c: New file.
	* include/unistd.h: Declare it.

	mescc: Mes C Library: Add closedir, opendir, readdir.
	* include/dirent.h: New file.  Import from glibc-2.2.5.
	* include/dirstream.h: Likewise.
	* lib/dirent/__getdirentries.c: Likewise.
	* lib/dirent/closedir.c: Likewise.
	* lib/dirent/readdir.c (readdir): Likewise.
	* lib/libc+gnu.c: Include them.
	* include/linux/x86/syscall.h (SYS_getdents): New macro.
	* include/linux/x86_64/syscall.h (SYS_getdents): Likewise.
	* lib/linux/gnu.c (getdents): New function.
	* include/limits.h (NAME_MAX): New macro.
	* include/fcntl.h (O_DIRECTORY): New macro.
	* scaffold/tests/readdir.dir: New directory.
	* scaffold/tests/99-readdir.c: New file, use it.
	* build-aux/check-mescc.sh (tests): Run it.

2018-08-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Move strncmp to own test.
	* scaffold/tests/51-strcmp.c: Remove strncmp tests.
	* scaffold/tests/51-strncmp.c: New file.
	* build-aux/check-mescc.sh (tests): Add it.

2018-08-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Cleanup includes.
	* scaffold/tests/30-strlen.c: Include only libmes-mini.h
	* scaffold/tests/31-eputs.c: Likewise.
	* scaffold/tests/32-compare.c: Likewise.
	* scaffold/tests/33-and-or.c: Likewise.
	* scaffold/tests/34-pre-post.c: Likewise.
	* scaffold/tests/35-compare-char.c: Likewise.
	* scaffold/tests/36-compare-arithmetic.c: Likewise.
	* scaffold/tests/37-compare-assign.c: Likewise.
	* scaffold/tests/38-compare-call.c: Likewise.
	* scaffold/tests/40-if-else.c: Likewise.
	* scaffold/tests/41-?.c: Likewise.
	* scaffold/tests/42-goto-label.c: Likewise.
	* scaffold/tests/43-for-do-while.c: Likewise.
	* scaffold/tests/44-switch.c: Likewise.
	* scaffold/tests/45-void-call.c: Likewise.

	mescc: Cleanup includes.
	* include/libmes-mini.h: New file.
	* include/libmes.h: Use it.

2018-08-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Add dir to include path.
	* module/mescc/mescc.scm (preprocess): Add dir to include path.
	(c->info): Likewise.
	* scaffold/tests/08-assign.c: New file.

2018-08-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	check-mescc: c-mini

2018-08-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Explode libc+gnu.c.
	* modified:   include/math.h: Add declarations.
	* lib/posix/getopt.c: Rename from lib/getopt.c.
	* lib/gcc.c: Remove.
	* lib/m4.c: Remove.
	* lib/ctype/isalnum.c: New file, explode from libc+gnu.c.
	* lib/ctype/isalpha.c: Likewise.
	* lib/ctype/isascii.c: Likewise.
	* lib/ctype/iscntrl.c: Likewise.
	* lib/ctype/isnumber.c: Likewise.
	* lib/ctype/isprint.c: Likewise.
	* lib/ctype/ispunct.c: Likewise.
	* lib/math/fabs.c: Likewise.
	* lib/posix/alarm.c: Likewise.
	* lib/posix/mktemp.c: Likewise.
	* lib/posix/raise.c: Likewise.
	* lib/posix/sbrk.c: Likewise.
	* lib/posix/sleep.c: Likewise.
	* lib/posix/unsetenv.c: Likewise.
	* lib/stdio/clearerr.c: Likewise.
	* lib/stdio/fdgets.c: Likewise.
	* lib/stdio/feof.c: Likewise.
	* lib/stdio/fgets.c: Likewise.
	* lib/stdio/fileno.c: Likewise.
	* lib/stdio/freeopen.c: Likewise.
	* lib/stdio/freopen.c: Likewise.
	* lib/stdio/perror.c: Likewise.
	* lib/stdlib/__exit.c: Likewise.
	* lib/stdlib/abs.c: Likewise.
	* lib/stdlib/atexit.c: Likewise.
	* lib/stdlib/atol.c: Likewise.
	* lib/stdlib/bsearch.c: Likewise.
	* lib/stdlib/mbstowcs.c: Likewise.
	* lib/string/bcmp.c: Likewise.
	* lib/string/bcopy.c: Likewise.
	* lib/string/bzero.c: Likewise.
	* lib/string/index.c: Likewise.
	* lib/string/rindex.c: Likewise.
	* lib/string/strcspn.c: Likewise.
	* lib/string/strdup.c: Likewise.
	* lib/string/strerror.c: Likewise.
	* lib/string/strncat.c: Likewise.
	* lib/string/strpbrk.c: Likewise.
	* lib/string/strspn.c: Likewise.
	* lib/stub/__cleanup.c: Likewise.
	* lib/stub/atof.c: Likewise.
	* lib/stub/chown.c: Likewise.
	* lib/stub/ctime.c: Likewise.
	* lib/stub/fpurge.c: Likewise.
	* lib/stub/freadahead.c: Likewise.
	* lib/stub/frexp.c: Likewise.
	* lib/stub/fscanf.c: Likewise.
	* lib/stub/getpwnam.c: Likewise.
	* lib/stub/gmtime.c: Likewise.
	* lib/stub/pclose.c: Likewise.
	* lib/stub/popen.c: Likewise.
	* lib/stub/rewind.c: Likewise.
	* lib/stub/setbuf.c: Likewise.
	* lib/stub/sigsetmask.c: Likewise.
	* lib/stub/strftime.c: Likewise.
	* lib/stub/sys_siglist.c: Likewise.
	* lib/stub/system.c: Likewise.
	* lib/stub/times.c: Likewise.
	* lib/stub/umask.c: Likewise.
	* lib/stub/utime.c: Likewise.
	* lib/libc+gnu.c: Include explodings.
	* lib/libg.c: Likewise.
	* lib/libgetopt.c: Include explodings.

2018-08-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Explode libc+tcc.c.
	* include/libmes.h: Add declarations.
	* include/string.h: Likewise.
	* lib/ctype/islower.c: New file, explode from lib/libc+tcc.c.
	* lib/ctype/isupper.c: Likewise.
	* lib/ctype/tolower.c: Likewise.
	* lib/ctype/toupper.c: Likewise.
	* lib/mes/search-path.c: Likewise.
	* lib/posix/execvp.c: Likewise.
	* lib/stdio/fclose.c: Likewise.
	* lib/stdio/fdopen.c: Likewise.
	* lib/stdio/ferror.c: Likewise.
	* lib/stdio/fflush.c: Likewise.
	* lib/stdio/fopen.c: Likewise.
	* lib/stdio/fprintf.c: Likewise.
	* lib/stdio/fread.c: Likewise.
	* lib/stdio/fseek.c: Likewise.
	* lib/stdio/ftell.c: Likewise.
	* lib/stdio/fwrite.c: Likewise.
	* lib/stdio/printf.c: Likewise.
	* lib/stdio/remove.c: Likewise.
	* lib/stdio/snprintf.c: Likewise.
	* lib/stdio/sprintf.c: Likewise.
	* lib/stdio/sscanf.c: Likewise.
	* lib/stdio/vfprintf.c: Likewise.
	* lib/stdio/vprintf.c: Likewise.
	* lib/stdio/vsnprintf.c: Likewise.
	* lib/stdio/vsprintf.c: Likewise.
	* lib/stdio/vsscanf.c: Likewise.
	* lib/stdlib/calloc.c: Likewise.
	* lib/stdlib/qsort.c: Likewise.
	* lib/stdlib/strtof.c: Likewise.
	* lib/stdlib/strtol.c: Likewise.
	* lib/stdlib/strtold.c: Likewise.
	* lib/stdlib/strtoll.c: Likewise.
	* lib/stdlib/strtoul.c: Likewise.
	* lib/stdlib/strtoull.c: Likewise.
	* lib/string/memcmp.c: Likewise.
	* lib/string/memmem.c: Likewise.
	* lib/string/memmove.c: Likewise.
	* lib/string/memset.c: Likewise.
	* lib/string/strcat.c: Likewise.
	* lib/string/strchr.c: Likewise.
	* lib/string/strlwr.c: Likewise.
	* lib/string/strncpy.c: Likewise.
	* lib/string/strrchr.c: Likewise.
	* lib/string/strstr.c: Likewise.
	* lib/string/strupr.c: Likewise.
	* lib/stub/gettimeofday.c: Likewise.
	* lib/stub/ldexp.c: Likewise.
	* lib/stub/localtime.c: Likewise.
	* lib/stub/mprotect.c: Likewise.
	* lib/stub/sigaction.c: Likewise.
	* lib/stub/sigemptyset.c: Likewise.
	* lib/stub/strtod.c: Likewise.
	* lib/stub/time.c: Likewise.
	* lib/libc+tcc.c: Include explodings.

2018-08-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Explode libmes.c.
	* include/libmes.h: Add declarations.
	* lib/abtol.c: New file, explode from lib/libmes.c.
	* lib/ctype/isdigit.c: Likewise.
	* lib/ctype/isnumber.c: Likewise.
	* lib/ctype/isspace.c: Likewise.
	* lib/ctype/isxdigit.c: Likewise.
	* lib/mes/abtol.c: Likewise.
	* lib/mes/eputc.c: Likewise.
	* lib/mes/eputs.c: Likewise.
	* lib/mes/fdgetc.c: Likewise.
	* lib/mes/fdputc.c: Likewise.
	* lib/mes/fdputs.c: Likewise.
	* lib/mes/fdungetc.c: Likewise.
	* lib/mes/itoa.c: Likewise.
	* lib/mes/ltoab.c: Likewise.
	* lib/mes/ntoab.c: Likewise.
	* lib/mes/utoa.c: Likewise.
	* lib/stdlib/atoi.c: Likewise.
	* lib/libmes.c: Include explodings.

	mescc: Mes C Library: Explode libc-mini.c.
	* include/libmes.h: Add declarations.
	* lib/mes/eputs.c: New file, explode from lib/libc-mini.c.
	* lib/mes/oputs.c: Likewise.
	* lib/stdlib/exit.c: Likewise.
	* lib/stdlib/puts.c: Likewise.
	* lib/string/strlen.c: Likewise.
	* lib/libc-mini.c: Include explodings.

	mescc: Mes C Library: Explode libc.c.
	* lib/libc.c: New file, explode from lib/libc.c.
	* lib/posix/execv.c: Likewise.
	* lib/posix/isatty.c: Likewise.
	* lib/posix/wait.c: Likewise.
	* lib/stdio/fgetc.c: Likewise.
	* lib/stdio/fputc.c: Likewise.
	* lib/stdio/fputs.c: Likewise.
	* lib/stdio/getc.c: Likewise.
	* lib/stdio/getchar.c: Likewise.
	* lib/stdio/putc.c: Likewise.
	* lib/stdio/putchar.c: Likewise.
	* lib/stdio/ungetc.c: Likewise.
	* lib/stdlib/free.c: Likewise.
	* lib/stdlib/getenv.c: Likewise.
	* lib/stdlib/realloc.c: Likewise.
	* lib/stdlib/setenv.c: Likewise.
	* lib/string/strcmp.c: Likewise.
	* lib/string/strcpy.c: Likewise.
	* lib/string/strncmp.c: Likewise.
	* lib/libc.c: Include explodings.

2018-08-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Build initial scaffold tests without libc.
	* scaffold/argv.c (strcmp): New function; support building without
	libc.
	* build-aux/build-cc.sh: Build initial scaffold tests without libc.
	* build-aux/build-cc32.sh: Likewise.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/check-mescc.sh: Likewise.
	* scaffold/read.data: Rename from `mesmes'.
	* scaffold/read.c: Rename from `m.c'; update.

	test: Remove 30-test.i indirection.
	* include/30-test.i: Remove.
	* scaffold/tests/30-strlen.c: Remove 30-test.i indirection.
	* scaffold/tests/31-eputs.c: Likewise.
	* scaffold/tests/32-compare.c: Likewise.
	* scaffold/tests/33-and-or.c: Likewise.
	* scaffold/tests/34-pre-post.c: Likewise.
	* scaffold/tests/35-compare-char.c: Likewise.
	* scaffold/tests/36-compare-arithmetic.c: Likewise.
	* scaffold/tests/37-compare-assign.c: Likewise.
	* scaffold/tests/38-compare-call.c: Likewise.
	* scaffold/tests/40-if-else.c: Likewise.
	* scaffold/tests/41-?.c: Likewise.
	* scaffold/tests/42-goto-label.c: Likewise.
	* scaffold/tests/43-for-do-while.c: Likewise.
	* scaffold/tests/44-switch.c: Likewise.
	* scaffold/tests/45-void-call.c: Likewise.
	* scaffold/tests/46-function-static.c: Likewise.
	* scaffold/tests/50-assert.c: Likewise.
	* scaffold/tests/51-strcmp.c: Likewise.
	* scaffold/tests/52-itoa.c: Likewise.
	* scaffold/tests/53-strcpy.c: Likewise.
	* scaffold/tests/60-math.c: Likewise.
	* scaffold/tests/63-struct-cell.c: Likewise.
	* scaffold/tests/64-make-cell.c: Likewise.
	* scaffold/tests/65-read.c: Likewise.
	* scaffold/tests/66-local-char-array.c: Likewise.
	* scaffold/tests/70-printf.c: Likewise.
	* scaffold/tests/71-struct-array.c: Likewise.
	* scaffold/tests/72-typedef-struct-def.c: Likewise.
	* scaffold/tests/73-union.c: Likewise.
	* scaffold/tests/74-multi-line-string.c: Likewise.
	* scaffold/tests/75-struct-union.c: Likewise.
	* scaffold/tests/76-pointer-arithmetic.c: Likewise.
	* scaffold/tests/77-pointer-assign.c: Likewise.
	* scaffold/tests/78-union-struct.c: Likewise.
	* scaffold/tests/79-int-array.c: Likewise.
	* scaffold/tests/7a-struct-char-array.c: Likewise.
	* scaffold/tests/7b-struct-int-array.c: Likewise.
	* scaffold/tests/7c-dynarray.c: Likewise.
	* scaffold/tests/7d-cast-char.c: Likewise.
	* scaffold/tests/7e-struct-array-access.c: Likewise.
	* scaffold/tests/7f-struct-pointer-arithmetic.c: Likewise.
	* scaffold/tests/7g-struct-byte-word-field.c: Likewise.
	* scaffold/tests/7h-struct-assign.c: Likewise.
	* scaffold/tests/7i-struct-struct.c: Likewise.
	* scaffold/tests/7j-strtoull.c: Likewise.
	* scaffold/tests/7k-for-each-elem.c: Likewise.
	* scaffold/tests/7l-struct-any-size-array.c: Likewise.
	* scaffold/tests/7m-struct-char-array-assign.c: Likewise.
	* scaffold/tests/7n-struct-struct-array.c: Likewise.
	* scaffold/tests/80-setjmp.c: Likewise.
	* scaffold/tests/81-qsort.c: Likewise.
	* scaffold/tests/86-strncpy.c: Likewise.
	* scaffold/tests/87-sscanf.c: Likewise.

	test: Remove 00-test.i indirection.
	* include/00-test.i: Remove.
	* scaffold/tests/01-return-0.c: Remove 00-test.i indirection.
	* scaffold/tests/02-return-1.c: Likewise.
	* scaffold/tests/03-call.c: Likewise.
	* scaffold/tests/04-call-0.c: Likewise.
	* scaffold/tests/05-call-1.c: Likewise.
	* scaffold/tests/06-call-!1.c: Likewise.
	* scaffold/tests/10-if-0.c: Likewise.
	* scaffold/tests/11-if-1.c: Likewise.
	* scaffold/tests/12-if-==.c: Likewise.
	* scaffold/tests/13-if-!=.c: Likewise.
	* scaffold/tests/14-if-goto.c: Likewise.
	* scaffold/tests/15-if-!f.c: Likewise.
	* scaffold/tests/16-if-t.c: Likewise.
	* scaffold/tests/20-while.c: Likewise.
	* scaffold/tests/21-char[].c: Likewise.
	* scaffold/tests/22-while-char[].c: Likewise.
	* scaffold/tests/23-pointer.c: Likewise.

	build: Cleanup trace output.
	* build-aux/build-cc.sh: Cleanup trace output.
	* build-aux/build-cc32.sh: Likewise.
	* build-aux/build-guile.sh: Likewise.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/build-x86_64-mes.sh: Likewise.
	* build-aux/cc-mes.sh: Likewise.
	* build-aux/cc.sh: Likewise.
	* build-aux/cc32-mes.sh: Likewise.
	* build-aux/cc64-mes.sh: Likewise.
	* build-aux/check-boot.sh: Likewise.

	mescc: Support -l none (linking without libc).
	* module/mescc/mescc.scm (mescc:link): Support -l none.

2018-08-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support -o-.
	* module/mescc/mescc.scm (GUILE-with-output-to-file): New variable.
	(with-output-to-file): Use it in redefined function.

	build: Update dir-locals for new layout.
	* .dir-locals.el: Update to new layout.

2018-08-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Support oputs for POSIX.
	* lib/libmes.c (oputs)[POSIX]: New function.

	core: mes: Prepare for M2-Planet.
	* src/mes.c (cal): Refactor to use if instead of switch.
	(eval_apply): Likewise.

	core: lib: Prepare for M2-Planet.
	* src/lib.c (display_helper): Refactor to use if instead of switch.
	(memq): Likewise.

	core: reader: Prepare for M2-Planet.
	* src/reader.c (MAX_STRING): New define.
	(read_input_file_env_): Remove dead code.
	(reader_read_line_comment): Refactor to remove recursion.
	(reader_read_line_sexp_): Refactor to use if instead of switch.
	(reader_read_hash): Likewise.
	(reader_read_character): Refactor: cache peekchar () value, make
	M2-Planet friendly.
	(reader_read_binary): Make M2-Planet friendly.
	(reader_read_octal): Likewise.
	(reader_read_hex): Likewise.
	(reader_read_string): Refactor.
	(dump): Make M2-Planet friendly.

	build: src/mes build fixes.
	* build-aux/GNUmakefile.in (seed): Add dependency on gcc.
	* build-aux/build-cc.sh: Copy result to src/mes.
	* build-aux/build-cc32.sh: Likewise.
	* build-aux/build.sh.in: Remove copying of results.

	mescc: Mes C Library: Cleanup start files.
	* lib/linux/x86-mes-gcc/crt0.c: Split from lib/linux/crt0.c.
	* lib/linux/x86-mes-gcc/crt1.c: Split from lib/linux/crt1.c.
	* lib/linux/x86-mes-gcc/crti.c: Split from lib/linux/crti.c.
	* lib/linux/x86-mes-gcc/crtn.c: Split from lib/linux/crtn.c.
	* lib/linux/x86-mes/crt0.c: Split from lib/linux/crt0.c.
	* lib/linux/x86-mes/crt1.c: Split from lib/linux/crt1.c.
	* lib/linux/x86-mes/crti.c: Split from lib/linux/crti.c.
	* lib/linux/x86-mes/crtn.c: Split from lib/linux/crtn.c.
	* build-aux/build-cc.sh: Update.
	* build-aux/build-cc32.sh: Update.
	* build-aux/build-mes.sh: Update.

2018-08-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Add x86_64 libc+gnu support.
	* include/linux/x86/syscall.h: Move SYS_ defines from gnu.c.
	* include/linux/x86_64/syscall.h: Add SYS_ defines for gnu.
	* lib/linux/gnu.c: Update.
	* lib/linux/gnu.c (signal)[__x86_64__]: Implement using rt_sigaction.
	* lib/stdlib/abort.c: Support x86_64.

	mescc: Mes C Library: Add x86_64 libc+tcc support.
	* include/linux/x86/syscall.h: Move SYS_ defines from tcc.c.
	* include/linux/x86_64/syscall.h: Add SYS_ defines for tcc.
	* lib/x86-mes-gcc/setjmp.c: Rename from lib/libc+tcc-gcc.c
	* lib/x86-mes/setjmp.c: Rename from lib/libc+tcc-mes.c
	* lib/linux/tcc.c: Update.

	mescc: Mes C Library: Add x86_64 libc support.
	* include/linux/x86_64/syscall.h: New file.
	* include/linux/x86/syscall.h: New file.
	* lib/linux/x86_64-mes-gcc/mes.c: New file.
	* lib/linux/x86-mes/mes.c: Rename from lib/linux/mes.c.
	* lib/linux/x86-mes-gcc/mes.c: Rename from lib/linux/gcc.c.
	* lib/linux/libc.c: Update includes.
	(waitpid)[__x86_64__]: Use wait4.
	* build-aux/build-cc.sh: Build libc too.
	* lib/x86-mes/x86.M1 (mov____0x8(%ebp),%esi): New macro.

2018-08-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mes C Library: Add x86_64 libc-mini support.
	* lib/linux/x86-mes-gcc/mini.c: Rename from lib/linux/mini-gcc.c.
	* lib/linux/x86-mes/mini.c: Rename from lib/linux/mini-mes.c.
	* lib/linux/x86_64-mes-gcc/crt1.c: Rename from lib/linux/x86_64/crt1.c.
	* lib/linux/x86_64-mes-gcc/mini.c: New file.
	* build-aux/build-cc.sh: Build libc-mini, scaffold/main, scaffold/hello.
	* build-aux/cc64.sh: New file.

	mescc: Add objdump'able x86_64-mes scaffold.
	* lib/x86_64-mes/elf64-header.hex2: New file.
	* lib/x86_64-mes/elf64-footer-single-main.hex2: New file.
	* build-aux/build-x86_64-mes.sh: Enable second, objdump'able exit-42
	  scaffold test.

	mescc: Initial x86_64-mes scaffold.
	* build-aux/GNUmakefile.in (x86_64-mes): New target.
	* .gitignore: Ignore x86 and x86_64 out files.
	* build-aux/build-mes.sh: Resurrect three initial exit42 scaffold tests.
	* build-aux/build-x86_64-mes.sh: New file.  Add initial exit42
	  scaffold test.
	* lib/x86-mes/elf32-0header.hex2: Fix comment.
	* lib/x86-mes/elf32-header.hex2: Likewise.
	* lib/x86_64-mes/elf-0footer.hex2: New file.
	* lib/x86_64-mes/elf64-0header.hex2: New file.
	* lib/x86_64-mes/elf64-body-exit-42.hex2: New file.
	* lib/x86_64-mes/exit-42.c: New file.

2018-08-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: seed: Oops, copy TCC seed after it's been regenerated.
	* build-aux/GNUmakefile.in (seed): Oops, copy TCC seed after it's been
	regenerated.

2018-08-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Fix mescc man page generation.
	* build-aux/GNUmakefile.in (doc/mescc.1): Reverse dependencies;
	  generate page for mescc.

2018-08-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Fixes for make check.
	* build-aux/config.sh (srcdir): Initialize if unset.
	* build-aux/test.sh (DIFF): Do not fail if unset.

2018-08-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: Update to 0.17.
	* guix/git/mes.scm (mes): Update to 0.17.

2018-07-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.17.
	* configure (VERSION): Update to 0.17.

	doc: Release update.
	* HACKING: Update.
	* INSTALL: Update.
	* NEWS: Update.
	* README: Update.
	* doc/announce/ANNOUNCE-0.17: New file.

2018-08-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Non-bootstrap install fixes.
	* configure (main): Fix default bindir.
	* build-aux/GNUmakefile.in (PHONY_TARGETS): Remove src/mes.  Fixes
	  re-build upon install.
	* build-aux/install.sh.in: Fix tar arguments for scaffold files.
	  Expand install directories.

	check: Do not fail if partial test prerequisites fail.
	* build-aux/check-tcc.sh: Pass if no test directory found.
	* build-aux/check.sh.in (TINYCC_PREFIX): Rename from TCC_PREFIX.  Pass
	  if partial tests prerequisites fail.

	check: Fix 4f-string-split.scm for Guile.
	* module/mes/guile.scm (core:car, core:make-cell): New function.
	  Fixes scaffold/boot/4f-string-split.scm.

	build: configure: Oops, substitute @prefix@.
	* build-aux/pre-inst-env.in (MES_PREFIX): Respect pre-set value.
	* configure (main): Oops, substitute @prefix@.
	* configure.sh (subst): Likewise.

2018-07-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: web: New target.
	* README: Add bug-mes@gnu.org
	* NEWS: Likewise.
	* doc/mes.texi: Likewise.
	* build-aux/gendocs.sh: New file, from gnulib.
	* doc/gendocs_template: New file, from gnulib.
	* build-aux/GNUmakefile.in (web): New target.

	Remove fosdem talk.
	* doc/fosdem/GuixSD.png: Remove.
	* doc/fosdem/LISP-1-5-page-13-bottom.png: Remove.
	* doc/fosdem/LISP-1.5-page-13-bottom.png: Remove.
	* doc/fosdem/LISP-1.5-page-13.pdf: Remove.
	* doc/fosdem/LISP-1.5-page-13.png: Remove.
	* doc/fosdem/README: Remove.
	* doc/fosdem/beamercolorthemeX.sty: Remove.
	* doc/fosdem/beamerthemeX.sty: Remove.
	* doc/fosdem/bootstrap-graph.png: Remove.
	* doc/fosdem/egg.jpeg: Remove.
	* doc/fosdem/egg.png: Remove.
	* doc/fosdem/egg.xcf: Remove.
	* doc/fosdem/fosdem.org: Remove.
	* doc/fosdem/fosdem.pdf: Remove.
	* doc/fosdem/fsb-logo-guile-guix-gnu.png: Remove.
	* doc/fosdem/fsb-logo-guile-guix-gnu.xcf: Remove.
	* doc/fosdem/fsb-logo-guile-guix-mes.png: Remove.
	* doc/fosdem/fsb-logo-guile-guix-mes.xcf: Remove.
	* doc/fosdem/fsb-logo.png: Remove.
	* doc/fosdem/guix-build-bootstrap-tarballs.log: Remove.
	* doc/fosdem/mes.png: Remove.
	* doc/fosdem/mes.xcf: Remove.

2018-07-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Remove tinycc/test2 import.
	* scaffold/tinycc/: Remove.
	* build-aux/check-mescc.sh: Remove tinycc testing.
	* build-aux/check-tcc.sh: New file.
	* build-aux/check.sh.in: Use it.
	* build-aux/config.sh: Update.
	* build-aux/export.make: Update.

	Add missing copyright headers and READMEs.
	* ChangeLog: Add copyright header.
	* build-aux/GNUmakefile.in (generate-ChangeLog): Append it as copyright footer.
	* BOOTSTRAP: Add copyright header.
	* scaffold/boot/2f-define-second-lambda.scm: Likewise.
	* scaffold/boot/39-global-define-override.scm: Likewise.
	* scaffold/boot/3a-global-define-lambda-override.scm: Likewise.
	* scaffold/boot/4f-string-split.scm: Likewise.
	* scaffold/boot/numbers.scm: Likewise.
	* scaffold/gc.scm: Likewise.
	* scaffold/b-0.mes: Remove.
	* doc/GNU-EVAL-APPLY: Remove.
	* doc/announce/README: New file.
	* doc/announce/ANNOUNCE: Move from doc/ANNOUNCE.
	* doc/announce/ANNOUNCE-0.10: Likewise.
	* doc/announce/ANNOUNCE-0.11: Likewise.
	* doc/announce/ANNOUNCE-0.12: Likewise.
	* doc/announce/ANNOUNCE-0.13: Likewise.
	* doc/announce/ANNOUNCE-0.14: Likewise.
	* doc/announce/ANNOUNCE-0.15: Likewise.
	* doc/announce/ANNOUNCE-0.16: Likewise.
	* doc/announce/ANNOUNCE-0.3: Likewise.
	* doc/announce/ANNOUNCE-0.4: Likewise.
	* doc/announce/ANNOUNCE-0.5: Likewise.
	* doc/announce/ANNOUNCE-0.6: Likewise.
	* doc/announce/ANNOUNCE-0.7: Likewise.
	* doc/announce/ANNOUNCE-0.8: Likewise.
	* doc/announce/ANNOUNCE-0.9: Likewise.
	* doc/announce/ANNOUNCE-2: Likewise.
	* doc/announce/UPDATE-0.13: Likewise.
	* doc/fosdem/README: New file.
	* doc/fosdem/fosdem.org: Add legalese.
	* doc/fosdem/fosdem.pdf: Regenerate.
	* doc/images/README: New file.
	* mes/module/mes/psyntax.pp.header: New file.
	* mes/module/mes/psyntax.pp: Add it to generated file.

2018-07-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Make build more autotools-like.
	* build-aux/build.sh.in: Move from ./build.sh
	* build-aux/check.sh.in: Likewise.
	* build-aux/GNUmakefile.in: Likewise.
	* build-aux/install.sh.in: Likewise.
	* build-aux/uninstall.sh.in: Likewise.
	* configure: Substitute them.
	* configure.sh: Likewise.
	* build-aux/build-cc.sh: Update: use ${srcdest} instead of ${top_builddest}.
	* build-aux/build-cc32.sh: Likewise.
	* build-aux/build-guile.sh: Likewise.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/cc-mes.sh: Likewise.
	* build-aux/cc.sh: Likewise.
	* build-aux/cc32-mes.sh: Likewise.
	* build-aux/check-boot.sh: Likewise.
	* build-aux/check-mes.sh: Likewise.
	* build-aux/check-mescc.sh: Likewise.
	* build-aux/config.sh: Likewise.
	* build-aux/export.make: Likewise.
	* build-aux/mes-snarf.scm: Likewise.
	* build-aux/pre-inst-env.in: Likewise.
	* build-aux/test.sh: Likewise.
	* build-aux/trace.sh: Likewise.
	* module/mescc/mescc.scm: Likewise.
	* scripts/mescc.in: Likewise.
	* src/mes.c: Likewise.
	* .gitignore: Likewise.

2018-07-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Support all `Standard targets' for users.
	* GNUmakefile (distclean mostlyclean, maintainer-clean, html, dvi, ps,
	  install-dvi, install-ps, install-html, installcheck): New target.
	  (install-info): Remove fake target.
	* configure (parse-opts): Add --srcdir.

	xx

2018-07-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	Add taken-from-Binutils and copyright line to alloca.c
	* lib/stdlib/alloca.c: Add `taken from binutils' and copyright line to
	  alloca.c for minor changes.

2018-07-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	Relicense some taken-from-GNU Guile LGPLv3+ files to GPLv3+.
	* mes/module/mes/pmatch.scm: Relicense to GPLv3+.
	* mes/module/sxml/xpath.scm: Likewise.
	* mes/module/mes/peg/cache.scm: Likewise.
	* mes/module/mes/peg/codegen.scm: Likewise.
	* mes/module/mes/peg/simplify-tree.scm: Likewise.
	* mes/module/mes/peg/string-peg.scm: Likewise.
	* mes/module/mes/peg/using-parsers.scm: Likewise.

2018-07-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	Relicense some taken-from-GNU Guile LGPLv2+ files to GPLv3+.
	* mes/module/mes/pretty-print.scm: Relicense to GPLv3+.
	* mes/module/mes/psyntax.ss: Likewise.
	* mes/module/srfi/srfi-1.scm: Likewise.
	* mes/module/srfi/srfi-16.scm: Likewise.
	* mes/module/srfi/srfi-26.scm: Likewise.
	* module/mes/getopt-long.scm: Likewise.

	Add missing copyright headers.
	* .dir-locals.el: Add copyright header.
	* AUTHORS: Likewise.
	* HACKING: Likewise.
	* INSTALL: Likewise.
	* README: Likewise.
	* build-aux/export.make: Likewise.
	* build-aux/setup-mes.sh: Likewise.
	* configure.sh: Likewise.
	* install.sh: Likewise.
	* scaffold/tests/90-goto-var.c: Likewise.
	* scaffold/tests/91-goto-array.c: Likewise.
	* tests/read.test: Likewise.
	* uninstall.sh: Likewise.
	* doc/fosdem/beamercolorthemeX.sty:
	* doc/fosdem/beamerthemeX.sty:
	* doc/fosdem/html.sty: Remove.
	* doc/fosdem/README: New file.
	* doc/images/README: New file.

2018-07-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	GNU Mes.
	Throughout, make these changes

	   Copyright headers: GNU Mes
	   First mention of name: GNU Mes
	   Website: https://www.gnu.org/software/mes
	   Git:     git://git.savannah.gnu.org/mes.git

2018-07-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Support uninstall.
	* uninstall.sh: New file.
	* GNUmakefile (uninstall): Use it in new target.

	build: Generate gcc-mesboot-graph from .dot.
	* doc/images/gcc-mesboot-graph.dot: New file.
	* doc/images/gcc-mesboot-graph.png: Remove.
	* GNUmakefile (${top_builddest}doc/images/gcc-mesboot-graph.png): New target.
	* configure (det): Add check.
	* build-aux/export.make: Export it.
	* doc/mes.texi (The Mes Bootstrap Process): Describe new recipe.
	* guix/git/mes.scm (mes): Add graphvis dependency.

2018-07-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: Refactor package setup.
	Next to the convenient environment setup and package build from git

	   guix environment -l .guix.scm
	   guix build -f .guix.scm

	we can now also build other included packages

	    GUIX_PACKAGE_PATH=guix guix build mes@0.17
	    GUIX_PACKAGE_PATH=guix guix build nyacc@0.80.42

	* guix/git/mes.scm: Move from .guix.scm, make a module.
	* .guix.scm: Move from guix.scm, use it.
	* build-aux/manifest.scm: Update location.
	* build-aux/pre-inst-env.in: Support it.
	* configure: Check for guix.
	* build-aux/export.make: Export GUIX.
	* GNUmakefile (update-hash): New target.

2018-07-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Respect --docdir.
	* configure: Respect --docdir.

2018-07-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Support --srcdir build.
	* build-aux/config.sh: New file.
	* build-aux/trace.sh: New file.
	* build-aux/GNUmakefile.in: New file.
	* configure: Support srcdir configure.
	* GNUmakefile: Support srcdir build.
	* build-aux/build-cc.sh: Likewise.
	* build-aux/build-cc32.sh: Likewise.
	* build-aux/build-guile.sh: Likewise.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/cc-mes.sh: Likewise.
	* build-aux/cc.sh: Likewise.
	* build-aux/cc32-mes.sh: Likewise.
	* build-aux/check-mes.sh: Likewise.
	* build-aux/check-mescc.sh: Likewise.
	* build-aux/export.make: Likewise.
	* build-aux/mes-snarf.scm: Likewise.
	* build-aux/pre-inst-env.in: Likewise.
	* build-aux/test.sh: Likewise.
	* build.sh: Likewise.
	* check.sh: Likewise.
	* install.sh: Likewise.
	* module/mescc/mescc.scm: Likewise.
	* scripts/mescc.in: Likewise.
	* src/mes.c: Likewise.

2018-06-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Prepare for the Hurd.
	* lib/linux/libc.c: Move from lib/linux.c.
	* lib/linux/gcc.c: Move from lib/linux-gcc.c.
	* lib/linux/gnu.c: Move from lib/linux+gnu.c.
	* lib/linux/libc.c: Move from lib/linux.c.
	* lib/linux/mes.c: Move from lib/linux-mes.c.
	* lib/linux/mini-gcc.c: Move from lib/linux-mini-gcc.c.
	* lib/linux/mini-mes.c: Move from lib/linux-mini-mes.c.
	* lib/linux/tcc.c: Move from lib/linux+tcc.c.
	* lib/linux/crt0.c: Move from lib/crt0.c.
	* lib/linux/crt1.c: Move from lib/crt1.c.
	* lib/linux/crti.c: Move from lib/crti.c.
	* lib/linux/crtn.c: Move from lib/crtn.c.
	* build-aux/build-cc.sh: Update for new layout.
	* build-aux/build-cc32.sh: Likewise.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/cc-mes.sh: Likewise.
	* build-aux/cc32-mes.sh: Likewise.
	* lib/string/argz-count.c: New file taken from GNU C Library,
	  relicensed.
	* lib/string/argz-extract.c: New file taken from GNU C Library,
	  relicensed.
	* include/argz.h: New file.
	* lib/string/memcpy.c: New file, extract from libc.
	* lib/assert/assert.c: Likewise.

2018-07-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Install ChangeLog.
	* ChangeLog: New file.
	* install.sh: Regenerate it, install it.

	build: Refactor configure.
	* configure: Refactor.

2018-07-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Prepare for autoconfiscation.
	Make build system more in alignment with how autotools work.  This
	will make transition easier.

	* mes/module/mes/boot-0.scm.in: Update from module/mes/boot-0.scm.
	* scripts/mescc.in: Update from scripts/mescc.
	* build-aux/pre-inst-env.in: New file.
	* build-aux/cc-mes.sh: Use pre-inst-env.
	* configure: Substitute new .in files.
	* install.sh: Do not substitute mescc, boot-0.scm.

2018-07-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Document number->string INT-MIN failure with gcc-x86.
	* src/mes.c (scm_symbol_arch, scm_symbol_compiler): New symbol.
	  (mes_symbols, bload_env): Add them.
	  (scm_symbol_gnuc, scm_symbol_mesc): Remove.
	* scaffold/mini-mes.c: Likewise.
	* module/mes/mes-0.scm (%arch, %compiler): New public variable.
	* tests/srfi-13.test: Expect number->string INT-MIN to fail for
	  gcc-x86.
	* HACKING (Bugs): Add it.

	build: Refactor mes tests.
	* build-aux/check-mes.sh: New file.
	* check.sh: Invoke it for Guile and Mes.
	* .gitignore: Ignore new guile logs.
	* mes/module/mes/boot-0.scm: Ignore some standard Guile options.
	* module/mes/test.scm: Make a module.
	* tests/base.test: Use it.  Make a module, support invoking with Guile
	  or Mes alike.
	* tests/boot.test: Likewise.
	* tests/catch.test: Likewise.
	* tests/closure.test: Likewise.
	* tests/cwv.test: Likewise.
	* tests/display.test: Likewise.
	* tests/fluids.test: Likewise.
	* tests/getopt-long.test: Likewise.
	* tests/guile.test: Likewise.
	* tests/let-syntax.test: Likewise.
	* tests/let.test: Likewise.
	* tests/match.test: Likewise.
	* tests/math.test: Likewise.
	* tests/module.test: Likewise.
	* tests/optargs.test: Likewise.
	* tests/peg.test: Likewise.
	* tests/pmatch.test: Likewise.
	* tests/psyntax.test: Likewise.
	* tests/quasiquote.test: Likewise.
	* tests/read.test: Likewise.
	* tests/scm.test: Likewise.
	* tests/srfi-13.test: Likewise.
	* tests/srfi-14.test: Likewise.
	* tests/srfi-16.test: Likewise.
	* tests/srfi-1.test: Likewise.
	* tests/srfi-43.test: Likewise.
	* tests/srfi-9.test: Likewise.
	* tests/syntax.test: Likewise.
	* tests/vector.test: Likewise.
	* tests/base.test-guile: Remove.
	* tests/boot.test-guile: Remove.
	* tests/catch.test-guile: Remove.
	* tests/closure.test-guile: Remove.
	* tests/cwv.test-guile: Remove.
	* tests/display.test-guile: Remove.
	* tests/fluids.test-guile: Remove.
	* tests/getopt-long.test-guile: Remove.
	* tests/guile.test-guile: Remove.
	* tests/let-syntax.test-guile: Remove.
	* tests/let.test-guile: Remove.
	* tests/match.test-guile: Remove.
	* tests/math.test-guile: Remove.
	* tests/module.test-guile: Remove.
	* tests/optargs.test-guile: Remove.
	* tests/peg.test-guile: Remove.
	* tests/pmatch.test-guile: Remove.
	* tests/psyntax.test-guile: Remove.
	* tests/quasiquote.test-guile: Remove.
	* tests/read.test-guile: Remove.
	* tests/scm.test-guile: Remove.
	* tests/srfi-13.test-guile: Remove.
	* tests/srfi-14.test-guile: Remove.
	* tests/srfi-16.test-guile: Remove.
	* tests/srfi-1.test-guile: Remove.
	* tests/srfi-43.test-guile: Remove.
	* tests/srfi-9.test-guile: Remove.
	* tests/syntax.test-guile: Remove.
	* tests/vector.test-guile: Remove.

	build: all-go: Support V=0,1,2.
	* build-aux/build-guile.sh: Support V=0,1,2.

	build: Fix for handling missing makeinfo.
	* configure (main): Update MAKEINFO.

	mescc: fwrite: Increase debug tracing threshold.
	* lib/libc+tcc.c (fwrite): Increase debug tracing threshold.

	mescc: Add proper includes.
	* include/libmes.h (__mes_debug): Declare.
	* lib/libtcc1.c: Add proper includes.
	* lib/linux+gnu.c: Likewise.
	* lib/m4.c: Likewise.

	core: Resurrect gcc support.
	* src/mes.c (MES_ARENA)[POSIX]: Default to 100000000.

	scaffold: Add proper includes.
	* scaffold/argv.c: Add proper includes.
	* scaffold/malloc.c: Likewise.
	* scaffold/micro-mes.c: Likewise.
	* scaffold/mini-mes.c: Likewise.
	* scaffold/tiny-mes.c: Likewise.

	build: cc32: Silence warnings.
	* build-aux/build-cc32.sh (CC32_CFLAGS): Silence warnings.

	build: Resurrect i686-unknown-linux-gnu-gcc support.
	* build-aux/build-cc32.sh (CC32_CFLAGS): Add -fno-builtin.  Resurrects
	  i686-unknown-linux-gnu-gcc.

	mescc: Support verbose int types.
	* module/mescc/compile.scm (i386:type-alist): Support verbose int types.

	build: Separate Mes and Guile modules.
	* scaffold/gc.scm: Move from guile/gc.scm.
	* guile/: Remove.
	* module/language/paren.mes: Remove.
	* mes/module/mes/base.mes: Move from module/mes/.
	* mes/module/mes/boot-0.scm: Likewise.
	* mes/module/mes/boot-00.scm: Likewise.
	* mes/module/mes/boot-01.scm: Likewise.
	* mes/module/mes/boot-02.scm: Likewise.
	* mes/module/mes/catch.mes: Likewise.
	* mes/module/mes/display.mes: Likewise.
	* mes/module/mes/fluids.mes: Likewise.
	* mes/module/mes/getopt-long.mes: Likewise.
	* mes/module/mes/guile.mes: Likewise.
	* mes/module/mes/lalr.mes: Likewise.
	* mes/module/mes/lalr.scm: Likewise.
	* mes/module/mes/let.mes: Likewise.
	* mes/module/mes/match.mes: Likewise.
	* mes/module/mes/match.scm: Likewise.
	* mes/module/mes/mescc.mes: Likewise.
	* mes/module/mes/misc.mes: Likewise.
	* mes/module/mes/module.mes: Likewise.
	* mes/module/mes/optargs.mes: Likewise.
	* mes/module/mes/optargs.scm: Likewise.
	* mes/module/mes/peg.mes: Likewise.
	* mes/module/mes/peg/cache.scm: Likewise.
	* mes/module/mes/peg/codegen.scm: Likewise.
	* mes/module/mes/peg/simplify-tree.scm: Likewise.
	* mes/module/mes/peg/string-peg.scm: Likewise.
	* mes/module/mes/peg/using-parsers.scm: Likewise.
	* mes/module/mes/pmatch.mes: Likewise.
	* mes/module/mes/pmatch.scm: Likewise.
	* mes/module/mes/posix.mes: Likewise.
	* mes/module/mes/pretty-print.mes: Likewise.
	* mes/module/mes/pretty-print.scm: Likewise.
	* mes/module/mes/psyntax-0.mes: Likewise.
	* mes/module/mes/psyntax-1.mes: Likewise.
	* mes/module/mes/psyntax.mes: Likewise.
	* mes/module/mes/psyntax.pp: Likewise.
	* mes/module/mes/psyntax.ss: Likewise.
	* mes/module/mes/quasiquote.mes: Likewise.
	* mes/module/mes/quasisyntax.mes: Likewise.
	* mes/module/mes/quasisyntax.scm: Likewise.
	* mes/module/mes/repl.mes: Likewise.
	* mes/module/mes/scm.mes: Likewise.
	* mes/module/mes/syntax.mes: Likewise.
	* mes/module/mes/syntax.scm: Likewise.
	* mes/module/mes/test.mes: Likewise.
	* mes/module/mes/tiny-0.mes: Likewise.
	* mes/module/mes/type-0.mes: Likewise.
	* mes/module/mescc/M1.mes: Likewise.
	* mes/module/mescc/as.mes: Likewise.
	* mes/module/mescc/bytevectors.mes: Likewise.
	* mes/module/mescc/compile.mes: Likewise.
	* mes/module/mescc/i386/as.mes: Likewise.
	* mes/module/mescc/info.mes: Likewise.
	* mes/module/mescc/mescc.mes: Likewise.
	* mes/module/mescc/preprocess.mes: Likewise.
	* mes/module/nyacc/lalr.mes: Likewise.
	* mes/module/nyacc/lang/c99/cpp.mes: Likewise.
	* mes/module/nyacc/lang/c99/parser.mes: Likewise.
	* mes/module/nyacc/lang/c99/pprint.mes: Likewise.
	* mes/module/nyacc/lang/calc/parser.mes: Likewise.
	* mes/module/nyacc/lang/util.mes: Likewise.
	* mes/module/nyacc/lex.mes: Likewise.
	* mes/module/nyacc/parse.mes: Likewise.
	* mes/module/nyacc/util.mes: Likewise.
	* mes/module/rnrs/arithmetic/bitwise.mes: Likewise.
	* mes/module/srfi/srfi-0.mes: Likewise.
	* mes/module/srfi/srfi-1.mes: Likewise.
	* mes/module/srfi/srfi-1.scm: Likewise.
	* mes/module/srfi/srfi-13.mes: Likewise.
	* mes/module/srfi/srfi-14.mes: Likewise.
	* mes/module/srfi/srfi-16.mes: Likewise.
	* mes/module/srfi/srfi-16.scm: Likewise.
	* mes/module/srfi/srfi-26.mes: Likewise.
	* mes/module/srfi/srfi-26.scm: Likewise.
	* mes/module/srfi/srfi-43.mes: Likewise.
	* mes/module/srfi/srfi-8.mes: Likewise.
	* mes/module/srfi/srfi-9.mes: Likewise.
	* mes/module/srfi/srfi-9/gnu.mes: Likewise.
	* mes/module/sxml/xpath.mes: Likewise.
	* mes/module/sxml/xpath.scm: Likewise.
	* module/mes/mes-0.scm: Likewise.
	* build-aux/build-guile.sh: Update for new layout.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/check-boot.sh: Likewise.
	* build-aux/check-mescc.sh: Likewise.
	* install.sh: Likewise.
	* scaffold/boot/51-module.scm: Likewise.
	* scaffold/boot/52-define-module.scm: Likewise.
	* scripts/mescc: Likewise.
	* src/mes.c: Likewise.
	* tests/base.test-guile: Likewise.
	* tests/boot.test: Likewise.
	* tests/srfi-9.test: Likewise.
	* mes/include: New symlink.
	* mes/lib: New symlink.
	* AUTHORS: Update file names.

	core: typo: Remove trailing 1.
	* include/alloca.h: typo: Remove trailing 1.

2018-07-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	Add missing copyright header.  Thanks, Mike!
	* guile/gc.c: Add missing copyright header.  Thanks, Mike!

2018-07-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: mes: Updatee to 0.16.1.
	* guix.scm (mes): Update to 0.16.1.
	  (mes.git): Likewise.

2018-07-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.16.1
	* configure (VERSION): Bump to 0.16.1.

	doc: Release update.
	* BOOTSTRAP: Update.
	* HACKING: Update.
	* INSTALL: Update.
	* NEWS: Update.
	* README: Update.
	* scaffold/tests/23-pointer.c: Add (janneke) to copyright line.
	* doc/images/gcc-mesboot-graph.png: Update.
	* doc/mes.texi (The Mes Bootstrap Process): Describe update.

	build: setup-mes.sh: Cater for Debian/stretch too.  Thanks, pdewacht!
	* build-aux/setup-mes.sh: Cater for Debian/stretch too.  Thanks,
	  pdewacht!

	core: Fix segfault on Debian/strectch.  Thanks, pdewacht!
	* src/posix.c (execl_): Typo in initialization.  Fixes segfault on
	  Debian/strectch.  Thanks, pdewacht!

	doc: Add html, pdf.
	* GNUmakefile (html, pdf): New target.
	* .gitignore: Ignore html, pdf targets.

	doc: Remarks from Rutger.
	* doc/mes.texi: Remarks from Rutger.

	doc: Further work.
	* doc/images/gcc-mesboot-graph.png: New file.
	* install.sh: Install it.
	* doc/mes.texi (The Mes Bootstrap Process): Show it.
	  (Bootstrapping): Add missing Mes direntry.
	  (Running the Test Suites): Fix example.
	  Fix typos.

	build: Handle CFLAGS, CPPFLAGS for Debian.

	build: Have configure create a git archive.
	* configure: Create git archive if necessary.

	build: Use GNU style lower case directory configure variable naming.
	* GNUmakefile: Use GNU style lower case directory configure variable naming.
	* HACKING: Likewise.
	* INSTALL: Likewise.
	* build-aux/build-cc.sh: Likewise.
	* build-aux/build-cc32.sh: Likewise.
	* build-aux/cc-mes.sh: Likewise.
	* build-aux/cc.sh: Likewise.
	* build-aux/cc32-mes.sh: Likewise.
	* build-aux/export.make: Likewise.
	* build-aux/setup-mes.sh: Likewise.
	* build.sh: Likewise.
	* check.sh: Likewise.
	* configure: Likewise.
	* doc/mes.texi: Likewise.
	* install.sh: Likewise.
	* scripts/mescc: Likewise.

	build: Support Debian build, install.
	* scripts/mescc: Support Debian build, install.
	* lib/libmes.c (fdgetc): Allow Nyacc/ungetc conflict.
	* build-aux/export.make (ARCH): Export.
	* build-aux/build-mes.sh: Disable full build for non-bootstrap
	  x86-only.
	* check.sh (total): Use bash to invoke build-aux/check-mescc.sh.
	* build-aux/build-guile.sh (SCM_FILES): Support guile-2.0.
	* module/mes/guile.scm (guile-2.0): Support guile-2.0.
	* build-aux/build-mes.sh: Use bash.
	* build-aux/setup-mes.sh: New file.

	mescc: Be sure to exit upon system* failure.
	* module/mescc/mescc.scm (assert-system*): New function.
	  (M1->hex2, hex2->elf, M1->blood-elf): Use it.

	build: Support $DESTDIR.
	* build-aux/export.make: export DESTDIR.
	* install.sh: Support $DESTDIR.

	build: Build and install manual pages.
	* build-aux/export.make: New file.
	* GNUmakefile (man): New target.
	  (doc): Depend on man.
	  include build-aux/export.make, remove exports.
	* guix.scm (mes): Add dependency on help2man.
	* configure: Check for help2man.
	* install.sh: Install manual pages if built.

	doc: Initial version.
	* doc/mes.texi: New file.
	* doc/fdl-1.3.texi: New file.
	* AUTHORS: Mention it.
	* GNUmakefile (doc, info, install-info): New targets.
	* install.sh: Install info if available.
	* guix: (mes): Add texinfo to native-inputs.
	* configure: Check for makeinfo.

2018-06-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: mescc-tools: Update to 0.5.1.
	* guix.scm (mescc-tools): Update to 0.5.1.

	guix: Oops, fix nyacc-for-mes checksum.  Thanks, pdewacht!
	* guix.scm (nyacc-for-mes): Fix checksum.

	guix: Update mes to 0.16.
	* guix.scm (mes): Update to 0.16.
	  (mes.git): Likewise.

2018-06-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.16.
	* configure (VERSION): Bump to 0.16.

2018-06-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release update.
	* BOOTSTRAP: Update.
	* HACKING: Update.
	* INSTALL: Update.
	* NEWS: Update.
	* README: Update.
	* doc/ANNOUNCE-0.16: New file.

2018-06-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Fix compile warnings.
	* lib/libmes.c: Fix warning.
	* src/posix.c (execl_): Fix warning, add debug printing.

	core: execl_: Allow 1000 arguments.
	* src/posix.c (execl_): Allow 1000 arguments.

2018-06-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support binutils 2.10.1: strrchr: Stop at start of string.
	* lib/libc+tcc.c (strrchr): Stop at start of string.
	* scaffold/tests/88-strrchr.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

	build: Support tcc, create tinycc-seed with tcc.
	* configure: check for tcc.
	* build-aux/cc32-mes.sh: Rename from cc-mes-gcc.sh.  Support
	  tcc.  Update users.
	* build-aux/build-cc32-mes.sh: Rename from build-mes-gcc.sh.  Update users.
	* GNUmakefile (mes-tcc): New target.
	* .gitignore: Ignore mes-tcc arch output.
	* lib/crt1.c (_start): Add "rm" constraint so satisfy tcc.
	* lib/linux-gcc.c (_sys_call, _sys_call1 _sys_call2 _sys_call3): Likewise.

2018-06-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support glibc-2.2.5: header tweaks.
	* include/sys/types.h [__PTRDIFF_T]: Extra guard for ptrdiff_t.
	  [__SIZE_T]: Extra guard for size_t.
	* include/stdlib.h: Include alloca; remove alloca prototype,
	* include/errno.h: Add E2BIG.

2018-06-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support binutils 2.20.1: vfprint, vsprintf: %llx.
	* lib/libc+tcc.c (vfprintf, vsprintf): Handle %%llx.  Print error:
	  should we skip another int, va_arg a long long?

2018-06-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support binutils 2.14: vfprint, vsprintf: %12.10d.
	* lib/libc+tcc.c (vfprintf, vsprintf): Handle %12.10d.
	* scaffold/tests/70-printf.c: Test it.

2018-06-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support gnu toolchain: libtcc1.
	* lib/libtcc1.c: New file.
	* lib/libc+tcc-gcc.c: Remove libtcc1 stubs.

	mescc: Support binutils-2.20.1a: header tweaks.
	* include/signal.h: Include sys/types.h; remove type declaration copies.
	* include/stdarg.h: Likewise.
	* include/stdio.h: Likewise.
	* include/stdlib.h: Likewise.
	* include/unistd.h: Likewise.

2018-06-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support Tinycc 0.9.27: Drop dlclose, dlopen.
	* lib/libc+tcc.c (dlclose, dlopen): Remove.
	* include/dlfcn.h (RTLD_DEFAULT): Add.

	core: Resurrect dump-tiny.
	* src/reader.c (dump): Resurrect dump-tiny.

	core: Resurrect loading of boot-0.32-mo.

2018-06-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support binutils 2.25: fseek: Add debug printing.
	* lib/libc+tcc.c (fseek): Add debug printing.

	mescc: Tinycc support: bcopy: Do not return void.
	* lib/m4.c (bcopy): Do not return void.  Helps tcc.

	mescc: Support binutils 2.25: memcmp: Support size 0.
	* lib/libc+tcc.c (memcmp): Support size 0.

	mescc: Support binutils 2.25: vsscanf: Skip `l'.
	* lib/libc+tcc.c (vsscanf): Skip `l'.

	mescc: Debugging oops.
	* lib/libc.c (__mes_debug): Oops, wrong direction.

2018-06-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support binutils 2.15a: fread: read ungetc'd chars too.
	* lib/libmes.c (_ungetc_fd): New variable.
	  (fdgetc): Use it.
	  (_fdungetc_p): New function.
	* lib/libc+tcc.c (_fungetc_p): New function.
	* lib/libc+tcc.c (fread): Use it to read ungetc'd chars too.

	mescc: Add another fopen test.
	* scaffold/tests/98-fopen.c: New file.
	* build-aux/check-mescc.sh (tests): Add it.
	* AUTHORS: Mention it.

	mescc: Add fopen test.
	* scaffold/tests/97-fopen.c: New file.
	* build-aux/check-mescc.sh (tests): Run it.
	* include/unistd.h (link): Declare.

	mescc: Support binutils-2.14: fopen: Return 0 upon failure.
	* lib/libc+tcc.c (fopen): Return 0 upon failure.

2018-06-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Update elf32-header for linux-4.17.
	Previously, our binaries showed this

	    $ readelf -s scaffold/main.mes-out
	    There are 2 program headers, starting at offset 64

	    Program Headers:
	      Type           Offset   VirtAddr   PhysAddr   FileSiz MemSiz  Flg Align
	      LOAD           0x000000 0x01000000 0x01000000 0x0557c 0x0557c RWE 0x1
	      LOAD           0x000000 0x01000000 0x01000000 0x0557c 0x0557c RWE 0x1

	     Section to Segment mapping:
	      Segment Sections...
	       00     .text .data
	       01     .text .data

	Linux-4.17 refuses to run this and says

	    Uhuuh, elf segment at 0000000001000000 requested but the memory is mapped already
	    Segmentation fault

	* lib/x86-mes/elf32-header.hex2: Remove unused data program header.

2018-06-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: make seed: Update mescc-tools-seed too.

	guix: mescc-tools: Update to 0.5.
	* guix.scm (mescc-tools): Update to 0.5.

	Update for mescc-tools-0.5.
	* build-aux/build-mes.sh (HEX2FLAGS): Remove = from flags.
	* build.sh (HEX2FLAGS): Likewise.
	* module/mescc/mescc.scm (hex2->elf): Likewise.

2018-06-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: Update mes to 0.15.
	* guix.scm (mes): Update to 0.15.
	  (mes.git): Likewise.

2018-06-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.15.
	* configure (VERSION): Bump to 0.15.

2018-05-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release udpate.
	* BOOTSTRAP: Update.
	* HACKING: Update.
	* NEWS: Update.
	* README: Update.
	* doc/ANNOUNCE-0.15: New file.

2018-06-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Resurrect non-bootstrap build.
	* configure (parse-opts): Support mixing VAR=VALUE --prefix=PREFIX.
	* guix.scm (mes): Remove setting PREFIX in make-flags.
	* install.sh: Cater for Guix's setting read-only of scripts/diff.scm.

2018-06-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support less-patched tcc/gcc: Add crti and crtn.
	* lib/crt0.c[__MESC__]: Support MesCC.
	* lib/crti.c: New file.
	* lib/crtn.c: New file.
	* build-aux/build-mes-gcc.sh: Build them.

	mescc: Refactor debug and stub printing.
	* lib/libc.c (__mes_debug): New function.  Use it for debug printing
	  and in stubs throughout.

	mescc: Support binutils-2.30: fopen fix.
	* lib/libc+tcc.c (fopen): Set O_APPEND for 'a'.

2018-06-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support binutils-2.30.
	* lib/binutils.c (raise, strdup): New function.
	  (mbstowcs): New stub.
	* include/fcntl.h (O_APPEND, FD_CLOEXEC): New define.

	mescc: Support binutils-2.10.1: Stubs set errno to 0.

	mescc: Silence some stubs.
	* lib/libc+tcc.c: [!NOISY_FLOATS, !NOISY_TIMES]: Silence stubs.
	* lib/gcc.c: Likewise.
	* lib/binutils.c: Likewise.

2018-06-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Add debug printing: fopen, fwrite.
	* lib/libc+tcc.c (fopen, fwrite)[MESC_DEBUG]: Print debug info.

	mescc: Support binutils-2.10.1: opentype `r+'.
	* lib/libc+tcc.c (fopen): Support opentype `r+'.

2018-06-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: syscall: return only ever error -1, set errno.

2018-06-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support gcc-2.95: Add getpwnam stub.
	* lib/gcc.c (getpwnam): New stub.

	mescc: Support gcc-3.0: Implement alarm, setitimer.

	mescc: Support gcc-3.0: Implement atexit.

	mescc: Support gcc-3.0: Implement dup2, fcntl, getrusage.
	* include/sys/resource.h: New file.
	* lib/linux+gnu.c (fcntl, dup2, getrusage): New function.
	* lib/binutils.c (fcntl): Remove stub.

	mescc: Support gcc-3.2: Implement getuid, getgid.
	* lib/linux+gnu.c (getuid, getdid): New function.
	* lib/binutils.c (getuid, getdid): Remove stub.

	mescc: Support gcc-3.2: Reset errno.
	* lib/linux-gcc.c (_sys_call, _sys_call1, _sys_call2, _sys_call3):
	  Reset errno.
	* lib/linux-mes.c (__sys_call, __sys_call1, __sys_call2 ,
	  __sys_call3): Rename from _*.
	   (_sys_call, _sys_call1, _sys_call2, _sys_call3): New function.
	  Reset errno.

2018-06-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support gcc-3.2: Implement integer strto*.
	* lib/libc+tcc.c (strtoll, strtoul): Call strtoul.

	mescc: Support gcc-3.2: Add getpid, signal.
	* lib/linux+gnu.c (getpid, signal): New function.
	* include/signal.h: Declare signal.
	* include/unistd.h: Declare getpid.
	* scaffold/tests/95-signal.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

	mescc: Support gcc-3.4.0: *printf: Support `%n'.
	* lib/libc+tcc.c (vfprintf, vsprintf): Support `%n'.  For Gcc 3.4.0.
	* scaffold/tests/70-printf.c: Test it.

	mescc: Support gcc-3.4.0: alloca.
	* lib/alloca.c: New file.
	* AUTHORS: Mention it.
	* lib/libc+gnu.c: Add it.
	* include/stdlib.h: Declare alloca.

	mescc: Support gcc-3.4.0: unsetenv.
	* lib/gcc.c (unsetenv): New function.

	mescc: Support gcc-3.2: Add __divdi3, __moddi3 stubs.
	* lib/gcc.c (__divdi3, __moddi3): New stubs.

	mescc: Support gcc-3.2: puts with newline.
	* lib/libc-mini.c (oputs): Rename from puts.
	  (puts): New function: Add newline.

	mescc: Support binutils-2.10.1.
	xx

2018-06-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support glibc-1.06.4.
	* lib/glibc.c: New file.
	* lib/libc+gnu.c: Include it.

2018-06-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support gcc-2.6.3.
	* TODO

2018-05-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Support binutils-2.5.1.
	* include/stdint.h: #undef types before typedef'ing them.
	* include/sys/types.h: Likewise.
	* include/string.h (NULL): New define.
	* include/stdio.h (BUFSIZ): New define.

2018-06-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	tests: Remove tinycc-imported non-free grep test.
	* scaffold/tinycc/46_grep.c: Remove.
	* scaffold/tinycc/46_grep.expect: Remove.

2018-05-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Implement fflush, sscanf, vsscanf.
	* lib/libc+tcc.c (vsscanf): New function.
	  (sscanf): Use it.
	  (fflush): Remove stub notice; we have no buffering.
	* include/stdarg.h: Declare it.
	* scaffold/tests/87-sscanf.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

2018-05-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Use arch-dir.
	* lib/x86-mes: Move from stage0.
	* build-aux/build-cc.sh: Create libraries in lib/gcc.  Update users.
	* build-aux/build-mes.sh: Create libraries in lib/x86-mes.  Update users.
	* build-aux/build-mes-gcc.sh: Rename from build-mlibc.sh.  Create
	  libraries in lib/x86-mes-gcc.  Update callers.
	* build-aux/cc-mes-gcc.sh: Rename from cc-mlibc.sh.  Update callers.

	mlibc: Implement strstr.
	* lib/libc+tcc.c (_memmem, memmem): New function.  Import from GNU
	  LilyPond.
	  (strstr): Implement using memmem.
	* include/string.h (_memmem, memmem): Declare.
	* AUTHORS: Add Han-Wen Nienhuys.

	mlibc: Implement ftell, fseek.
	* lib/libc+tcc.c (ftell, fseek): Implement.

	mlibc: Cleanup.

2018-05-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: m4 support: WIP

2018-05-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Refactor boot-0 loading.
	* src/mes.c (load_boot): New function.
	  (load_env): Use it.

2018-05-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Out of the box Geiser support.
	* .dir-locals.el: New file.  Out of the box Geiser support for mescc.

2018-05-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Posixify interface.
	* module/mescc/compile.mes: Move from language/c99/compiler.mes.
	* module/mescc: New module..
	* module/mescc/M1.scm: Move from mes/M1.mes.
	* module/mescc/as.scm: Likewise.
	* module/mescc/bytevectors.scm: Likewise.
	* module/mescc/mescc.scm: New file.
	* scripts/mescc: Update to new layout and posixy interface.
	* GNUmakefile: Likewise.
	* build-aux/build-cc.sh: Likewise.
	* build-aux/build-guile.sh: Likewise.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/build-mlibc.sh: Likewise.
	* build-aux/cc-mes.sh: Likewise.
	* build-aux/cc-mlibc.sh: Likewise.
	* build-aux/cc.sh: Likewise.
	* build-aux/check-mescc.sh: Likewise.
	* build-aux/test.sh: Likewise.
	* build.sh: Likewise.
	* .gitignore: Update for posixy extensions.

2018-05-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Add drop, drop-right.
	* module/srfi/srfi-1.mes (drop, drop-right): New function.

2018-05-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "fork/exec: debug."
	This reverts commit f0315ac0d9acd66a30dbb192334f443459b7ed16.

	fork/exec: debug.

2018-05-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Support fork, waitpid, execve.
	* stage0/x86.M1 (SYS_fork, SYS_waitpid, SYS_execve): New define.
	* lib/linux-gcc.c (fork, waitpid, execve): New function.
	* lib/linux-mes.c (fork, waitpid, execve): New function.
	* lib/libc.c (wait): New function.
	* include/unistd.h (fork, execve): Declare.
	* include/sys/wait.h (waitpid, wait): Declare.
	* module/mes/posix.mes (search-path, execlp, system*, waitpid): New function.
	* src/posix.c (primitive_fork, execl): New function.

2018-05-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Oops, alignment.
	* module/mes/M1.mes (object->M1): Oops, alignment: only add alignment
	  when not aligned.

2018-05-26  Jeremiah Orians  <jeremiah@pdp10.guru>

	mescc: Add fopen.
	* lib/libc+tcc.c (fopen)[!POSIX]: Remove stub.
	* lib/libc.c (fopen)[!POSIX]: New function.
	* AUTHORS: Add Jeremiah.

2018-05-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Remove function declarations from M1.
	* module/language/c99/compiler.mes (info->object): Remove function
	  declarations.

	build: Check for mes-seed, tinycc-seed.
	* configure: Check for guile-tools, mes-seed, tinycc-seed.  Bugfix:
	  Add cwd to load path.

2018-05-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: mes: Update to 0.14.
	* guix.scm (mes): Update to 0.14.
	  (mes.git): Likewise.

2018-05-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: Add nyacc-for-mes.
	* guix.scm (nyacc-for-mes): New variable.

2018-05-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.14.
	* configure (VERSION): Bump to 0.14.

2018-05-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release udpate.
	* BOOTSTRAP: Update.
	* HACKING: Update.
	* NEWS: Update.
	* README: Update.
	* doc/ANNOUNCE-0.14: New file.

2018-05-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Handle short struct initializer.
	* module/language/c99/compiler.mes (array-init-element->data): Handle
	  short struct initializer.

2018-05-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Align global data.
	* module/mes/M1.mes (object->M1): Align globals.

2018-05-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: strncpy.
	* lib/libc+tcc.c (strncpy): New function.
	* scaffold/tests/86-strncpy.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.
	* build-aux/cc-mlibc.sh (LIBC): Acknowlegde.
	* build-aux/test.sh (LIBC): Export it.

2018-05-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	tinycc: Add stubs: __fixdfdi, __fixxfdi, __fixsfdi.
	* lib/libc+tcc-gcc.c (__fixdfdi, __fixxfdi, __fixsfdi): New stub.

2018-05-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	tinycc: Add stubs: __floatundixf __fixunsxfdi.
	* lib/libc+tcc-gcc.c (__floatundixf, __fixunsxfdi): New stub.

	mescc: Tinycc support: workaround for tcc; this breaks: Structured type with char or short on heap.
	* module/language/c99/compiler.mes (int->bv): Always use 32bit byte
	  vector.

2018-05-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Structured type with char or short on heap.
	* module/language/c99/compiler.mes (int->bv): New function.
	  (init->data): Use it.  Add parameter.  Update callers.
	  (array-init->data): Add type parmeter.
	  (array-init-element->data): Likewise.
	* module/mes/bytevectors.mes (bytevector-u8-set!): New function.
	* module/mes/bytevectors.scm (mes): Export it.
	* module/mes/as.mes (int->bv8): New function.

2018-05-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Fix size ERROR message.
	* module/language/c99/compiler.mes (expr->accu): Fix size ERROR message.

	mescc: Fix itoa.
	* lib/libc.c (itoa): Use function-static buffer.  Increase to 12 to
	  handle INT_MIN.
	  (itoab): Likewise.

2018-05-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Export nested struct definitions.
	* module/language/c99/compiler.mes (struct-field): Support nested,
	  named and anonymous enums.
	  (field->info): New function.
	  (type->info): Use it to reap nestedly defined enums, structs, unions.
	  (decl->info): Likewise.
	* scaffold/tests/t.c: Test it.

	mescc: Tinycc support: Unsigned comparison.
	* stage0/x86.M1 (ja32, jae32, jb32, jbe32): New macro.
	* module/mes/as-i386.mes (i386:jump-a, i386:jump-ae, i386:jump-b,
	  i386:jump-be): Use it in new function.
	* module/mes/as-i386.scm: Export them.
	* module/language/c99/compiler.mes (test-jump-label->info): Use them to
	  support unsigned comparison.
	* scaffold/tests/7s-unsigned-compare.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

2018-05-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Char and short sign extend.
	* module/mes/as-i386.mes (i386:accu*n->local, i386:byte-accu->local+n,
	  i386:word-accu->local+n): Remove.
	  (i386:byte-accu, i386:signed-byte-accu, i386:word-accu,
	  i386:signed-word-accu): New function.
	* module/mes/as-i386.scm: Export them.
	* module/language/c99/compiler.mes (accu->local+n-text): Simplify.
	  (mem->accu, convert-accu): New function.
	  (expr->accu): Use them.
	* stage0/x86.M1 (mov____%al,0x32(%ebp), mov____%al,0x8(%ebp),
	  mov____%ax,0x32(%ebp), mov____%ax,0x8(%ebp), movzbl_0x32(%ebp),%eax,
	  movzbl_0x8(%ebp),%eax, movzwl_0x32(%ebp),%eax,
	  movzwl_0x8(%ebp),%eax): Deprecate.
	* scaffold/tests/7r-sign-extend.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

2018-05-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: string->number: Support upper case hex.
	* module/mes/scm.mes (string->number): Support upper case hex.

2018-05-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Minimal float support.
	* lib/libc+tcc.c (ldexp, strtod, strtof, strtold): New stub.
	* include/math.h (ldexp): Declare.
	* include/stdlib.h (strtod, strtof, strtold): Declare.
	* module/mes/scm.mes (string->number): Minimal float support.
	  (inexact->exact): New function.
	* tests/math.test ("string->number"): Test it.
	* module/language/c99/compiler.mes (ast->type): Handle float type.
	  (type->info): Likewise.
	  (cstring->int): Rename from cstring->number.  Update callers.
	  (cstring->float): New function.
	  (expr->accu): Use it.

2018-05-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Switch with heterogeneous body, non-last default.
	* module/language/c99/compiler.mes (switch->info): New function.
	  (ast->info): Use it for switch.
	  (clause->info, statements->clauses): Remove.
	* scaffold/tests/44-switch.c (default_first): Test it.

2018-05-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Support fold 3.
	* module/srfi/srfi-1.mes (fold): Support fold 3.

2018-05-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Compound strings as function argument.
	* module/language/c99/compiler.mes (expr->accu): Handle compound
	  strings as function argument.
	* module/mes/M1.mes (object->M1): Call error when string not found.
	* scaffold/tests/t.c: Test it.

	mescc: Tinycc support: Update some tests.

	mescc: Tinycc support: Add __lshrdi3, __ashldi3, __ashrdi3.
	* lib/libc+tcc-gcc.c (__lshrdi3, __ashldi3, __ashrdi3): New function.

	mescc: Tinycc support: Fix sizeof interesting expressions.
	* module/language/c99/compiler.mes (ast->type): Return type for
	  sizeof-expr, sizeof-type.
	* scaffold/tests/85-sizeof.c: Test it.

2018-05-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Support bit-fields.
	* module/language/c99/compiler.mes (struct->fields): Support bit-fields.
	  (ast->type):
	  (field-field):
	  (field-offset):
	  (expr->accu*):
	  (expr->accu):
	  (struct-field):
	  (->size):
	* module/language/c99/info.scm (<bit-field>): New type.
	* stage0/x86.M1 (and____$i32,%eax, and____(%edx),%eax,
	  mov____(%edx),%eax, or____(%edx),%eax): New macro.
	* module/mes/as-i386.mes (i386:base-mem->accu): Use
	  it.
	  (i386:accu-and, i386:accu-and-base-mem, i386:accu-or-base-mem): New
	  function.
	* module/mes/as-i386.scm: Export them.
	* scaffold/tests/7q-bit-field.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

2018-05-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Anonymous string array.
	* module/language/c99/compiler.mes (global->info): Anonymous string
	  array.
	  (local->info): Likewise.
	  (array-init->string): Support array of char.
	  (init-local): Likewise.
	  (->size): Fix for array.
	* scaffold/tests/4a-char-array.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

	mescc: Tinycc support: sizeof: Bugfix for c-array.
	* module/language/c99/compiler.mes (->size): Bugfix for c-array.
	* scaffold/tests/85-sizeof.c: Test it.

2018-05-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Implement ((struct foo*)p)->bar.
	* module/language/c99/compiler.mes (expr->accu*):
	* scaffold/tests/7p-struct-cast.c: Test it.
	* build-aux/check-mescc.sh (tests): Run it.

2018-05-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Implement (foo--)->bar and permutations.
	* module/language/c99/info.scm (clone): Add post field.
	  (make): Handle post parameter.
	* module/language/c99/compiler.mes (clone): Handle post parameter.
	  (expr->accu*): Set it to support foo--/foo--.
	  (expr->accu): Read it to support foo--/foo--.
	* scaffold/tests/7o-struct-pre-post.c: Test it.
	* build-aux/check-mescc.sh: Run it.

2018-05-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: Function addresses.

	mescc: Tinycc support: Numeric constant expressions.

	mescc: Tinycc support: Function variables.

	mescc: Tinycc support: Pointer typedefs.

	mescc: Tinycc support: Array typedefs.

	mescc: Tinycc support: Sizeof struct destruct.

	mescc: Tinycc support: Anonymous union initialization.

	mescc: Tinycc support: Fix for ?-operator.

	mescc: Tinycc support: Valued function assign.

2018-05-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Refactor type system: WIP
	* module/language/c99/compiler.mes (): WIP
	* module/language/c99/info.scm (): WIP

	mescc: Refactor type system: struct/enum fields: (name . <type>).
	* module/language/c99/compiler.mes (struct-field): Refactor.
	  (field:name): Update.
	  (field:pointer): Update.
	  (field:size): Update.
	  (field:type): Remove.
	  (->size): New function.

2018-05-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Refactor type system: introduce <array>, <pointer>, <var>.
	* module/language/c99/info.scm (<array>, <pointer>, <var>): New type.
	* module/language/c99/compiler.mes (ast-><type>): New function.
	  (ast-type): Use it.

2018-05-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Refactor variable declaration.
	* module/language/c99/compiler.mes (decl->info): Refactor.

2018-05-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Handle sizeof expression.
	* module/language/c99/compiler.mes (expr->accu): Handle sizeof
	  expression.
	* scaffold/tests/85-sizeof.c: Test it.

	mescc: Handle struct field lists.
	* module/language/c99/compiler.mes (struct-field): Return list of
	  fields.  Update callers.
	* scaffold/tests/84-struct-field-list.c: Test it.
	* build-aux/check-mescc.sh (tests): Add it.

	mescc: Support heterogeneous variable init.
	* module/language/c99/compiler.mes (decl->info): Support heterogeneous
	  variable init.
	* scaffold/tests/83-heterogenoous-init.c: Test it.
	* build-aux/check-mescc.sh (tests): Add it.

	mescc: Handle (Skip) global static.
	* module/language/c99/compiler.mes (decl->info): Handle (Skip) global
	  static.
	* scaffold/tests/48-global-static.c: Test it.

	mescc: Support functions in expression.
	* module/language/c99/info.scm (<function>): New type.
	* module/language/c99/compiler.mes (ast->type): Support function.
	  (expr->type-size): Likewise.
	  (expr->type): Likewise.
	  (expr->accu*): Likewise.
	  (function->info): Create <function>.
	* module/mes/M1.mes (object->M1): Grok <function>.
	* scaffold/tests/47-function-expression.c: Test it.
	* build-aux/check-mescc.sh: Add it.

	mescc: Support function-static variables.
	* module/language/c99/info.scm (make): Add statics field.
	  (<global>): Add name and function fields.  Update callers.
	  (global->string): New function.
	* module/mes/M1.mes (object->M1): Update.
	* module/language/c99/compiler.mes (clone): Add statics field.
	  (ident->accu): For <global>, use global in text (WAS: name).
	  (ident-address->accu): Likewise.
	  (ident-address->base): Likewise.
	  (decl-local->info): New function.
	  (decl->info): New function.
	  (ast->info): Use them.
	  (function->info): Keep globals in object (WAS: global:value only).
	* scaffold/tests/46-function-static.c: Test it.

2018-05-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Add unfold.
	* module/srfi/srfi-1.mes (unfold): New function.

	mes: Add const.
	* module/mes/scm.mes (const): New function.
	* tests/scm.test ("const"): Test it.

2018-05-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Add logxor.
	* src/math.c (logxor): New function.
	* tests/math.test ("logxor"): Test it.

	mes: string-join: Support optional delimiter, support grammar.
	* module/srfi/srfi-13.mes (string-join): Support optional infix and
	  grammar.
	* tests/srfi-13.test ("string-join"): Test it.

	core: reader: Support binary #b101.
	* src/reader.c (reader_read_binary): New function.
	  (reader_read_hash): Use it.
	* tests/scm.test ("binary"): Test it.

2018-05-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Support srfi-9-gnu.
	* module/srfi/srfi-9/gnu.mes: New file.  Support srfi-9-gnu.
	* tests/srfi-9.test: Test it.
	* tests/srfi-9.test-guile:

2018-04-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Have core:eval expand macros.
	* src/mes.c (core:eval-expand): Remove
	  (core:eval-expanded): New variable.
	  (eval_apply): Have core:eval expand macros; core:eval-expanded evals
	  expanded sexps.

2018-04-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "core: Remove pmatch-car, pmatch-cdr hack."
	This reverts commit be1e84624ea4a158173f34af923e3c4a3793412a.

2018-04-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Remove pmatch-car, pmatch-cdr hack.
	* src/mes.c (scm_vm_eval_pmatch_car, scm_vm_eval_pmatch_cdr): Remove
	  (eval_apply): Remove cell_vm_eval_pmatch_car,
	  cell_vm_eval_pmatch_cdr hack.
	  (mes_symbols): Remove cell_symbol_pmatch_car, cell_symbol_pmatch_cdr.
	* scaffold/mini-mes.c: Likewise.
	* module/mes/guile.scm (mes): Remove pmatch-car, pmatch-cdr.
	* module/mes/pmatch.scm (ppat): Use plain car, cdr.

2018-05-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Do not assume /bin/sh, basename/dirname.
	* install.sh: Do not assume /bin/sh, basename/dirname.
	* scripts/diff.scm: Likewise.

	build: Build mini-libc and libc+tcc-gcc too.
	* include/getopt.h[__GNUC__ && POSIX]: Only use include_next.
	* lib/libc+tcc-gcc.c[POSIX](longjmp, setjmp, __udivdi3, __umoddi3):
	  Remove.
	* build-aux/build-cc.sh: Build mini-libc-gcc and libc+tcc-gcc too.
	* build-aux/build-mlibc.sh: Build mini-libc-gcc too.

	boot: Bugfix for diff on mes.
	* scripts/diff.scm (diff-files): Rename from diff; Avoids name clash
	  with module to allow using -e '(<module>)' hack.

	build: Install naive diff.
	* scripts/diff.scm: Move from build-aux.
	* install.sh: Install it.
	* build-aux/tests.sh: Update location.

2018-05-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Update configure.
	* configure: Update.

2018-05-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Remove debugging.
	* module/mes/module.mes (mes-load-module-env): Remove debugging.

2018-05-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Use ../mes-seed/refresh.sh, ../tinycc-seed/refresh.sh.
	* GNUmakefile (seed): Use ../mes-seed/refresh.sh, ../tinycc-seed/refresh.sh.

2018-05-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Guile fixes.
	* scripts/mescc: Set GODIR.  Add module as expression to Mes
	  invokation.  Remove explicit (second) call to main.

2018-05-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Use diff -ub for tinycc tests.
	* build-aux/diff.scm: Support -b.
	* build-aux/test.sh: Use it.

2018-05-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	check: Also test with i686-unknown-linux-gnu-gcc.
	* check.sh (CC32): New variable.
	* build-aux/test.sh: Also test with CC32.o

2018-05-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: configure: Handle VAR=VALUE.  Update help.
	* configure: Handle VAR=VALUE.  Update help.

2018-05-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Fixes for Debian and /bin/sh == dash.
	* build.sh: Use separate export stanzas.  Use command -v (WAS: type
	  -p).  Fixes sh, /bin/sh == dash.
	* build-aux/build-cc.sh: Likewise.
	* build-aux/build-guile.sh: Likewise.
	* build-aux/build-mes.sh: Likewise.
	* build-aux/build-mlibc.sh: Likewise.
	* build-aux/cc-mes.sh: Likewise.
	* build-aux/check-mescc.sh: Likewise.
	* check.sh: Likewise.
	* install.sh: Likewise.
	* scripts/mescc: Likewise.

	build: Rebuild after build from seed.
	* build-aux/build-mes.sh: Rebuild after build from seed.

	mescc: Use file-name as global prefix.
	* module/mes/M1.mes (object->M1): Add file-name parameter.

2018-05-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Fixes for int-max, int-min.
	* src/math.c (greater_p): Fix INT_MAX > 0.
	  (less_p): Fix INT_MIN < 0.
	* tests/math.test ("< INT-MIN"): Test it.
	  ("< INT-MAX"):
	  ("> INT-MAX"):
	  ("> INT-MAX 0"):
	  ("> INT-MIN"):
	* tests/srfi-13.test ("string->number INT-MAX"): Test it.
	  ("string->number INT-MIN"):
	  ("number->string INT-MAX"):
	  ("number->string INT-MIN"):
	* scaffold/tests/60-math.c (test): Test it.

	mescc: Fix dumping of strings > M1_STRING_MAX.
	* module/mes/M1.mes (object->M1): Skip opening quote.

2018-04-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "core: length: Check parameter."
	This reverts commit 1f52ed35c66febcce16e06868e803a39be7eda41.

	core: length: Check parameter.
	* src/mes.c (length): Check parameter.

2018-05-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: enable all tests, use expect count, add tinycc tests.
	* build-aux/check-mescc.sh (tests): Add tinycc tests.
	* build-aux/diff.scm: Naive diff for tinycc tests.
	* build-aux/test.sh: Run diff when .expect found.

2018-04-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Simplify, drop make.scm experiment.
	* build.sh: Rewrite.
	* build-aux/build-cc.sh: New file.
	* build-aux/build-mes.sh: New file.
	* build-aux/build-mlibc.sh: New file.
	* build-aux/cc.sh: New file.
	* build-aux/cc-mes.sh: New file.
	* build-aux/cc-mlibc.sh: New file.
	* install.sh: Update.
	* make.scm: Remove.
	* guile/guix/make.scm: Remove.
	* guile/guix/records.scm: Remove.
	* guile/guix/shell-utilsg.scm: Remove.

2018-04-30  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Use length__.
	* src/mes.c (check_formals): Use length__.

2018-04-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes-snarf: Support running with Mes.
	* build-aux/mes-snarf.scm: Support running with Mes.

	mes: Support -C and -L for Guile compatibility.
	* module/mes/boot-0.scm): Support -C and -L for Guile compatibility.

	mes: Support -e,--main option.
	* module/mes/boot-0.scm: Support -e,--main option.

	mes: Upgrade Guile module support.
	* module/mes/boot-0.scm (define-module): New macro with minimal Guile support.
	  (use-modules): New macro.

	mes: Add srfi-8.
	* module/srfi/srfi-8.mes: New file.

	mes: string-join: Handle empty list.
	* module/mes/boot-0.scm (string-join): Handle empty list.

	mes: Add basename.
	* module/mes/posix.mes (basename): New function.

	mes: Add delete-duplicates.
	* module/srfi/srfi-1.mes (delete-duplicates): New function.

	mes: filter-map: Handle two lists.
	* module/srfi/srfi-1.mes (filter-map): Handle two lists, add error
	  when called with three or more.

	mes: Add string-replace.
	* module/srfi/srfi-13.mes (string-replace): New function.
	* tests/srfi-13.test ("string-replace"): Test it.

	mes: Add string-map.
	* module/srfi/srfi-13.mes (string-map): New function.
	* tests/srfi-13.test ("string-map"): Test it.

	mes: Add string-trim, string-trim-right, string-trim-both.
	* module/srfi/srfi-13.mes (string-trim, string-trimn-right,
	  string-trim-both): New function.
	* tests/srfi-13.test ("string-trim"): Test it.
	  ("string-trim-right"):
	  ("string-trim-both"):

	mes: Add string-contains.
	* module/srfi/srfi-13.mes (string-contains): New function.
	* tests/srfi-13.test ("string-contains"): Test it.
	  ("string-contains not"):

	mes: string-drop: Error on negative droppings.
	* module/srfi/srfi-13.mes (string-drop, string-take,
	  string-drop-right): Error on negative droppings.
	* tests/srfi-13.test ("string-drop"): Test it.

	core: reverse!: Handle empty list.
	* src/mes.c (reverse_x_): Handle empty list.
	* tests/scm.test ("reverse! ()"): Test it.

	core: Add string ports.
	* src/mes.c (type_t): Add TPORT.
	  (scm_type_port): New symbol.
	  (PORT): New macro.
	  (MAKE_STRING_PORT): New macro.
	  (eval_apply): Handle string ports in primitive-load.
	  (mes_symbols): Add scm_type_port.
	* src/posix.c (peekchar): Handle string ports.
	  (readchar): New function.  Replace all getchar callers.
	  (unreadchar): Likewise.
	* module/mes/type-0 (port?): New function.
	* module/mes/guile.mes (with-input-from-file): Rewrite.
	  (open-input-string): Remove.
	* module/mes/guile.scm (guile): Update cell types.
	* src/gc.c (gc_loop): Support TPORT.
	* src/lib.c (display_helper): Support TPORT.
	* module/mes/display.mes (display): Support TPORT.

	mes: assq, assoc-ref: Handle non-A-LISTs.
	* src/mes.c (assq): Return #f if A-LIST is not a list.
	* module/mes/scm.mes (assoc): Likewise.

	core: Use single definition rule for cell-type.
	* src/mes.c (scm_type_char, scm_type_closure, scm_type_continuation,
	  scm_type_function, scm_type_keyword, scm_type_macro,
	  scm_type_number, scm_type_pair, scm_type_ref, scm_type_special,
	  scm_type_string, scm_type_symbol, scm_type_values,
	  scm_type_variable, scm_type_vector): New symbol.
	  (mes_symbols): Add them.
	* module/mes/type-0.mes (<cell:char>, <cell:char>, <cell:closure>,
	  <cell:continuation>, <cell:function>, <cell:keyword>, <cell:macro>,
	  <cell:number>, <cell:pair>, <cell:ref>, <cell:special>,
	  <cell:string>, <cell:symbol>, <cell:values>, <cell:variable>,
	  <cell:vector>, <cell:broken-heart): Remove.
	* module/mes/boot-0.scm: Likewise.
	* module/mes/boot-01.scm: Likewise.
	* module/mes/boot-02.scm: Likewise.
	* scaffold/boot/20-define-quote.scm: Likewise.
	* scaffold/boot/37-closure-lambda.scm: Likewise.
	* scaffold/boot/38-simple-format.scm: Likewise.
	* scaffold/boot/4c-quasiquote.scm:
	* scaffold/boot/4e-string-split.scm: Likewise.
	* scaffold/boot/51-module.scm: Likewise.
	* scaffold/boot/52-define-module.scm: Likewise.
	* scaffold/boot/60-let-syntax.scm: Likewise.
	* module/mes/guile.scm: Add some of them.

	core: Fix gc_up_arena for x86_64.
	* src/gc.c (gc_): Fix gc_up_arena for x86_64.

	core: Fix compile warnings.
	* src/posix.c: Include sys/stat.h.
	  (chmod): Return cell_unspecified.
	* include/stdlib.h: Typo.

	mlibc: Declare chmod.
	* include/sys/stat.h (mode_t, chmod): Declare.

2018-04-28  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: Update mes to 0.13.
	* guix.scm (mes): Update to 0.13.
	  (mes.git): Likewise.

2018-04-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.13.
	* configure (VERSION): Bump to 0.13.

2018-04-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release udpate.
	* BOOTSTRAP: Update.
	* HACKING: Update.
	* NEWS: Update.
	* README: Update.
	* doc/ANNOUNCE-0.13: New file.

2018-04-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Merge mescc.mes and mescc.scm.
	* scripts/mescc: New file.
	* scripts/mescc.mes: Remove.
	* guile/mescc.scm: Remove.
	* guile/guix/make.scm (CC.mescc): Update.
	* install.sh (TINYCC_SEED): Update.
	* make.scm (bootstrap?): Update.
	* test.sh (MES): Update.
	* check-boot.sh: Use $GUILE to allow running without Guile.

	core: Add chmod.
	* src/posix.c (chmod_): New function.

2018-04-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: jam-scaper/garbage-collector: Use only one arena.
	* src/mes.c (ARENA_SIZE): Lower to 200000.
	  (MES_MAX_ARENA): Bump to 300000000.
	  (JAM_SIZE): New global.
	  (make_cell__): Remove ARENA assert.
	  (gc_init_cells): Alloc ARENA_SIZE + JAM_SIZE.
	  (mes_symbols): Do not init news.
	  (gc_init_news): Remove.
	  (main): Initialize JAM_SIZE, consider MES_JAM environment variable.
	* src/gc.c (gc_init_news): Move from mes.c.  Start at g_free.
	  (gc_flip): Do not flip to g_news, instead copy g_news to cells.
	  (gc_up_arena): Realloc to ARENA_SIZE + JAM_SIZE.
	  (gc_): Init news.  Only up arena if g_news is safe.

2018-04-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Create less garbage when dumping M1.
	* module/mes/M1.mes (display-join): New function.
	* (object->M1): Use it.

	core: last_pair: Move to core.
	* src/lib.c (last_pair): New function.
	* module/mes/scm.mes (last-pair): Remove.

	core: equal2_p: Add short-circuit and eliminate tail call.
	* src/lib.c (equal2_p): Add short-circuit and eliminate tail call.

2018-04-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Use display for dumping M1.
	* module/mes/M1.mes (object->M1): Use display for dumping M1.

2018-04-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Guile-like command-line interface.
	* module/mes/boot-0.scm (tty?): Guile-like command-line interface.
	* scripts/repl.mes: Remove.
	* scripts/mescc.mes: Update.
	* tests/*.test: Update scripts.
	* module/mes/repl.mes (repl): Add ,quit.

	mes: getopt-long: Support stop-at-first-non-option.
	* module/mes/getopt-long.scm (process-options): Fix parsing `-'.  Add
	  parameter: stop-at-first-non-option.
	  (getopt-long): Add keyword parameter #:stop-at-first-non-option.

	mes: Add isatty?.
	* src/posix.c (isatty_p): New function.

	mlibc: Add isatty.
	* lib/libc.c (isatty): New function.
	* include/unistd.h: Declare it.

	mlibc: Add ioctl.
	* stage0/x86.M1 (SYS_ioctl): New define.
	* lib/linux-mes.c (ioctl): New syscall.
	* lib/linux-gcc.c (ioctl): New syscall.
	* include/sys/ioctl.h: New file.

2018-04-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Compile minimal mes with MES_MINI=1.
	* src/mes.c: Compile minimal mes with MES_MINI=1.

2018-04-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	core; reader_read_string: Support escaped characters.
	* src/reader.c (reader_read_string): Support escaped characters.

2018-04-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "mescc: Use core:write."
	This reverts commit d88e31dfec3158a830c32f9f732b052cfccac6eb.

2018-04-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Use core:write.
	* scripts/mescc.mes (source->ast): Use core:write.

2018-04-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: display: Display escaped characters.
	* module/mes/display.mes (display): Display escaped characters.

2018-04-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: display_helper: Display escaped characters.
	* src/lib.c (display_helper): Display escaped characters.

	mes: Resurrect macros in repl.
	* src/mes.c (scm_vm_begin_expand): Rename to core:begin-expand.
	 (eval_apply): Expose it.
	* module/mes/repl.mes (repl): Use it to resurrect macros.

	core: Fixes for garbage collector/jam scraper.
	* src/gc.c (gc_loop): Do not relocate car of TCLOSURE, TCONTINUATION.
	  Check for TBROKEN_HEART.
	* src/mes.c (make_closure_): Set car to 0.
	  (check_apply): Check for TBROKEN_HEART.  Fixes reporting artificial
	  out-of-memory error.
	  (eval_apply): Likewise.
	* src/vector.c (vector_entry): Only copy TCHAR and TNUMBER.

	core: drop global_p from variable.
	* src/mes (struct scm): Remove field global_p.
	 (VARIABLE_GLOBAL_P): Remove.
	 (make_variable_): Remove global_p parameter.  Update callers.
	* src/lib.c (display_helper): Drop VARIABLE_GLOBAL_P support.

	core: Reenable full printing of lists.
	* src/lib.c (display_helper): Reenable full printing of lists.

2018-04-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: append2, append_reverse, reverse, reverse!: Create less garbage.
	* src/mes.c (append_reverse): New function.
	  (reverse_x_): New function.
	  (append2): Use them to create less garbage.
	* module/mes/scm.mes (reverse): Create less garbage.
	* module/srfi/srfi-1.mes (reverse!): Rewrite, use core:reverse!.
	  (append-reverse): Remove.

	core: vector_to_list: Create less garbage.
	* src/vector.c (vector_to_list): Create less garbage.

	core: Optimize vector-map, vector-for-each.
	* module/srfi/srfi-43.mes (vector-map): Optimize.
	  (vector-for-each): Optimize.
	* tests/srfi-43.test: New file.
	* tests/srfi-43.test-guile: New file.
	* check.sh (tests): Add it.
	* make.scm (mes-tests): Add it.

2018-04-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "build-32.sh"
	This reverts commit ace8b6f1b52de58c9ab404ed13234f397dac6bdc.

2018-04-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	build-32.sh

2018-04-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Cleanup make_cell, remove tmp cells.
	* src/mes.c (make_cell__): New function.
	  (make_cell_): Use it.
	  (length__): New function.
	  (tmp, tmp_num, tmp_num2, tmp_num_, tmp_num2_, make_tmps): Remove.
	  Update callers to use make_cell__ directly.
	 * src/vector.c (make_vector__): New function.
	  (make_vector_): Use it.

2018-04-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "mlibc: Use memmove in realloc."
	This reverts commit f47a21e3cb4814c4a30d10ff59e5c947441725e9.

2018-04-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	mlibc: Use memmove in realloc.
	* src/libc.c (memmove): New function.
	  (realloc): Use it.
	* src/libc+tcc.c (memmove): Remove.

	mes: Add char-whitespace?
	* module/srfi/srfi-14.mes (char-whitespace?): New function.

2018-04-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Move base-0.mes int boot-0.scm.
	* module/mes/boot-02.scm: New file, rename from boot-0.scm.
	* module/mes/boot-0.scm: Add base-0.mes.
	* module/mes/base-0.mes: Remove.

2018-04-13  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Unify mlibc-gcc and mes builds.
	* make.scm (bin.gcc): Remove stray slash.
	* src/mes.c: Unify mlibc-gcc and mes builds.
	(gc_init_cells):
	(gc_init_news):
	(bload_env):
	* src/reader.c (reader_read_character):
	(reader_read_string):

2018-04-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Remove local variables from gc.
	* src/gc.c (gl_loop): Remove local variables.

	core: Listen to MES_SAFETY environment variable.

	core: Remove local variables from eval/apply.
	* src/mes.c (eval_apply): Move all variables to global scope.

	core: Remove MesCC reminder.

2018-04-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Update default memory settings.
	* src/mes.c (MAX_ARENA_SIZE)[__MESC__]: Set to maximum 172100000.

2018-04-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Tune debug printing.
	* src/mes.c: Tune debug printing.
	* src/gc.c: Likewise.
	* module/mes/guile.mes: Likewise.
	* HACKING: Describe it.

	core: Rewrite reader to create less garbage.
	* src/reader.c (reader_read_line_comment): Rename from read_line_comment.
	(reader_identifier_p): New function.
	(reader_end_of_word_p): New function.
	(reader_read_identifier_or_number): New function.
	(reader_read_sexp_): Rewrite.  Update callers.
	(reader_read_list): Rewrite.
	(reader_lookup_): Remove.

2018-04-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Add isspace.
	* include/ctype.h (isspace): Declare.
	* lib/libc.c (isspace): New function.

2018-04-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Rewrite string reader.
	* src/reader.c (reader_read_string): Rewrite, create much less
	  garbage.
	  (append_char): Remove.

	install: Fix prefix confusion.
	* install.sh: Substitute @PREFIX@ with MES_PREFIX.
	* scripts/mescc.mes: Grok PREFIX as MES_PREFIX.

	guix.scm: Update mes to 0.12.
	* guix.scm (mes, mes.git): Update to 0.12.

2018-04-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	Release 0.12.
	* configure (VERSION): Bump to 0.12.

2017-11-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release udpate.
	* HACKING: Update.
	* INSTALL: Update.
	* NEWS: Update.
	* README: Update.
	* doc/ANNOUNCE-0.12: New file.
	* throughout: (janneke) coming out.

2018-04-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix.scm: Update mescc-tools to 0.4.
	* guix.scm (mescc-tools): Update to 0.4.

	core: Workaround for mescc.
	* src/mes.c (eval_apply)[__MESC__]: Add reminder for macro_p, global_p.

2018-04-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Remove scripts/mes symlink.

	mes: Add string-fold, string-fold-right.
	* module/srfi/srfi-13.mes (string-fold, string-fold-right): New
	  function.
	* tests/srfi-13.test ("string-fold"): Test it.
	  ("string-fold-right"): Test it.

	mes: Allow tick as part of identifier.
	* src/reader.c (reader_read_sexp_): Do not treat tick as special.

	mescc: Remove debugging.
	* module/language/c99/compiler.mes: Remove debugging.

	mescc: No comments in M1 when running on Mes.
	* module/language/c99/compiler.mes (ast-comment): If mes?, return nil.

	mescc: Trace globals.
	* module/language/c99/compiler.mes (mescc:trace): New function.  Use
	  throughout.

	Revert "core: Add member."
	This reverts commit 921686a0a3b06281f1804d04e6d4a0344dda507a.

	core: Add member.
	* src/lib.c (member): New function.
	* module/mes/scm.mes (member): Remove.

	mescc: trace M1 dumping.
	* module/language/c99/compiler.mes (info->object): Add tracing.
	* module/mes/M1.mes (object->M1): Add tracing.

	Revert "guix: Update nyacc to 0.83.31."
	This reverts commit 624b85d6b1dd876542f7ad342d6beb8a92408397.

	guix: Update nyacc to 0.83.31.
	* guix.scm (nyacc): Update to 0.83.31.

	mescc: Have Nyacc trace functions while parsing.
	* guile/mescc.scm (main): Set NYACC_TRACE.
	* scripts/mescc.mes (main): Set NYACC_TRACE.

	mes: Add setenv.
	* src/posix.c (setenv_): New function.
	* tests/base.test ("setenv, getenv"): Test it.

	core: Add setenv.
	* lib/libc.c (setenv): New function.
	* include/stdlib.h (setenv): Declare it.
	* scaffold/tests/61-array.c (test): Test it.

2018-04-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: Add manifest.
	* build-aux/manifest.scm: New file.

	guix: Update Nyacc to 0.80.42.
	* guix.scm (nyacc): Update to 0.80.42.

2018-04-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Also print `parsing: input' when using -E.
	* module/language/c99/compiler.mes (c99-input->ast): Print `parsing:
	  input'.
	  (c99-input->info): Remove that.

2018-04-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Cleanup reader.
	* src/reader.c (reader_read_sexp_): Rename from reader_read_word_.  Cleanup.
	  (read_hash): Cleanup.

	mes: Cleanup formatting.

	core: Add equal2?.
	* src/lib.c (equal2_p): New function.
	* module/mes/base.mes (equal2?): Remove.

	core: Add memq.
	* lib/mes.c (memq): New function.
	* module/mes/scm.mes (memq): Remove.

	mes: Remove duplicate memq.
	* module/mes/base-0.mes (memq): Remove.

2017-12-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Single environment lookup for variables, SICP chapter 3.
	* src/mes.c (t): Add TVARIABLE.
	  (scm_vm_eval_deref): New vm special.
	  (make_vref_): New internal function.
	  (eval_apply): WIP: replace symbols with their variable reference.
	* src/gc.c (gc_loop): Handle TVARIABLE.
	* src/lib.c (display_helper): Handle TVARIABLE.
	* module/mes/type-0.mes (<cell:variable>): New variable.
	  (cell:type-alist): Add it.
	  (variable?): New function.
	* module/mes/display.mes (display): Handle <variable>.

2018-04-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Remove override hook for read-input-file.
	* src/reader.c (read_input_file_env): Remove override hook for
	read-input-file.

2018-03-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Iterative recursive macro expand.
	* src/mes.c (eval_apply): Iterative recursive macro expand.
	* src/posix.c (set_current_input_port): Return previous port.
	* module/mes/catch.mes (%eh): Use core:display.
	* module/mes/display.mes (display-cut, display-cut2): Move macro
	  definitions to toplevel.

2018-04-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: records.scm: update from upstream.
	* guile/guix/records.scm: Update from upstream.

2018-01-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Add incremental test suite.
	* check-boot.sh: New file.
	* check.sh: Invoke it.
	* module/srfi/srfi-16.mes: New file.
	* scaffold/boot/00-zero.scm: New file.
	* scaffold/boot/01-true.scm: New file.
	* scaffold/boot/02-symbol.scm: New file.
	* scaffold/boot/03-string.scm: New file.
	* scaffold/boot/04-cons.scm: New file.
	* scaffold/boot/04-quote.scm: New file.
	* scaffold/boot/05-list.scm: New file.
	* scaffold/boot/06-tick.scm: New file.
	* scaffold/boot/07-if.scm: New file.
	* scaffold/boot/08-if-if.scm: New file.
	* scaffold/boot/10-cons.scm: New file.
	* scaffold/boot/11-list.scm: New file.
	* scaffold/boot/12-car.scm: New file.
	* scaffold/boot/13-cdr.scm: New file.
	* scaffold/boot/14-exit.scm: New file.
	* scaffold/boot/15-display.scm: New file.
	* scaffold/boot/16-if-eq-quote.scm: New file.
	* scaffold/boot/20-define-quote.scm: New file.
	* scaffold/boot/20-define-quoted.scm: New file.
	* scaffold/boot/20-define.scm: New file.
	* scaffold/boot/21-define-procedure.scm: New file.
	* scaffold/boot/22-define-procedure-2.scm: New file.
	* scaffold/boot/23-begin.scm: New file.
	* scaffold/boot/24-begin-define.scm: New file.
	* scaffold/boot/25-begin-define-2.scm: New file.
	* scaffold/boot/26-begin-define-later.scm: New file.
	* scaffold/boot/26-define-define.scm: New file.
	* scaffold/boot/27-lambda-define.scm: New file.
	* scaffold/boot/28-define-define.scm: New file.
	* scaffold/boot/29-lambda-define.scm: New file.
	* scaffold/boot/2a-lambda-lambda.scm: New file.
	* scaffold/boot/2b-define-lambda.scm: New file.
	* scaffold/boot/2c-define-lambda-recurse.scm: New file.
	* scaffold/boot/2d-define-lambda-set.scm: New file.
	* scaffold/boot/2e-define-second.scm: New file.
	* scaffold/boot/30-capture.scm: New file.
	* scaffold/boot/31-capture-define.scm: New file.
	* scaffold/boot/32-capture-modify-close.scm: New file.
	* scaffold/boot/33-procedure-override-close.scm: New file.
	* scaffold/boot/34-cdr-override-close.scm: New file.
	* scaffold/boot/35-closure-modify.scm: New file.
	* scaffold/boot/36-closure-override.scm: New file.
	* scaffold/boot/37-closure-lambda.scm: New file.
	* scaffold/boot/38-simple-format.scm: New file.
	* scaffold/boot/40-define-macro.scm: New file.
	* scaffold/boot/41-when.scm: New file.
	* scaffold/boot/42-if-when.scm: New file.
	* scaffold/boot/43-or.scm: New file.
	* scaffold/boot/44-or-if.scm: New file.
	* scaffold/boot/45-pass-if.scm: New file.
	* scaffold/boot/46-report.scm: New file.
	* scaffold/boot/47-pass-if-eq.scm: New file.
	* scaffold/boot/48-let.scm: New file.
	* scaffold/boot/49-macro-override.scm: New file.
	* scaffold/boot/4a-define-macro-define-macro.scm: New file.
	* scaffold/boot/4b-define-macro-define.scm: New file.
	* scaffold/boot/4c-quasiquote.scm: New file.
	* scaffold/boot/50-primitive-load.scm: New file.
	* scaffold/boot/51-module.scm: New file.
	* scaffold/boot/52-define-module.scm: New file.
	* scaffold/boot/53-closure-display.scm: New file.
	* scaffold/boot/60-let-syntax.scm: New file.
	* scaffold/boot/closure.scm: New file.
	* scaffold/boot/compose.scm: New file.
	* scaffold/boot/data/bar.mes: New file.
	* scaffold/boot/data/i.scm: New file.
	* scaffold/boot/data/module.mes: New file.
	* scaffold/boot/foo.scm: New file.
	* scaffold/boot/lambda-star.scm: New file.
	* scaffold/boot/vector.scm: New file.
	* tests/boot.test: New file.
	* tests/boot.test-guile: New file.
	* tests/srfi-16.test: New file.
	* tests/srfi-16.test-guile: New file.

2018-02-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Boot from MES_BOOT, boot-0.scm.
	* src/mes.c (load_env): Softcode loading of boot-0.scm from
	  environment variabl MES_BOOT.
	* module/mes/boot-00.scm: New file.
	* module/mes/boot-01.scm: New file.
	* module/mes/boot-0.scm: Rename from read-0.mes.
	* module/mes/module.mes: New file.

2018-03-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: Add -fno-stack-protector for debian.
	* guile/guix/make.scm (%C32-FLAGS): Add -fno-stack-protector.

2018-01-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: reader: reader_ prefix; read/write char/string in core.
	* src/posix.c (peek_char, read_char, read_string, unread_char, write_char): New function.
	* src/reader.c: Use reader_ prefix.

	r#	bootstrappable.org

2018-01-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: More informative error reporting for number asserts.
	* src/math.c (assert_number): New function.  Update assert () users.

2018-01-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	guile: Resurrect eval/apply in scheme.
	* guile/mes.mes (eval-expand): Short-circuit make-closure.
	* guile/mes.scm (environment): Update.

2018-02-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: simple-format: support ~A, ~S.
	* module/mes/display.scm (simple-format): support ~A, ~S.

2018-01-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	core: Display and write string and char compliance.
	* src/lib.c (display_helper): Display and write char and string compliance.

2018-02-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: display: Support keyword.
	* src/lib.c (display_helper): Support keyword.

2018-01-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: display: vector.
	* src/lib.c (display_helper): Display vector.

2018-01-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: display: closure names.
	* src/lib.c (display_helper): Display closure names.

2018-01-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Rename make-vector to core:make-vector.
	* src/vector.c (make_vector_): Rename from make_vector.  Update callers.

	mes: Better error reporting.
	* src/lib.c (write_error_): New function.
	* src/mes.c (error, check_apply): Use it.
	  (append2, set_car_x): Upon error, call error (WAS: assert).

	Revert "mes: un-defmacro optargs.  WIP"
	This reverts commit 5da527c540dc0e1481a010899233b4e806fe37da.

2018-01-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: un-defmacro optargs.  WIP

	mes: Test optargs without pmatch.
	* tests/optargs.test: Remove pmatch.

	mes: Add define-macro*.
	* module/mes/optargs.mes (define-macro*): New macro.

2018-01-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Evaluate test of COND only once.
	* module/mes/base-0.mes (cond): Evaluate test of COND only once.
	  Fixes cond tests with side effects (Nyacc).
	* tests/base.test ("cond side effect"): Test it.

2018-01-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: #\page is whitespace.
	* module/srfi/srfi-14.mes (char-set:whitespace): Add #\page.

	mes: #<eof> is not a character.
	* module/mes/display.mes (display):
	* module/mes/type-0.mes (char?): -1 is not a character.
	  (eof-object?): New function.
	* tests/base.test ("#<eof>"): Test it.
	* module/mes/scm.mes (eof-object?): Remove.
	  (unread-char): Return character (WAS: integer).

	mes: open-input-string: peek fix.
	* module/mes/guile.mes (open-input-string): Return actual tell.
	* tests/guile.test ("open-input-string peek"): Test it.

	mes: with-input-from-string: peek fix.
	* module/mes/guile.mes (with-input-from-string): Return actual tell.
	* tests/guile.test ("with-input-from-string peek"): Test it.

2018-01-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Resurrect guile-1.8.
	* guile/mescc.scm: Use GUILE_LOAD_COMPILED_PATH instead of -C.
	  [guile]: Include syncase.
	* module/language/c99/compiler.scm [guile]: Stub pretty-print-c99.
	  Set stack to unlimited.
	* module/language/c99/info.scm [guile]: Include (ice-9 syncase).
	* module/mes/as-i386.scm [guile]: Likewise.
	* module/mes/guile.scm [guile]: Add compose, export it.

	mes: Add string-drop-right.
	* module/srfi/srfi-13.mes (string-drop-right): New function.

2018-01-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: cleanups.
	* guile/mescc.scm: Cleanups.
	* module/language/c99/compiler.mes:
	* module/language/c99/compiler.scm:
	* module/language/c99/info.mes:
	* module/language/c99/info.scm:
	* module/mes/getopt-long.mes:
	* module/mes/optargs.mes:
	* module/mes/optargs.scm:
	* module/mes/repl.mes:
	* module/mes/scm.mes:
	* scripts/mescc.mes:

	nyacc cpp-debugging, tests

	mes: getopt-long: fix multi-opt and unclumping.
	* module/mes/getopt-long.scm (remove-if-not): Remove.
	  (option-spec): Add value field.  Update users.
	  (expand-clumped-singles): Simplify, fix.
	  (process-options): To get an option's value, use value instead of
	  value-policy.  Fixes multi-opt.
	* tests/getopt-long.test: New file.
	* make.scm (mes-tests): Add it.
	* check.sh (tests): Add it.
	* tests/getopt-long.test-guile: New symlink.

	guix: back to 0.80.41 for tinycc.
	guix.scm (nyacc): New variable.

2018-01-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Support equal? with arbitrary number of arguments.
	* module/mes/base.mes (equal2?): Rename from equal?.
	  (equal?): Implement.

	mescc: Use records for mes too.
	* module/language/c99/info.mes: Use info.scm records, remove
	  simplistic list data structures.

	mescc.mes: Use write for preprocessing output.
	* scripts/mescc.mes (source->ast): Use core:write instead of pretty-print.

	mes: Add write, core:write.
	* src/lib.c (display_helper, fdisplay_): Add parameter, write_p.
	  Update callers.  When write_p: write quoted strings.
	  (write_, write_port_): New function.
	* module/mes/read-0.mes (write): New function.

	mes: gc_safety.

	check-mescc.sh: run with mes.
	* src/build.sh:
	* src/check-mescc.sh: Run with mes.

	mes: Add string-null?.
	* module/srfi/srfi-13.mes (string-null?): New function.

	mes: Add dirname.
	* module/mes/guile.mes (dirname): New function.

2018-01-01  Jan Nieuwenhuizen  <janneke@gnu.org>

	test: Add syntax tests.
	* tests/syntax.test: New file.
	* tests/syntax.test-guile: New file.

	fixup: 1b0696f9 (Jan Nieuwenhuizen 2018-01-01 15:53:13 +0100 40) ,        (lambda ()

2017-12-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "mes: use array-based stack. WIP: will not survice gc."
	This reverts commit 7fb653f68c2dbf8bc83cce4bd138439c600b538f.

2017-12-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: use array-based stack. WIP: will not survice gc.
	* src/mes.c (STACK_SIZE)[MES_ARRAY_STACK]: New variable.
	  (g_stack_array): New variable.
	  (g_stack): Change type to SCM*.
	* (gc_push_frame)[MES_ARRAY_STACK]: Use g_stack_array, g_stack.
	  (gc_peek_frame): Likewise.
	  (gc_pop_frame): Likewise.
	* src/gc.c (gc_check): Likewise.
	  (gc): Likewise.

2017-12-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Fix assq to improve performance.
	* src/mes.c (assq): Special case eq_p to improve performance.

2017-12-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Reimplement records.
	* module/srfi/srfi-9.mes (define-record-type): New macro.
	* AUTHORS: Update.
	* module/mes/record-0.mes: Remove.
	* module/mes/record.mes: Remove.
	* module/srfi/srfi-9-psyntax.mes: Remove.
	* module/srfi/srfi-9.scm: Remove.
	* make.scm: Remove them.

	mes: Fix display of closure.
	* module/mes/display.mes (display): Drop extra ( at start of *closure*, *circ*.
	* src/lib.c (display_helper): Likewise.

2017-12-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Resurrect define, define-macro in C core.
	* make.scm (bin.gcc, bin.mescc): Use MES_C_READER=1.
	* src/mes.c (scm_symbol_define, scm_symbol_define_macro): New symbol.
	  (scm_vm_eval_define): New special.
	  (scm_symbol_c_define): New symbol.
	  (MAKE_MACRO): New define.
	  (eval_apply)[MES_C_DEFINE]: Handle define, define-macro.
	  (mes_symbols): Define %c-define for use in read-0.mes.
	* module/mes/read-0.mes: Do not implement full scheme define if %c-define.
	* module/mes/quasiquote.mes (sexp:define, env:define, env:macro): New function.
	  (define-macro): New macro.  FIXME
	* module/mes/psyntax.mes (define): New macro.  FIXME

2017-12-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Fix initial display.
	* module/mes/read-0.mes (display): Fix.

2017-12-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Fix compile warning in reader.
	* src/reader.c[MES_C_READER]: Declare read_block_comment, read_hash.
	  Fixes compile warning.

2017-12-09  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Allow invoking git mescc.mes from elsewhere.
	* src/mes.c (load_env): Look in MES_PREFIX too.  Add debug printing.
	* scripts/mescc.mes: Consider MES_PREFIX.
	* guile/mescc.scm (%prefix): Consider MES_PREFIX.
	* module/mes/base-0.mes (string->list): New function, move from type-0.mes.
	  (%moduledir): Consider MES_PREFIX.
	* module/mes/type-0.mes (string->list): Remove.

	mescc: Output performance hacks: use core:display.
	* src/lib.c (display_): Write to g_stdout (WAS: STDOUT).
	* module/mes/guile.scm (guile): Declare and export core:display core:display-error.
	* module/mes/M1.mes (object->M1): Use core:display and string-append
	  instead of format.
	* module/mes/guile.mes (with-input-from-string): Add debugging.
	  (open-input-string): Likewise.
	  (read-string): Likewise.  Re-implement.
	  (drain-input): Use read-string.

	mes: Nyacc support: substring/copy, substring/shared.
	* module/srfi/srfi-13.mes (substring/copy, substring/shared): Define
	  to substring.

	mes: Nyacc support: Read old characters.
	* src/reader.c (read_character)[MES_C_READER]: Support reading old
	  characters: #\bel, #\bs, #\vt.

	mes: resurrect running MesCC: handle \t in strings.
	* src/reader.c (read-string): Handle \t.  Fixex M1 output.

	mescc: Use small, bootstrappable syntax rather than huge psyntax seed.
	* module/nyacc/lex.mes (mes): Use syntax (WAS: psyntax).
	* module/mes/pmatch.mes (mes): Likewise.
	* module/nyacc/lang/c99/parser.mes (srfi-9): Use syntax (WAS: srfi-9-psyntax).

	mes: Fix for pmatch on bootstrappable syntax-rules.
	* module/mes/pmatch.scm (ppat): Do not use let.
	* tests/pmatch.test ("pmatch nyacc minimal", "pmatch nyacc"): Test it.

2017-12-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	mlibc: M4 support: robustify headers, add sys/signal.h.
	* include/errno.h (ERANGE): New define.
	* include/stdarg.h (size_t): Undefine before typedef.
	* include/stdint.h: Likewise.
	* include/stdio.h: Likewise.
	* include/stdlib.h: Likewise.
	* include/sys/types.h: Likewise.
	* include/string.h: Likewise.
	  (ssize_t): Undefine before typedef.
	* include/unistd.h: Likewise.
	  (off_t): Undefine before typedef.
	* include/sys/stat.h (struct stat): New stub.
	* include/sys/signal.h: New file.

2017-12-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: M4 support: scaffold/tests/82-define.c.
	* scaffold/tests/82-define.c: New file; inspired by M4.  Thanks, Ricardo!
	* make.scm ("82-define"): Build it.
	* check-mescc.sh: Add 82-define.

	mlibc: Tinycc support: Avoid hex.
	* include/00-test.i (main)[__TINYC__]: Do not use $0x.

	mlibc: Tinycc support: qsort.
	* lib/libc+tcc.c (qswap, qpart): New function
	  (qsort): Implement.
	* scaffold/tests/81-qsort.c: Test it.
	* make.scm ("81-qsort"): Build it.

2017-12-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: scaffold: misc cleanups.
	* scaffold/tests/44-switch.c (swits): More case labels.
	* scaffold/tests/60-math.c: Discriminate return values.
	* scaffold/tests/77-pointer-assign.c (memset)[__TINYC__]: Remove.
	* scaffold/tests/79-int-array.c (test): Discriminate return values.

	mlibc: Tinycc support: __udivdi3, __umoddi3.
	* lib/libc+tcc-gcc.c (__udivdi3, __umoddi3): Fix signature, do not
	  crash on simple integer devisions.

	mescc: Tinycc support: Respect word size better.
	* stage0/x86.M1 (movzwl_0x32(%ebp),%eax,movzwl_0x8(%ebp),%eax): New
	  define.
	* module/mes/as-i386.mes (i386:push-word-local-de-ref,
	  i386:word-local->accu): New function.
	* module/mes/as-i386.scm: Export them.
	* module/language/c99/compiler.mes (push-local-de-ref): Respect word size.
	  (ident->accu): Likewise.

	mlibc: New library layout; remove duplication.
	* lib/libc+tcc-gcc.c: New file: Libc bits for GCC from libc-mes+tcc.c.
	* lib/libc+tcc-mes.c: New file: Libc bits for MesCC from libc-mes+tcc.c.
	* lib/libc+tcc.c: New file: Libc bits from libc-mes+tcc.c.
	* lib/libc.c: New file: Merged from libc-mes.c, libc-gcc.c.
	  (abtoi): New function: Rename from _atoi.
	* lib/linux+tcc-gcc.c: New file:  Linux bits from libc-gcc+tcc.c.
	* lib/linux+tcc-mes.c: New file: Linux bits from libc-mes+tcc.c.
	* lib/linux-gcc.c: New file: Linux bits from libc-gcc.c.
	* lib/linux-mes.c: New file: Linux bits from libc-mes.c.
	* lib/mini-libc-gcc.c: New file.
	* lib/mini-libc.c: New file: Libc bits from mini-libc-mes.c.
	* lib/mini-linux-gcc.c: New file.
	* lib/mini-linux-mes.c: New file: Linux bits from mini-libc-mes.c.
	* lib/libc-gcc.c: Remove duplication using include now.
	* lib/libc-mes.c: Likewise.
	* lib/mini-libc-mes.c: Likewise.
	* include/stdio.h (puts)[POSIX]: Remomve macro.
	  (fputc, fputs)[!POSIX]: New macro.
	  (fputc, fputs): Remove declaration.
	* scaffold/tests/7j-strtoull.c (strtoull, test): Use abtoi.
	* src/lib.c (fputs)[__MESC__]: Remove define.
	* guile/guix/make.scm: Update for new library layout.
	* make.scm: Likewise.
	* build.sh: Likewise.
	* install.sh: Likewise.

	mlibc: Tinycc support: itoab, for debugging.
	* lib/libc-gcc.c (itoab): New function.
	* lib/libc-mes.c (itoab): New function.

2017-12-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: prefix string labels with _.
	* module/mes/M1.mes (object->M1): Prefix string lables with _.

	mescc: prefix local labels with _.
	* module/language/c99/compiler.mes (expr->accu): prefix local labels with _.

	bootstrap: Update build script.
	* build.sh: Add blood-elf, use -o.

	mlibc: Mescc-tools support: fix for [v]fprintf.
	* lib/libc-mes+tcc.c (vfprintf): Bugfix: print to fd.

2017-11-29  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: resurrect full reader in C core.
	* module/mes/read-0.mes (defined?): New function.
	  (eat-whitespace, read-env, read-word, read-block-comment,
	  read-line-comment, read-list, read-character, read-hex, read-octal,
	  reader:read-string, lookup, read-hash, read-word): Only define if
	  not %c-reader.
	* module/mes/base-0.mes (defined?): Remove.
	* src/mes.c[MES_C_READER]: Set ARENA_SIZE=10000000.
	  (scm_symbol_quasiquote scm_symbol_unquote,
	  scm_symbol_unquote_splicing, scm_symbol_syntax,
	  scm_symbol_quasisyntax, scm_symbol_unsyntax,
	  scm_symbol_unsyntax_splicing): New symbol.
	  (scm_symbol_c_reader): New symbol.
	  (MAKE_KEYWORD)[MES_C_READER]: New define.
	  (mes_symbols): Define %c_reader.
	* src/reader.c (read_word_)[MES_C_READER]: Extend to full Scheme
	  reader.
	  (eat_whitespace)[MES_C_READER]: Likewise.
	  (read_block_comment, read_hash, read_word, read_character,
	  read_octal, read_hex, append_char, read_string)[MES_C_READER]:
	  Likewise.
	* make.scm (bin.gcc,bin.mescc): Define MES_C_READER=1.

2017-11-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Mescc-tools support: char foo[BAR] = {'a', 'b', 'c'}.
	* stage0/x86.M1 (mov____%al,0x8(%ebp), mov____%al,0x32(%ebp),
	  mov____%ax,0x8(%ebp), mov____%ax,0x32(%ebp)): New define.
	* module/mes/as-i386.mes (i386:accu->local+n,i386:byte-accu->local+n,
	  i386:word-accu->local+n): New function.
	* module/language/c99/compiler.mes (accu->local+n): New function.
	  (initzer->data): Return char as single byte.
	  (decl->info): Support char foo[BAR] = {'a', 'b', 'c'}.
	* scaffold/tests/66-local-char-array.c: Test it.
	* make.scm (add-scaffold-test): Build it.

2017-11-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	mlibc: Mescc-tools support: chmod.
	* stage0/x86.M1 (SYS_chmod): New define.
	* lib/libc-gcc.c (chmod): New function.
	* lib/libc-mes.c (chmod): New function.

	mlibc: GNU Gcc support: setjmp, longjmp.
	* stage0/x86.M1 (jmp____*%ebx): New macro.
	  (mov____0x8(%ebp),%ebp): New macro.
	  (mov____0x8(%ebp),%esp): New macro.
	* include/setjmp.h (jmp_buf): Redefine as struct.
	* lib/libc-mes+tcc.c (longjmp, setjmp): Implement.
	* scaffold/tests/80-setjmp.c: Test it.
	* make.scm ("80-setjmp"): Build it.
	* .gitignore: Ignore *.tcc-guile.

2017-11-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mlibc: GNU Gcc support: ferror.
	* lib/libc-mes+tcc.c (ferror): New function.
	* include/stdio.h (ferror): Declare it.

2017-11-24  Jan Nieuwenhuizen  <janneke@gnu.org>

	bootstrap: Add bootstrap build scripts.
	* build.sh: New file.
	* check-mescc.sh: New file.
	* check.sh: New file.
	* install.sh: New File.

2017-11-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	remove obsolete Nyacc link.
	* guile/nyacc: Remove.

2017-11-22  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: mlib/include to include, move mlib to lib.
	* include: Move from mlib/include.
	* lib: Move from mlib.
	* BOOTSTRAP: Update.
	* HACKING: Update.
	* guile/guix/make.scm: Update.
	* make.scm: Update.
	* module/language/c99/compiler.mes: Update.

2017-11-21  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Resurrect running mes tests tests/*.test with Guile.
	* tests/tests/base.test-guile: New file to resurrect running Mes test with Guile.
	* tests/catch.test-guile: Symlink for same purpose.
	* tests/closure.test-guile: Likewise.
	* tests/cwv.test-guile: Likewise.
	* tests/display.test-guile: Likewise.
	* tests/fluids.test-guile: Likewise.
	* tests/guile.test-guile: Likewise.
	* tests/let-syntax.test-guile: Likewise.
	* tests/let.test-guile: Likewise.
	* tests/match.test-guile: Likewise.
	* tests/math.test-guile: Likewise.
	* tests/module.test-guile: Likewise.
	* tests/optargs.test-guile: Likewise.
	* tests/peg.test-guile: Likewise.
	* tests/pmatch.test-guile: Likewise.
	* tests/psyntax.test-guile: Likewise.
	* tests/quasiquote.test-guile: Likewise.
	* tests/read.test-guile: Likewise.
	* tests/record.test-guile: Likewise.
	* tests/scm.test-guile: Likewise.
	* tests/srfi-1.test-guile: Likewise.
	* tests/srfi-13.test-guile: Likewise.
	* tests/srfi-14.test-guile: Likewise.
	* tests/vector.test-guile: Likewise.
	* make.scm (add-guile-test): New function.  Use it to run running tests/*.test-guile.

2017-11-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: resurrect running MesCC: handle \t in strings.
	* module/mes/read-0.mes (reader:read-string): Handle \t.  Fixex M1 output.

	mes: Nyacc support: with-fluids.
	* module/mes/fluids.mes (with-fluids): New macro.
	* tests/fluids.test ("with-fluids"): Test it.

	mes: resurrect running MesCC: update info interface.
	* module/language/c99/info.mes (type?, global?, local?): New function.
	  (make-global): Remove name parameter.
	* module/nyacc/lang/c99/pprint.mes: New file.

2017-12-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Add last.
	* module/srfi/srfi-1.mes (last): New funcion.

2017-11-20  Jan Nieuwenhuizen  <janneke@gnu.org>

	mes: Add reverse-list->string.
	* module/srfi/srfi-13.mes (reverse-list->string): New function.

	bootstrap: Unbundle necessary M1 sources.
	* mlibc/crt1.M1: Remove.
	* mlibc/libc-mes.M1: Remove.
	* src/mes.M1: Remove.

2017-11-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	mlibc: Mescc-tools support: fix fgetc.
	* mlibc/libc-mes.c (fgetc): Fix from completely fubar.

	mlibc: Mescc-tools support: strtol: partly implement stub.
	* mlibc/libc-mes+tcc.c (strtol): Partly implement stub.

	mlibc: Mescc-tools support: getopt, getopt_long.
	* mlibc/getopt.c: Move to ANSI C.  Remove GETOPT_COMPAT and
	  non-POSIXLY_CORRECT options.
	* mlibc/include/getopt.h: New file.
	* mlibc/libc-gcc+tcc.c: Include getopt.c.
	* mlibc/libc-mes+tcc.c: Likewise.

	mlibc: Mescc-tools support: import getopt_long.
	* mlibc/getopt.c: Import from gcc-2.0.

	Revert "mescc: Grok char foo[] parameter."
	This reverts commit c4cc75105db48b550cd515751b766b2e7a88ddc3.

	mescc: Grok char foo[] parameter.
	* module/language/c99/compiler.mes (function->text+data): Grok char
	  foo[] parameter.

	mescc: Grok char *const foo[];
	* module/language/c99/compiler.mes (ast-strip-const): Grok char *const argv[];

	mlibc: Mescc-tools support: endianness.
	* mlibc/include/endian.h: New file.
	* mlibc/include/ctype.h[!(__GNUC__ && POSIX)]: Include it.
	* mlibc/include/stdlib.h: Likewise.
	* mlibc/include/sys/types.h: Likewise.

	mlibc: Mescc-tools support: exit stati.
	* mlibc/include/stdlib.h (EXIT_FAILURE, EXIT_SUCCESS): New define.

2017-11-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: cleanup obsolete Nyacc 0.7x compatibility.
	* module/language/c99/compiler.mes (ast-type->type, ast->type
	  expr->accu, struct-field, decl->info,): Remove obsolete Nyacc 0.7x
	  patterns.

	guix: Release update.
	* guix.scm (mes): Update commit, hash and version.  Add
	  'make-git-source-writable stage.

	Release 0.11.
	* configure (VERSION): Bump to 0.11.

2017-11-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	doc: Release udpate.
	* HACKING: Update.
	* INSTALL: Update.
	* NEWS: Update.
	* README: Update.
	* doc/ANNOUNCE-0.11: New file.

2017-11-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: fix for 07-include, thanks rain1!
	* make.scm (add-scaffold-test): New keyword parameter: includes.
	  ("07-include"): Use it.

	build: support gcc -m32, thanks rain1!
	* guile/guix/make.scm (%CC32): fallback to %CC.
	  (%C32-FLAGS): Add -m32, to suppor gcc -m32.
	  (LINK.gcc): Use it.

2017-11-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	bootstrap: Update necessary M1 sources.
	   M1 -f stage0/x86.M1 -f mlibc/crt1.M1 --LittleEndian --Architecture=1 > mlibc/crt1.hex2
	   M1 -f stage0/x86.M1 -f mlibc/mini-libc-mes.M1 --LittleEndian --Architecture=1  > mlibc/libc-mes.hex2
	   M1 -f stage0/x86.M1 -f src/mes.M1 --LittleEndian --Architecture=1 > src/mes.hex2
	   hex2 --LittleEndian --Architecture=1 --BaseAddress=0x1000000 -f stage0/elf32-header.hex2 -f mlibc/crt1.hex2 -f mlibc/libc-mes.hex2 -f src/mes.hex2 -f stage0/elf32-footer-single-main.hex2 > src/mes-mes
	   exec_enable src/mes-mes

	* mlibc/libc-mes.M1: Update.
	* src/mes.M1: Udate.

2017-11-18  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: test #include.
	* scaffold/tests/exit-42.i: New file.
	* scaffold/tests/07-include.c: New file.
	* make.scm ("07-include"): Build it.

2017-11-17  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: struct struct array.
	Support

	  struct foo
	  {
	    struct bar baz[N];
	    struct bar bla*[M];
	  };

	* module/language/c99/compiler.mes (expr->accu):
	* scaffold/tests/7n-struct-struct-array.c: Test it.
	* make.scm (add-scaffold-test): Build it.

2017-11-16  Jan Nieuwenhuizen  <janneke@gnu.org>

	mlibc: Tinycc support: support, most syscalls stubbed.
	* mlibc/libc-gcc.c (exit, write)[__TINYC__]: tcc-compatible gcc-style
	  asm implementation.
	  (read,open,access,brk,fsync)[__TINYC__]: Stub body.
	* mlibc/libc-gcc+tcc.c (close,unlink, lseek, getcwd)[__TINYC__]: Stub
	  body.
	* mlibc/libc-mes+tcc.c: Support tinycc.
	* mlibc/include/00-test.i (main) [__TINYC__]: Support tcc.

	mescc: Tinycc support: empty for.
	* module/language/c99/compiler.mes (test-jump-label->info): Handle
	  empty expression.
	* make.scm (add-tcc-test "45_empty_for"): Test it.

	tinycc: scaffold/main.c: running mes-tcc compiled binary #6.
	* scaffold/main.c (main): Use variable, if, argc, ++, +=, function call to return 42.

2017-11-15  Jan Nieuwenhuizen  <janneke@gnu.org>

	tinycc: scaffold/main.c: running mes-tcc compiled binary #5.
	* scaffold/main.c (main): Use function call and variable to return 42.

2017-11-14  Jan Nieuwenhuizen  <janneke@gnu.org>

	tinycc: scaffold/main.c: running mes-tcc compiled binary #4.
	* scaffold/main.c (main): Use variables to return 42.

	mescc: Tinycc support: workaround lack of long long support.
	* module/language/c99/compiler.mes (i386:type-alist): Use size=4 for
	  long long as a workaround.

2017-11-11  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: refactor expr->accu, expr->accu*, fixes nontrivial struct by value assign.
	* module/language/c99/compiler.mes: (pke): New function.
	  (expr->number): Rename from p-expr->number.  Update callers.
	  (decl->info, init-declr->pointer, struct-field): Several pointeryness fixes.
	  (expr->accu*, expr->accu): Remove special-casing for foo.bar,
	  foo->bar, foo[bar].  Fixes struct by value assign for non-trival
	  expressions.
	  (accu->ident, ident-address->accu, ident->accu):
	  (base->ident-address, ident->base): Remove.
	* scaffold/tests/7k-for-each-elem.c (test): Test it.
	* scaffold/tests/7c-dynarray.c (test): Test it.
	* scaffold/tests/7m-struct-char-array-assign.c: Test it.
	* make.scm (add-scaffold-test): Build it.

	mlibc: errno.h: declare errno without extern.
	* mlibc/include/errno.h: drop extern.  Fixes tcc compile.

	guix: nyacc: Update to 0.82.4.
	* guix.scm (nyacc): Update to 0.82.4.

2017-09-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: Release update.
	* guix.scm (mes): Update commit, hash and version.

	Release 0.10.
	* configure (VERSION): Bump to 0.10.

	doc: Release udpate.
	* HACKING: Update.
	* INSTALL: Update.
	* NEWS: Update.
	* doc/ANNOUNCE-0.10: New file.
	* BOOTSTRAP: New file.
	* make.scm: Install them.

2017-09-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	bootstrap: Include necessary M1 sources.
	   M1 -f stage0/x86.M1 -f mlibc/crt1.M1 --LittleEndian --Architecture=1 > mlibc/crt1.hex2
	   M1 -f stage0/x86.M1 -f mlibc/mini-libc-mes.M1 --LittleEndian --Architecture=1  > mlibc/libc-mes.hex2
	   M1 -f stage0/x86.M1 -f src/mes.M1 --LittleEndian --Architecture=1 > src/mes.hex2
	   hex2 --LittleEndian --Architecture=1 --BaseAddress=0x1000000 -f stage0/elf32-header.hex2 -f mlibc/crt1.hex2 -f mlibc/libc-mes.hex2 -f src/mes.hex2 -f stage0/elf32-footer-single-main.hex2 > src/mes-mes
	   exec_enable src/mes-mes

	* mlibc/crt1.M1: New File.
	* mlibc/libc-mes.M1: New File.
	* src/mes.M1: New File.

2017-09-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	guix: Bump Nyacc to 0.82.0.
	* guix.scm (nyacc): Bump to 0.82.0.

	mescc: Support Nyacc-0.81.0.
	* module/language/c99/compiler.mes (ast->info): Handle asm-expr from
	  Nyacc 0.81.0.

2017-09-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	tinycc: scaffold/main.c: running tcc-compiled binary #3.
	* scaffold/main.c (main): Remove asm.

2017-09-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: struct by value assign.
	* module/language/c99/compiler.mes (expr->accu): warn for unsupported
	  sizes.
	* scaffold/tests/7h-struct-assign.c (test): Test it.

2017-09-02  Jan Nieuwenhuizen  <janneke@gnu.org>

	tinycc: scaffold/main.c: running tcc-compiled binary #2.
	* scaffold/main.c (main)[__i386__]: Rename from _start.

2017-09-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	build: compile crt1.c, libc-mesc.c and <input>.c separately.
	* mlibc/crt1.c: New file.
	* mlibc/libc-mes.c (_start): Remove.
	* mlibc/libc-gcc.c (_start): Remove.
	* make.scm (LINK.hex2, bin.mescc): Move from guile/guix/make.scm.
	* guile/guix/make.scm (LINK.hex2, bin.mescc): Remove.

2017-09-03  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: refactor _start.
	* mlibc/libc-mes.c (_start): Refactor.
	  (_env): Remove.
	* stage0/x86.M1:

2017-08-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	tinycc: scaffold/main.c: first running tcc-compiled binary.
	* scaffold/main.c (_start): Exit 42 using asm.

2017-08-27  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: fix *--p = 'x'.
	* module/language/c99/compiler.mes (expr->accu): Respect size in *--p = 'x'.
	* scaffold/tests/23-pointer.c (test): Test it.

	mescc: Tinycc support: initializer arithmetic.
	* module/language/c99/compiler.mes (p-expr->bool): New function
	  (p-expr->number): Support bitwise-and, bitwise-not, cast, cond-expr.

	core: Add logand, lognot.
	* src/math.c (logand, lognot): New function.

	mescc: Tinycc support: array of struct of any size.
	* module/language/c99/compiler.mes (accu*value): New function
	  (expr->accu*): Use it to support array of struct of any size.
	* scaffold/tests/7l-struct-any-size-array.c: Test it.
	* make.scm (add-scaffold-test): Build it.

	mescc: Tinycc support: stdint.h: declare size_t.
	* mlibc/include/stdint.h (size_t)[!__MES_SIZE_T]: Declare.

2017-08-26  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: pointer arithmetic with pointer-variable.
	* module/language/c99/compiler.mes (expr->accu): pointer arithmetic with pointer-variable.
	* scaffold/tests/76-pointer-arithmetic.c (test): Test it.
	* mlibc/include/stdarg.h (va_start): Update for fixed pointer arithmetic.

2017-08-25  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: pointer arithmetic with &variable.
	* module/language/c99/compiler.mes (expr->pointer): Handle ref.
	* scaffold/tests/76-pointer-arithmetic.c: Test it.

2017-08-23  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: pointer arithmetic with variable.
	* module/language/c99/compiler.mes (expr->accu): Support pointer
	  arithmetic with variable: p + i, p - i, p += i, p -= i.
	* scaffold/tests/76-pointer-arithmetic.c (test): Test it.

	mescc: Tinycc support: handle pointerness, siziness for cast foo*.
	* module/language/c99/compiler.mes (expr->pointer): Support cast foo*.
	  (expr->size): Likewise.
	* scaffold/tests/7k-for-each-elem.c: Test it
	* make.scm (add-scaffold-test): Build it.

2017-08-19  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: strtoull.
	* mlibc/include/mlibc.h (_atoi): Declare.
	* mlibc/include/ctype.h (isxdigit): Declare.
	* mlibc/libc-gcc.c (isxdigit, _atoi): New function.
	  (atoi): Use it.
	* mlibc/libc-mes.c (isxdigit, _atoi): New function.
	  (atoi): Use it.
	* scaffold/tests/7j-strtoull.c (test): Test it.
	* make.scm (add-scaffold-test): Build it.

2017-08-12  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: snprintf.
	* mlibc/include/stdarg.h (vsprintf): Declare.
	* mlibc/libc-gcc.c (vsprintf): New function.
	  (sprintf): Use it.
	* mlibc/libc-mes+tcc.c (snprintf): Implement.
	* mlibc/libc-mes.c (vsprintf): New function
	  (sprintf): Use it.

2017-08-10  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: struct.struct.
	* module/language/c99/compiler.mes (field:name):
	  (field:pointer):
	  (field:size):
	  (field:type):
	  (field-field):
	  (field-offset):
	  (struct-field): Support struct.struct.
	* scaffold/tests/7i-struct-struct.c: Test it.
	* make.scm (add-scaffold-test): Build it.

	mescc: Fix compile warnings.
	* mlibc/include/stdio.h (fdputs): Declare.
	* mlibc/libc-gcc.c (malloc):
	  (memcpy): Fix compile warning.

	mescc: Tinycc support: --*p, ++*p.
	* module/language/c99/compiler.mes (expr->accu): Remove specific --/++.
	  (expr->accu*): Support p, *p.
	* scaffold/tests/76-pointer-arithmetic.c (test): Test it.

2017-08-08  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: word array assignment.
	* stage0/x86.M1 (movzwl_(%eax),%eax): New define.
	* module/mes/as-i386.mes (i386:word-mem->accu): New function.
	* module/mes/as-i386.scm: Export it.
	* module/language/c99/compiler.mes (expr->accu): word array assignment.
	  (expr->accu*): word array assignment.
	* scaffold/tests/7a-struct-char-array.c (test): Test it.

2017-08-07  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: struct char array assignment.
	* module/language/c99/compiler.mes (expr->accu): struct char array assignment.
	* scaffold/tests/7a-struct-char-array.c (test): Test it.

2017-08-06  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: struct assign by value.
	* module/language/c99/compiler.mes (base->ident): Remove.
	  (accu->ident): Use them to support assign of size >4 by value.
	* scaffold/tests/7h-struct-assign.c: Test it.
	* make.scm (add-scaffold-test): Build it.
	* module/mes/as-i386.mes (i386:base->local): Remove.
	  (i386:accu*n->local):
	  (i386:accu*n->label): New functions.
	* module/mes/as-i386.scm: Export them.
	* stage0/x86.M1: (mov____%ebx,0x32):
	  (mov____%ebx,0x32(%ebp)):
	  (mov____%ebx,0x8(%ebp)):
	  (mov____%ebx,0x8(%edx)):
	  (mov____%ecx,0x32(%ebp)):
	  (mov____%ecx,0x8(%ebp)):
	  (mov____0x32(%eax),%ebx):
	  (mov____0x32(%eax),%ecx):
	  (mov____0x8(%eax),%ebx): New define.

	mescc: Tinycc support: eputc.
	* mlibc/include/stdio.h (eputc): Declare.
	* mlibc/libc-gcc.c (eputc):
	* mlibc/libc-mes.c (eputc): New function.

	mescc: Move simple main to scaffold.
	* scaffold/main.c (main): Move from doc/examples/main.c
	* make.scm: Build it.
	* README: Update.
	* guile/mescc.scm (main):
	* scripts/mescc.mes (main): Remove fallback doc/examples/main.c

	mescc: Tinycc support: byte and word struct fields.
	* stage0/x86.M1 (mov____%al,0x8(%edx)):
	  (mov____%ax,(%edx)):
	  (mov____%ax,0x32(%edx)):
	  (mov____%ax,0x8(%edx)):
	  (movzbl_0x32(%eax),%eax):
	  (movzbl_0x8(%eax),%eax):
	  (movzwl_0x32(%eax),%eax):
	  (movzwl_0x8(%eax),%eax): New define.
	* module/mes/as-i386.mes (i386:word-accu->base-mem):
	  (i386:byte-accu->base-mem+n):
	  (i386:word-accu->base-mem+n):
	  (i386:byte-mem+n->accu):
	  (i386:word-mem+n->accu): New function.
	* module/mes/as-i386.scm: Export them.
	* module/language/c99/compiler.mes (struct-field): Use actual size for
	  simple types (WAS: 4).
	  (decl->info):
	  (expr->accu): Respect byte and word struct field sizes.
	* scaffold/tests/7g-struct-byte-word-field.c: Test it.
	* make.scm (add-scaffold-test): Build it.

	mescc: Tinycc support: eputs as function for gcc.
	* mlibc/libc-gcc.c (eputs)[POSIX]: New function.
	* mlibc/include/stdio.h (eputs)[POSIX]: Remove define.

2017-08-05  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: fixes for foo.bar[baz].
	* module/language/c99/compiler.mes (expr->accu, expr->accu*): fixes for foo.bar[baz].
	* scaffold/tests/7c-dynarray.c: Test it.

	mescc: Tinycc support: fixes for foo->bar[baz].
	* module/language/c99/compiler.mes (expr->accu, expr->accu*): fixes
	  for foo->bar[baz].
	  (expr->pointer): Support i-sel.
	  (p-expr->type): Support add, sub, de-ref, ref-to.
	* scaffold/tests/7f-struct-pointer-arithmetic.c: Test it.
	* make.scm (add-scaffold-test): Build it.

	mescc: Tinycc support: foo.bar[baz], foo->bar[baz] for typedef'd struct bar.
	* module/language/c99/compiler.mes (expr->accu): foo.bar[baz],
	  foo->bar[baz] for typedef'd struct bar.
	* scaffold/tests/7c-dynarray.c: Test it.

2017-08-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	mescc: Tinycc support: foo[index]->bar for array bar.
	* module/language/c99/compiler.mes (expr->accu*): foo[index]->bar for array bar.
	* scaffold/tests/7e-struct-array-access.c: Test it.
	* make.scm (add-scaffold-test): Build it.

2017-08-04  Jan Nieuwenhuizen  <janneke@gnu.org>

	Revert "mescc: Tinycc support: workaround for nyacc "\0" bug."
